1 REMark &&SSBGEN
10 :
12 REMark '' VER 231125_0700
14 :
16 QLC_INIT
18 :
20 KCtrlA = 1
22 KDown = 216
24 KUp = 208
26 KShiftDown = 220
28 KTab = 9
30 KShiftF5 = 250
32 KSpace = 32
34 KShiftUp = 212
36 KEnter = 10
38 KShiftEnter = 254
40 KBackSpace = 194
42 KCtrlUp = 210
44 KCtrlDown = 218
46 KCtrlD = 4
48 KCtrlR = 18
50 KF1 = 232
52 KF2 = 236
54 KF3 = 240
56 KF4 = 244
58 KF5 = 248
60 KF6ShiftF1 = 234
62 KF7ShiftF2 = 238
64 KF8ShiftF3 = 242
66 KF9ShiftF4 = 246
68 KF10ShiftF5 = 250
70 KPlus = 43
72 KMinus = 45
74 KEqual = 61
76 KUnderscore = 95
78 KCtrlI = 92
80 KCtrlW = 23
82 KCtrlX = 24
84 KCtrl1 = 145
86 KCtrl2 = 146
88 KHome = 193
90 KEnd = 201
92 KPageUp = 212
94 KPageDown = 220
96 :
98 :
100 :
102 :
104 REMark ''******************************************
106 REMark ''*        QLX   C O M M A N D E R         *
108 REMark ''*                                        *
110 REMark ''*              version 2.1               *
112 REMark ''*          code date 2023.11.13          *
114 REMark ''*                                        *
116 REMark ''*              Andrei Tenu               *
118 REMark ''*              Martyn Hill               *
120 REMark ''*                7alken                  *
122 REMark ''******************************************
124 :
126 :
128 REMark ''*** QLiberator Directives...
130 REMark ''$$stak=5120
132 :
134 :
136 REMark ''*** TURBO Directives...
138 REMark '' - also comment line 1370! And modify line 3010
140 REMark ''TURBO_locstr "R"
142 REMark ''TURBO_ref
144 REMark ''TURBO_windo 2
146 REMark ''TURBO_optim "B"
148 REMark ''TURBO_model 1
150 REMark ''TURBO_struct "S"
152 REMark ''TURBO_diags "I"
154 REMark ''TURBO_list "YES"
156 REMark ''TURBO_sound "YES"
158 REMark ''TURBO_objdat 64
160 REMark ''TURBO_buffersz 16
162 REMark ''TURBO_objstk 512
164 REMark ''TURBO_taskn "QLC v2.0"
166 REMark ''TURBO_objfil "win1_QLCommander_QLC_exe"
168 REMark ''TURBO_repfil "win1_QLCommander_QLCv20_rpt"
170 :
172 :
174 WHEN ERRor
176     REMark ''CloseProgram
178     PAPER# 1, 7
180     INK# 1, 2
182     PAPER# 0, 0
184     INK# 0, 4
186     CLS# 0
188     PRINT# 1, "Error at line: "; ERLIN
190     REPORT
192     STOP
194 END WHEN
196 :
198 REMark ''mode 4: paper#0,0:paper#1,0:paper#2,0:border#1,0:cls#1
200 REMark ''window#1,488,220,12,0
202 :
204 REMark ''----------------------------------------------------------
206 REMark ''recompilation QLXC from ssb source
208 DEFine PROCedure c
210     LOCal ssb_fn$, test_fn$
212 :
214     ssb_fn$ = "dos1_QLC_qlxc_ssb"
216     bas_fn$ = ssb_fn$(1 TO LEN(ssb_fn$) - 4) & "_bas"
218 :
220     PRINT #0, "Compiling SSB to BAS ..."
222     _err = CompileSsb2Bas(ssb_fn$, bas_fn$)
224 :
226     PAUSE 10
228 :
230     TYPE_IN "l" & CHR$(10) : REMark ''reload bas
232     AttachBasFileShell bas_fn$
234     REMark ''type_in "s" & chr$(10) ''save
236     TYPE_IN "r" & CHR$(10) : REMark ''run
238 END DEFine
240 :
242 xc
244 :
246 REMark ''----------------------------------------------------------
248 DEFine PROCedure xc
250 :
252     qlcVer$ = "2.1"
254     REMark ''Make sure that guardian window covers all screen,
256     REMark ''in all resolutions
258     IF VER$="HBA_xx"  : REMark ''FIXME mixworx
260         maxWinWid = SCR_XLIM
262         maxWinHgt = SCR_YLIM
264     ELSE
266         maxWinWid = 512
268         maxWinHgt = 256
270         REMark ''make sure we are in monitor mode 4,
272         REMark ''otherwise it will crash
274         WMON
276         MODE 4
278         PAPER# 0, 0
280         PAPER# 1, 0
282         BORDER# 1, 0
284         CLS# 1
286         CLS# 0
288     END IF
290     REMark ''comment next line if compiled with Turbo !
292     PAPER# 0, 0
294     BORDER# 0, 0
296     PAPER# 1, 0
298     BORDER# 1, 0
300     PAPER# 2, 0
302     BORDER# 2, 0
304     CLS# 0
306     CLS# 1
308     CLS# 2
310     WINDOW# 0, maxWinWid, maxWinHgt, 0, 0
312     OUTLN# 0, maxWinWid, maxWinHgt, 0, 0, 0, 0, 0
314 :
316 :
318     dbginit
320     readConfig
322     InitialiseVars
324     OpenWindows
326     DrawWindows 1
328     MainLoop
330     CloseProgram
332 :
334     STOP
336 END DEFine
338 :
340 REMark ''----------------------------------------------------------
342 DEFine PROCedure StopWithError(errorMessage$)
344 :
346     BEEP 1390 * 2, 20
348     REMark ''cls #0
350     PRINT #0, errorMessage$
352     PAUSE 50 * 2
354     CloseProgram
356     STOP
358 END DEFine
360 :
362 :
364 REMark ''-----------------------------------------------------------
366 DEFine PROCedure CloseProgram
368     LOCal ch
370 :
372     FOR ch = 3 TO 9 : CLOSE# ch : END FOR ch
374 :
376     IF headBuff > 0 THEN RECHP(headBuff)
378     IF titleFountBase > 0 THEN RECHP titleFountBase
380     IF mainFountBase > 0 THEN RECHP mainFountBase
382     IF comFountBase > 0 THEN RECHP comFountBase
384 :
386     DATA_USE initialDATAD$
388 :
390     WINDOW# 0, maxWinWid, maxWinHgt, 0, 0
392     PAPER# 0, 0
394     INK# 0, White
396     CLS# 0
398 :
400     WINDOW# 0, 512, 50, 0, 206
402     BORDER# 0, 1, 1, 7, 0
404     CLS# 0
406 :
408     WINDOW# 1, 256, 202, 256, 0
410     BORDER# 1, 1, 1, 7, 0
412     PAPER# 1, 7
414     INK# 1, 0
416     CLS# 1
418 :
420     WINDOW# 2, 256, 202, 0, 0
422     BORDER# 2, 1, 1, 7, 0
424     PAPER# 2, 2
426     INK# 2, 7
428     CLS# 2
430 :
432 END DEFine
434 :
436 :
438 REMark ''-----------------------------------------------------------
440 DEFine PROCedure OpenWindows
442     LOCal ch, titleFountFN$(36), titleFountLen
444     LOCal mainFountFN$(36), mainFountLen
446     LOCal comFountFN$(36), comFountLen
448 :
450     stdFountWid = 6
452 :
454     FOR ch = 3 TO 9 : OPEN# ch, con : END FOR ch
456 :
458     titleFountWid = stdFountWid
460     titleFountBase = 0
462     titleFountFN$ = ConfigDrv$ & "bold8_fnt"
464 :
466     IF FTEST(titleFountFN$) = 0
468         REMark ''use _+ as #, __+ as \ ???
470         titleFountLen = FLEN(\titleFountFN$)
472         IF titleFountLen > 0
474             titleFountBase = ALCHP(titleFountLen)
476             LBYTES titleFountFN$, titleFountBase
478             titleFountWid = 8
480             CHAR_USE# titleWin, titleFountBase, 0
482             CSIZE# titleWin,1,0
484             CHAR_INC# titleWin, titleFountWid, 10
486         END IF
488     END IF
490 :
492     mainFountWid = stdFountWid
494     mainFountBase = 0
496     mainFountFN$ = ConfigDrv$ & "5Pixel_fnt"
498     IF FTEST(mainFountFN$) = 0
500         REMark ''use _+ as #, __+ as \ ???
502         mainFountLen = FLEN(\mainFountFN$)
504         IF mainFountLen > 0
506             mainFountBase = ALCHP(mainFountLen)
508             LBYTES mainFountFN$, mainFountBase
510         END IF
512     END IF
514 :
516     SELect ON ClassicFont
518       = 0:
520           IF mainFountBase > 0
522               mainFountWid = 5
524               mainFountHeight = 10
526               CHAR_USE# leftPanelWin, mainFountBase, 0
528               CHAR_INC# leftPanelWin, mainFountWid, 10
530               CHAR_USE# rightPanelWin, mainFountBase, 0
532               CHAR_INC# rightPanelWin, mainFountWid, 10
534           ELSE
536               mainFountWid = 6
538               mainFountHeight = 10
540               comFountWid = stdFountWid
542           END IF
544 :
546       = 1:
548           CSIZE# leftPanelWin, 0, 0
550           CSIZE# rightPanelWin, 0, 0
552           mainFountWid = 6
554           mainFountHeight = 10
556           comFountWid = stdFountWid
558 :
560       = 2:
562           mainFountWid = 8
564           mainFountHeight = 20
566           comFountWid = 8
568           titleFountWid = 16
570           CSIZE# leftPanelWin, 1, 1
572           CSIZE# rightPanelWin, 1, 1
574           CSIZE# titleWin, 3, 1
576           CSIZE# 4, 1, 1
578           CSIZE# 5, 1, 1
580           CSIZE# 6, 1, 1
582           CSIZE# 9, 1, 1
584 :
586       = 3:
588           mainFountWid = 12
590           mainFountHeight = 20
592           titleFountWid = 16
594           comFountWid = 8
596           CSIZE# leftPanelWin, 2, 1
598           CSIZE# rightPanelWin, 2, 1
600           CSIZE# titleWin, 3, 1
602           CSIZE# 4, 2, 1
604           CSIZE# 5, 2, 1
606           CSIZE# 6, 2, 1
608           CSIZE# 9, 1, 1
610     END SELect
612 :
614     REMark ''comFountWid=stdFountWid
616     comFountBase = 0
618     comFountFN$ = ConfigDrv$ & "qlc_fnt"
620 :
622     IF FTEST(comFountFN$) = 0
624         REMark ''use _+ as #, __+ as \ ???
626         comFountLen = FLEN(\comFountFN$)
628         IF comFountLen > 0
630             comFountBase = ALCHP(comFountLen)
632             LBYTES comFountFN$, comFountBase
634             CHAR_USE# comWin, comFountBase, 0
636         END IF
638     END IF
640 :
642 END DEFine
644 :
646 :
648 REMark ''-----------------------------------------------------------
650 REMark ''reload = 1 we reload the file lists and draw the windows;
652 REMark ''reload==0 we do not reload the file lists,
654 REMark ''just redraw the windows
656 DEFine PROCedure DrawWindows(reload)
658     LOCal left
660     LOCal ch, w, h, x, y, c, px, py
662 :
664     IF (linelen * mainFountWid + 2) > (maxWinWid DIV 2)
666         linelen = ((maxWinWid DIV 2) - 4) DIV mainFountWid
668     END IF
670     panelWinWid = linelen * mainFountWid + 2
672     comWinWid = 2 * panelWinWid
674     left = (maxWinWid - 2 * panelWinWid) DIV 2
676 :
678     REMark ''title line
680     ch = 3
682     x = 2 * panelWinWid
684     y = mainFountHeight + 2
686     px = left
688     py = 5
690     WINDOW# ch, x, y, px, py
692     BORDER# ch, 1, TitleBorder
694     PAPER# ch, TitleBorder, TitleBk, 1
696     CLS# ch
698 :
700     PAPER# ch, 0
702     INK# ch, 2
704     IF ClassicFont >= 2
706         CSIZE# titleWin, 3, 1
708     ELSE
710         CSIZE# titleWin, 1, 0
712     END IF
714     CHAR_INC# titleWin, titleFountWid, 10
716 :
718 :
720     REMark ''FIXME long lines, use vars here !!!!!!
722     REMark ''LONGLINE
724     ch = 3
726     w = titleFountWid * 14
728     h = mainFountHeight
730     x = (2 * panelWinWid - 4 - 14 * titleFountWid) DIV 2
732     y = 0
734     c = 0
736     BLOCK# ch, w, h, x, y, c
738     x = (2 * panelWinWid - 4 - 14 * titleFountWid) DIV 2
740     y = 0
742     CURSOR# ch, x, y
744     PRINT# ch, " QLX COMMANDER "
746 :
748     REMark ''Drive line
750     REMark ''LONGLINE
752     ch = 4
754     x = 2 * panelWinWid
756     y = mainFountHeight + 2
758     px = left
760     py = mainFountHeight + 7
762     WINDOW# ch, x, y, px, py
764     PAPER# ch, brd
766     INK# ch, 0
768     BORDER# ch, 1, brd
770     CLS# ch
772 :
774     AT# ch, 0, 0
776     INK# ch, 2
778     PRINT# ch, "D"
780     AT# ch, 0, 1
782     INK# ch, 0
784     PRINT# ch, "ir"
786     CURSOR# ch, panelWinWid, 0
788     PRINT# ch, "Di"
790     INK# ch, 2
792     CURSOR# ch, panelWinWid + mainFountWid * 2, 0
794     PRINT# ch, "r"
796 :
798     REMark ''left dir
800     REMark ''LONGLINE
802     ch = 5
804     x = panelWinWid - 4 * mainFountWid
806     y = mainFountHeight
808     px = left + 4 * mainFountWid - 2
810     py = mainFountHeight + 8
812     WINDOW# ch, x, y, px, py
814     PAPER# ch, White
816     INK# ch, 0
818     BORDER# ch, 0
820     CLS# ch
822     PRINT# ch, leftDir$
824 :
826     REMark ''right dir
828     REMark ''LONGLINE
830     ch = 6
832     x = panelWinWid - 4 * mainFountWid
834     y = mainFountHeight
836     px = left + panelWinWid + 4 * mainFountWid - 2
838     py = mainFountHeight + 8
840     WINDOW# ch, x, y, px, py
842     PAPER# ch, White
844     INK# ch, 0
846     BORDER# ch, 0
848     CLS# ch
850     PRINT# ch, rightDir$
852 :
854     panelWinHeight = rowno * mainFountHeight + 3
856     IF panelWinHeight + 3 * mainFountHeight + 19 > maxWinHgt
858         REMark ''LONGLINE
860         rowno = (maxWinHgt - 3 * mainFountHeight - 22) DIV mainFountHeight
862         panelWinHeight = rowno * mainFountHeight + 3
864     END IF
866 :
868     REMark ''left file panel
870     REMark ''LONGLINE
872     ch = 7
874     x = panelWinWid
876     y = panelWinHeight
878     px = left
880     py = 2 * mainFountHeight + 9
882     WINDOW# ch, x, y, px, py
884     PAPER# ch, ppr
886     INK# ch, ik
888     BORDER# ch, 1, brd
890     CLS# ch
892 :
894     REMark ''Right file panel
896     REMark ''LONGLINE
898     ch = 8
900     x = panelWinWid
902     y = panelWinHeight
904     px = panelWinWid + left
906     py = 2 * mainFountHeight + 9
908     WINDOW# ch, x, y, px, py
910     PAPER# ch, ppr
912     INK# ch, ik
914     BORDER# ch, 1, brd
916     CLS# ch
918 :
920     REMark ''Commands line
922     REMark ''LONGLINE
924     ch = 9
926     x = 2 * panelWinWid
928     y = mainFountHeight + 2
930     px = left
932     py = panelWinHeight + 3 * mainFountHeight + 7
934     WINDOW# ch, x, y, px, py
936     PAPER# ch, brd
938     INK# ch, White
940     BORDER# ch, 1, brd
942     CLS# ch
944 :
946     WriteCommands comWin
948 :
950     crtPanel = leftPanelWin
952     IF reload = 1
954         LShowLeftDir
956         LShowRightDir
958     ELSE
960         ListFiles LeftFiles$, LStartPos, LIndex, 7
962         ListFiles RightFiles$, RStartPos, RIndex, 8
964     END IF
966 END DEFine
968 :
970 :
972 REMark ''-----------------------------------------------------------
974 DEFine PROCedure readConfig
976     LOCal a$(42), ch
978 :
980     ConfigDrv$ = OPTION_CMD$ : REMark ''CMD$
982 :
984     IF ConfigDrv$ = "" THEN ConfigDrv$ = "dos1_qlc_"
986 :
988     a$ = ConfigDrv$ & "qlc20_cfg"
990 :
992     ch = FOP_IN(a$)
994 :
996     IF ch > 0
998         INPUT# ch, MaxFiles
1000         INPUT# ch, TempDir$
1002         INPUT# ch, leftDir$
1004         INPUT# ch, rightDir$
1006         INPUT# ch, Qubide
1008         INPUT# ch, ClassicFont
1010         INPUT# ch, linelen
1012         INPUT# ch, rowno
1014         INPUT# ch, Xchangepath$
1016         INPUT# ch, Xchangeprog$
1018         INPUT# ch, EditPath$
1020         INPUT# ch, Editprog$
1022         INPUT# ch, QLColors
1024         CLOSE# ch
1026     ELSE
1028         CLS
1030         PRINT "Config file not found - using default values ! "
1032         MaxFiles = 256
1034         TempDir$ = "win1_temp_"
1036         leftDir$ = "win1_"
1038         rightDir$ = "win1_"
1040         Qubide = 0
1042         ClassicFont = 1
1044         linelen = 40
1046         rowno = 20
1048         Xchangepath$ = ""
1050         Xchangeprog$ = ""
1052         EditPath$ = ""
1054         Editprog$ = ""
1056         QLColors = 1
1058         PAUSE 100
1060         CLS
1062     END IF
1064 :
1066     IF RMODE <= 8 OR QLColors = 1
1068         IF VER$ = "HBA" AND RMODE > 4
1070             COLOUR_QL
1072             SetPalletteQL
1074         END IF
1076         ppr = 0
1078         brd = 4
1080         ik = 7
1082         strp = 7
1084         White = 7
1086         Green = 4
1088         PPR9a = 2
1090         ppr9b = 0
1092         TitleBorder = 4
1094         TitleBk = 0
1096     ELSE
1098         COLOUR_PAL
1100         ppr = 4
1102         brd = 13
1104         ik = 1
1106         strp = 13
1108         White = 1
1110         Green = 3
1112         PPR9a = 72
1114         ppr9b = 76
1116         TitleBorder = 13
1118         TitleBk = 4
1120     END IF
1122 :
1124     IF maxWinHgt = 256 AND ClassicFont > 1
1126         ClassicFont = 1
1128     END IF
1130 END DEFine
1132 :
1134 :
1136 REMark ''------------------------------------------------------------
1138 DEFine PROCedure InitialiseVars
1140     titleWin = 3
1142     leftPanelWin = 7
1144     rightPanelWin = 8
1146     comWin = 9
1148     LSizedir = 0
1150     LSizeFile = 0
1152     crtPanel = leftPanelWin
1154     RSizedir = 0
1156     RSizeFile = 0
1158 :
1160     maxFNLen = 36
1162 :
1164     _fLen = maxFNLen + 3
1166     _fTyp = maxFNLen + 7
1168     _fDat = maxFNLen + 9
1170     _fPar = maxFNLen + 13
1172     _fFlg = maxFNLen + 15
1174     _fMax = maxFNLen + 16
1176 :
1178     _dPar = maxFNLen + 3
1180     _dNxt = maxFNLen + 5
1182     _dChd = maxFNLen + 7
1184     _dFlg = maxFNLen + 9
1186     _dMax = maxFNLen + 10
1188 :
1190     DIM cmdText$(9, 9) : REMark ''Used by WriteCommands
1192     cmdText$(1) = CHR$(1) & " Info"
1194     cmdText$(2) = CHR$(2) & " Comp"
1196     cmdText$(3) = CHR$(3) & " View"
1198     cmdText$(4) = CHR$(4) & " Edit"
1200     cmdText$(5) = CHR$(5) & " Copy"
1202     cmdText$(6) = CHR$(6) & " Rename"
1204     cmdText$(7) = CHR$(7) & " MkDir"
1206     cmdText$(8) = CHR$(8) & " Delete"
1208     cmdText$(9) = CHR$(9) & " Exit"
1210 :
1212     initialDATAD$ = DATAD$
1214 :
1216     headSz = 64
1218     headBuff = ALCHP(headSz)
1220     IF headBuff < 0
1222         REMark ''LONGLINE
1224         StopWithError("Cannot allocate memory for File-header Buffer.")
1226     END IF
1228 :
1230 END DEFine
1232 :
1234 :
1236 REMark ''-----------------------------------------------------------
1238 DEFine PROCedure LShowLeftDir
1240     LOCal i
1242 :
1244     REMark ''dim LeftFiles$(MaxFiles,2,36)
1246     DIM LeftFiles$(MaxFiles, _fMax)
1248 :
1250     LoadDir leftDir$, LeftFiles$, 7, LSizedir, LSizeFile
1252 :
1254     IF LEN(leftDir$) = 5
1256         LStartPos = 1
1258     ELSE
1260         LStartPos = 0
1262     END IF
1264     LIndex = LStartPos
1266     LMinPos = LStartPos
1268     ListFiles LeftFiles$, LStartPos, LIndex, 7
1270 END DEFine
1272 :
1274 :
1276 REMark ''-----------------------------------------------------------
1278 DEFine PROCedure LShowRightDir
1280     LOCal i
1282 :
1284     DIM RightFiles$(MaxFiles, _fMax)
1286 :
1288     RSizedir = 0
1290     RSizeFile = 0
1292     LoadDir rightDir$, RightFiles$, 8, RSizedir, RSizeFile
1294     IF LEN(rightDir$) = 5
1296         RStartPos = 1
1298     ELSE
1300         RStartPos = 0
1302     END IF
1304     RIndex = RStartPos
1306     RMinPos = RStartPos
1308     ListFiles RightFiles$, RStartPos, RIndex, 8
1310 END DEFine
1312 :
1314 :
1316 REMark ''-----------------------------------------------------------
1318 REMark ''reference FileList$(0,0,0)
1320 REFERENCE FileList$(0, 0)
1322 DEFine PROCedure ListFiles(FileList$, StartPos, Index, ch)
1324     LOCal a$(linelen), i, size, EndPos
1326     LOCal nochars, x, DFlen1, DFLen2
1328 :
1330     IF ch = 7
1332         size = LSizedir + LSizeFile
1334     ELSE
1336         size = RSizedir + RSizeFile
1338     END IF
1340     EndPos = StartPos + rowno - 1
1342     IF EndPos > size THEN EndPos = size
1344 :
1346     CLS# ch
1348     FOR i = StartPos TO EndPos
1350         a$ = GetFNam$(FileList$, i)
1352         DFlen1 = LEN(a$)
1354         DFLen2 = LEN(GetFLen(FileList$, i))
1356         IF GetFFlg(FileList$, i) MOD 2 = 1
1358             x = 3
1360             IF DFlen1 > linelen - x
1362                 a$ = a$(TO linelen - x - 2)
1364                 a$ = a$ & ".."
1366             END IF
1368             a$ = a$ & " ->"
1370             a$ = a$ & FILL$(" ", linelen - LEN(a$) - 1)
1372         ELSE
1374             x = 9
1376             IF DFlen1 > linelen - x
1378                 a$ = a$(TO linelen - x - 2)
1380                 a$ = a$ & ".."
1382             END IF
1384             REMark ''LONGLINE
1386             a$ = a$ & FILL$(" ", linelen - LEN(a$) - DFLen2 - 1)
1388             a$ = a$ & GetFLen(FileList$,i)
1390         END IF
1392 :
1394         INK# ch, ik
1396         IF i = Index
1398             IF crtPanel = ch
1400                 STRIP# ch, strp
1402                 IF GetFFlg(FileList$, i) > 1
1404                     INK# ch, 2
1406                 ELSE
1408                     INK# ch, ppr
1410                 END IF
1412                 PRINT# ch, a$
1414                 STRIP# ch, ppr
1416             ELSE
1418                 PRINT# ch, a$
1420             END IF
1422         ELSE
1424             IF GetFFlg(FileList$, i) > 1
1426                 INK# ch, 2
1428             ELSE
1430                 INK# ch, ik
1432             END IF
1434             PRINT# ch, a$
1436         END IF
1438     END FOR i
1440 END DEFine
1442 :
1444 :
1446 REMark ''-----------------------------------------------------------
1448 DEFine PROCedure MainLoop
1450     LOCal a$, x, y$
1452 :
1454     REPeat loop
1456         a$ = INKEY$(-1)
1458         x = CODE(a$)
1460         dbg(x)
1462 :
1464         SELect ON x
1466 :
1468           = KCtrlW:
1470               WMOV
1472 :
1474           = KCtrlA:
1476                 REMark ''LONGLINE
1478               MessageWnd 216, 60, 3, "        QL COMMANDER v" & qlcVer$ & CHR$(10) & " Andrei Tenu & Martyn Hill - 2019" & CHR$(10) & "    GNU General Public License"
1480 :
1482           = KDown:
1484               IF crtPanel = 7
1486                   REMark ''LONGLINE
1488                   MoveDown LeftFiles$, LMinPos, LIndex, LStartPos, LSizeFile, LSizedir
1490               ELSE
1492                   REMark ''LONGLINE
1494                   MoveDown RightFiles$, RMinPos, RIndex, RStartPos, RSizeFile, RSizedir
1496               END IF
1498 :
1500           = KUp:
1502               IF crtPanel = 7
1504                   REMark ''LONGLINE
1506                   MoveUp LeftFiles$, LMinPos, LIndex, LStartPos, LSizeFile, LSizedir
1508               ELSE
1510                   REMark ''LONGLINE
1512                   MoveUp RightFiles$, RMinPos, RIndex, RStartPos, RSizeFile, RSizedir
1514               END IF
1516 :
1518           = KPageDown, KShiftDown:
1520               IF crtPanel = 7
1522                   MovePageDown LeftFiles$, LStartPos, LIndex, 7
1524               ELSE
1526                   MovePageDown RightFiles$, RStartPos, RIndex, 8
1528               END IF
1530 :
1532           = KTab:
1534               ChangePanel
1536 :
1538           = KCtrlX, KF10ShiftF5:
1540               RETurn
1542 :
1544           = KSpace:
1546               SelectFile
1548 :
1550           = KPageUp, KShiftUp:
1552               IF crtPanel = 7
1554                   MovePageUp LeftFiles$, LStartPos, LIndex, 7
1556               ELSE
1558                   MovePageUp RightFiles$, RStartPos, RIndex, 8
1560               END IF
1562 :
1564           = KEnter:
1566               OnEnter
1568 :
1570           = KShiftEnter:
1572               LRUNBasic
1574 :
1576           = KBackSpace
1578               IF crtPanel = 7
1580                   MoveTop LeftFiles$, LStartPos, LIndex, 7
1582                   IF GetFNam$(LeftFiles$, LIndex) = ".."
1584                       OnEnter
1586                   ELSE
1588                       BEEP 1390, 20
1590                   END IF
1592               ELSE
1594                   MoveTop RightFiles$, RStartPos, RIndex, 8
1596                   IF GetFNam$(RightFiles$,RIndex) = ".."
1598                       OnEnter
1600                   ELSE
1602                       BEEP 1390, 20
1604                   END IF
1606               END IF
1608 :
1610           = KHome, KCtrlUp:
1612               IF crtPanel = 7
1614                   MoveTop LeftFiles$, LStartPos, LIndex, 7
1616               ELSE
1618                   MoveTop RightFiles$, RStartPos, RIndex, 8
1620               END IF
1622 :
1624           = KEnd, KCtrlDown:
1626               IF crtPanel = 7
1628                   MoveLast LeftFiles$, LStartPos, LIndex, 7
1630               ELSE
1632                   MoveLast RightFiles$, RStartPos, RIndex, 8
1634               END IF
1636 :
1638           = KCtrl1, KCtrlD:
1640               InputDir 5
1642 :
1644           = KCtrl2, KCtrlR:
1646               InputDir 6
1648 :
1650           = KF3:
1652               ViewFile
1654 :
1656           = KF5:
1658               CopyFiles
1660 :
1662           = KF4:
1664               DoEdit
1666 :
1668           = KF6ShiftF1:
1670               RenameFile
1672 :
1674           = KF8ShiftF3:
1676               DeleteFiles
1678 :
1680           = KF1:
1682               ShowInfo
1684 :
1686           = KF7ShiftF2:
1688               CreateDir
1690 :
1692           REMark ''Find next matching File/Dir starting with a$
1694           =65  TO  90: JumpTo x, 1
1696           =160 TO 171: JumpTo x, 1
1698           =97  TO 122: JumpTo x, 2
1700           =128 TO 139: JumpTo x, 2
1702           =48  TO  57: JumpTo x, 0
1704 :
1706           = KPlus, KEqual:
1708               SelectAll
1710 :
1712           = KMinus, KUnderscore:
1714               UnSelectAll
1716 :
1718           = KF9ShiftF4:
1720               DrawWindows 0
1722 :
1724           = KF8ShiftF3:
1726               CompareDirs
1728 :
1730           = KCtrlI:
1732               InvertSelection
1734         END SELect
1736     END REPeat loop
1738 END DEFine
1740 :
1742 :
1744 REMark ''-----------------------------------------------------------
1746 REMark ''a = code of char to find
1748 REMark ''what=2 looking for file; =1 looking for dir; =0 looking for dir or file
1750 REMark ''search returns index of item that starts with a$, or first next item if a$ is not found, or last item in list if all existing items start with chars<a$
1752 DEFine FuNction FindFirst(a, what)
1754     LOCal i, istart, iend, FOUND
1756 :
1758     FOUND = 0
1760 :
1762     IF crtPanel = 7
1764 :
1766         IF what < 2
1768             istart = 1
1770         ELSE
1772             istart = LSizedir + 1
1774         END IF
1776 :
1778         IF what = 1
1780             iend = LSizedir
1782         ELSE
1784             iend = LSizedir + LSizeFile
1786         END IF
1788 :
1790         IF istart > iend THEN RETurn LIndex
1792 :
1794         IF what > 0
1796             FOR i = istart TO iend
1798               IF CODE(GetFNam$(LeftFiles$, i)) >= a
1800                   FOUND = 1
1802                   EXIT i
1804               END IF
1806               NEXT i
1808             END FOR i
1810         ELSE
1812             FOR i = LIndex + 1 TO iend
1814                 IF CODE(GetFNam$(LeftFiles$, i)) = a
1816                     FOUND = 1
1818                     EXIT i
1820                 END IF
1822                 NEXT i
1824             END FOR i
1826             IF FOUND = 0
1828                 FOR i = istart TO LIndex
1830                     IF CODE(GetFNam$(LeftFiles$, i)) = a
1832                         FOUND = 1
1834                         EXIT i
1836                     END IF
1838                     NEXT i
1840                 END FOR i
1842             END IF
1844             IF FOUND = 0 THEN i = istart
1846         END IF
1848 :
1850         REMark ''LONGLINE
1852         IF i <= iend THEN RETurn i : ELSE RETurn iend
1854 :
1856     ELSE
1858 :
1860         IF what < 2
1862             istart = 1
1864         ELSE
1866             istart = RSizedir + 1
1868         END IF
1870 :
1872         IF what = 1
1874             iend = RSizedir
1876         ELSE
1878             iend = RSizedir + RSizeFile
1880         END IF
1882 :
1884         IF istart > iend THEN RETurn RIndex
1886 :
1888         IF what > 0
1890             FOR i = istart TO iend
1892                 IF CODE(GetFNam$(RightFiles$, i)) >= a
1894                     EXIT i
1896                 END IF
1898                 NEXT i
1900             END FOR i
1902         ELSE
1904             FOR i = RIndex + 1 TO iend
1906                 IF CODE(GetFNam$(RightFiles$, i)) = a
1908                     FOUND = 1
1910                     EXIT i
1912                 END IF
1914                 NEXT i
1916             END FOR i
1918             IF FOUND = 0
1920                 FOR i = istart TO RIndex
1922                     IF CODE(GetFNam$(RightFiles$, i)) = a
1924                         FOUND = 1
1926                         EXIT i
1928                     END IF
1930                     NEXT i
1932                 END FOR i
1934             END IF
1936             IF FOUND = 0 THEN i = istart
1938         END IF
1940 :
1942         REMark ''LONGLINE
1944         IF i <= iend THEN RETurn i : ELSE RETurn iend
1946 :
1948     END IF
1950 :
1952 END DEFine
1954 :
1956 :
1958 REMark ''-----------------------------------------------------------
1960 DEFine PROCedure JumpTo(a, what)
1962     LOCal x, start
1964 :
1966     IF crtPanel = 7
1968         IF LSizedir + LSizeFile = 0 THEN RETurn
1970     ELSE
1972         IF RSizedir + RSizeFile = 0 THEN RETurn
1974     END IF
1976 :
1978     x = FindFirst(a, what)
1980 :
1982     IF crtPanel = 7
1984         IF x = LIndex THEN RETurn
1986         IF (x >= LStartPos) AND (x < LStartPos + 20)
1988             REMark ''LONGLINE
1990             ShowHideCursor LIndex - LStartPos, LIndex, LeftFiles$, 0
1992             LIndex = x
1994             REMark ''LONGLINE
1996             ShowHideCursor LIndex - LStartPos, LIndex, LeftFiles$, 1
1998         ELSE
2000             LIndex = x
2002             x = x + (LMinPos = 0)
2004             page = x DIV rowno
2006             IF x MOD rowno > 0 THEN page = page + 1
2008             LStartPos = (page - 1) * rowno + LMinPos
2010             ListFiles LeftFiles$, LStartPos, LIndex, 7
2012         END IF
2014     ELSE
2016         IF x = RIndex THEN RETurn
2018         IF x >= RStartPos AND x < RStartPos + rowno
2020             REMark ''LONGLINE
2022             ShowHideCursor RIndex - RStartPos, RIndex, RightFiles$, 0
2024             RIndex = x
2026             REMark ''LONGLINE
2028             ShowHideCursor RIndex - RStartPos, RIndex, RightFiles$, 1
2030         ELSE
2032             RIndex = x
2034             x = x + (RMinPos = 0)
2036             page = x DIV rowno
2038             IF x MOD rowno > 0 THEN page = page + 1
2040             RStartPos = (page - 1) * rowno + RMinPos
2042             ListFiles RightFiles$, RStartPos, RIndex, 8
2044         END IF
2046     END IF
2048 END DEFine
2050 :
2052 :
2054 REMark ''-----------------------------------------------------------
2056 REMark ''String Quick Search & Insert
2058 REMark ''(c)tcat, 2017 Tomas Kral
2060 REMark ''modified by Andrei Tenu 2018
2062 :
2064  REMark ''FileLis$ = name of array to load into
2066  REMark ''no = start index
2068  REMark ''    = 0 if we add a dir to root; 1 if add a dir in a directory; SizeDir+1 if we add a file
2070  REMark ''Quick search returns:
2072  REMark ''0=not found, 1=found, id=position
2074 :
2076 REMark ''reference FileList$(0,0,0),id
2078 REFERENCE FileList$(0, 0), id
2080 DEFine FuNction FIND(str$, id, FileList$, no, size)
2082     LOCal top, bot, mid, nextFNam$(maxFNLen)
2084 :
2086     top = no
2088     bot = size
2090 :
2092     REPeat find_loop
2094         mid = (bot + top) DIV 2
2096         nextFNam$ = GetFNam$(FileList$, mid)
2098 :
2100         IF top > bot
2102             id = mid + 1
2104             RETurn 0
2106         ELSE
2108             IF str$ = nextFNam$
2110                 id = mid
2112                 RETurn 1
2114             ELSE
2116                 IF str$ > nextFNam$
2118                     top = mid + 1
2120                 ELSE
2122                     IF str$ < nextFNam$
2124                         bot = mid - 1
2126                     END IF
2128                 END IF
2130             END IF
2132         END IF
2134     END REPeat find_loop
2136 END DEFine
2138 :
2140 :
2142 REMark ''-----------------------------------------------------------
2144  REMark ''Inserts String at position id
2146  REMark ''Returns 2=ok, -1=array full
2148 :
2150 REMark ''reference FileList$(0,0,0),r_SizeDir, r_SizeFile
2152 REFERENCE FileList$(0, 0), r_SizeDir, r_SizeFile
2154 DEFine FuNction Insert(str$, id, FileList$, DoF, r_SizeDir, r_SizeFile, fLength$)
2156     LOCal i, size
2158 :
2160     size = r_SizeDir + r_SizeFile
2162     IF size >= MaxFiles THEN RETurn -1
2164     FOR i = size TO id STEP -1
2166         CopyRec FileList$, i TO FileList$, i+1
2168     END FOR i
2170 :
2172     PutFNam FileList$, id, str$
2174     PutFLen FileList$, id, fLength$
2176     PutFFlg FileList$, id, DoF
2178 :
2180     IF DoF = 1
2182         r_SizeDir = r_SizeDir + 1
2184     ELSE
2186         r_SizeFile = r_SizeFile + 1
2188     END IF
2190 :
2192     RETurn 2
2194 END DEFine
2196 :
2198 :
2200 REMark ''End of String Quick Search & Insert -----------------------
2202 :
2204 :
2206 REMark ''-----------------------------------------------------------
2208 REMark ''reference dev$(0),FileList$(0,0,0),r_SizeDir,r_SizeFile
2210 REFERENCE dev$(0), FileList$(0, 0), r_SizeDir, r_SizeFile
2212 DEFine PROCedure LoadDir(dev$, FileList$, Chan, r_SizeDir, r_SizeFile)
2214     LOCal ch, i, head_start, totrim, flength, file$, ftype
2216     LOCal size2, res, DirOrFile, id, filelen$,k$, no_files
2218 :
2220     CLS# Chan
2222     INK# Chan, 7
2224     PRINT# Chan, "...Loading File List ..."
2226 :
2228     IF dev$(LEN(dev$)) <> "_" THEN dev$ = dev$ & "_"
2230 :
2232     REMark ''LONGLINE
2234     IF Chan = 7 THEN PRINT# 5, dev$ : ELSE PRINT# 6, dev$
2236 :
2238     IF DirExists(dev$) = 0
2240         BEEP 1390, 100
2242         PRINT# Chan, "Cannot open directory " & dev$
2244         RETurn
2246     END IF
2248 :
2250     r_SizeDir = 0
2252     r_SizeFile = 0
2254     totrim = LEN(dev$) - 4
2256     IF totrim <= 0 THEN totrim = 1
2258 :
2260     PutFNam FileList$, 0, ".."
2262     PutFLen FileList$, 0, 0
2264     PutFFlg FileList$, 0, 1
2266 :
2268     head_start = 0
2270     i = 1
2272     ch = FOP_DIR(dev$)
2274     REMark ''use _+ as #, __+ as \ ???
2276     no_files = FLEN(#ch) DIV 64
2278 :
2280     FOR listing = 1 TO no_files
2282         SET_POSITION# ch, head_start + 0
2284         REMark ''use _+ as #, __+ as \ ???
2286         flength = LONGINTEGER(INPUT$(#ch, 4)) - 64
2288         REMark ''use _+ as #, __+ as \ ???
2290         faccess = CODE(INKEY$(#ch))
2292         REMark ''use _+ as #, __+ as \ ???
2294         ftype = CODE(INKEY$(#ch))
2296         IF flength >= 0
2298             SET_POSITION #ch, head_start + 14
2300             REMark ''use _+ as #, __+ as \ ???
2302             file$ = GET$(#ch) : REMark ''FIXME get$ exists ???
2304             IF LEN(file$) > 0
2306                 file$ = file$(totrim TO)
2308                 filelen$ = flength
2310                 SET_POSITION #ch, head_start + 52
2312                 REMark ''use _+ as #, __+ as \ ???
2314                 fdate = LONGINTEGER(INPUT$(#ch, 4))
2316                 IF ftype < 255
2318                     size2 = r_SizeDir + r_SizeFile
2320                     file$ = LOWER$(file$)
2322                     REMark ''LONGLINE
2324                     res = FIND(file$, id, FileList$, r_SizeDir + 1, size2)
2326                     DirOrFile = 0
2328                 ELSE
2330                     file$ = UPPER$(file$)
2332                     REMark ''LONGLINE
2334                     res = FIND(file$, id, FileList$, 1, r_SizeDir)
2336                     DirOrFile = 1
2338                 END IF
2340                 i = i + 1
2342 :
2344                 REMark ''k$="":
2346                 REMark ''if flength>1023 then
2348                 REMark '' flength=INT(flength/1024+.5):k$="K"
2350                 REMark '' if flength>1023 then
2352                 REMark ''   flength=INT(flength/1024+.5):k$="M"
2354                 REMark '' endif
2356                 REMark ''endif
2358                 REMark ''filelen$=flength&k$
2360                 IF res = 0
2362                     REMark ''LONGLINE
2364                    res = Insert(file$, id, FileList$, DirOrFile, r_SizeDir, r_SizeFile, filelen$)
2366                 END IF
2368                 REMark ''FIXME mixworx : or then ??
2370                 IF res = -1 : EXIT listing
2372             END IF
2374         END IF
2376         head_start = head_start + 64
2378     END FOR listing
2380     CLOSE# ch
2382 END DEFine
2384 :
2386 :
2388 REMark ''-----------------------------------------------------------
2390 REMark ''reference FileList$(0,0,0),r_Index,r_StartPos
2392 REFERENCE FileList$(0, 0), r_Index, r_StartPos
2394 DEFine PROCedure MoveDown(FileList$, MinPos, r_Index, r_StartPos, SizeFile, SizeDir)
2396     LOCal size, idx
2398 :
2400     size = SizeFile + SizeDir
2402     IF r_Index > size THEN RETurn
2404     REMark ''LONGLINE
2406     ShowHideCursor r_Index - r_StartPos, r_Index, FileList$, 0
2408     r_Index = r_Index + 1
2410     IF r_Index > size THEN r_Index = size
2412     IF r_Index > r_StartPos + rowno - 1
2414         SCROLL# crtPanel, - mainFountHeight
2416         r_StartPos = r_StartPos + 1
2418     END IF
2420     ShowHideCursor r_Index-r_StartPos, r_Index,  FileList$, 1
2422 END DEFine
2424 :
2426 :
2428 REMark ''-----------------------------------------------------------
2430 REMark ''reference FileList$(0,0,0),r_Index,r_StartPos
2432 REFERENCE FileList$(0, 0), r_Index, r_StartPos
2434 DEFine PROCedure MoveUp(FileList$, MinPos, r_Index, r_StartPos, SizeFile, SizeDir)
2436     LOCal size, idx
2438 :
2440     size = SizeFile + SizeDir
2442     IF r_Index > size  THEN RETurn
2444     REMark ''LONGLINE
2446     ShowHideCursor r_Index - r_StartPos, r_Index, FileList$, 0
2448     r_Index = r_Index - 1
2450     REMark ''FIXME mixworx : or then ??
2452     IF r_Index<MinPos THEN : r_Index = MinPos
2454     IF r_Index < r_StartPos
2456         SCROLL# crtPanel, mainFountHeight
2458         r_StartPos = r_StartPos - 1
2460     END IF
2462     REMark ''LONGLINE
2464     ShowHideCursor r_Index - r_StartPos, r_Index, FileList$, 1
2466 END DEFine
2468 :
2470 :
2472 REMark ''-----------------------------------------------------------
2474 REMark ''reference FileList$(0,0,0)
2476 REFERENCE FileList$(0, 0)
2478 DEFine PROCedure ShowHideCursor(Linepos, Index, FileList$, SoH)
2480     LOCal a$, x, DFlen1, DFLen2
2482 :
2484     a$ = GetFNam$(FileList$, Index)
2486     DFlen1 = LEN(a$)
2488     DFLen2 = LEN(GetFLen(FileList$, Index))
2490 :
2492     IF GetFFlg(FileList$, Index) MOD 2 = 1
2494         x = 3
2496         IF DFlen1 > linelen - x
2498             a$ = a$(TO linelen - x - 2)
2500             a$ = a$ & ".."
2502         END IF
2504         a$ = a$ & " ->"
2506         a$ = a$ & FILL$(" ", linelen - LEN(a$) - 1)
2508     ELSE
2510         x = 9
2512         IF DFlen1 > linelen - x
2514             a$ = a$(TO linelen - x - 2)
2516             a$ = a$ & ".."
2518         END IF
2520         a$ = a$ & FILL$(" ", linelen - LEN(a$) - DFLen2 - 1)
2522         a$ = a$ & GetFLen(FileList$, Index)
2524     END IF
2526     IF SoH = 1
2528         STRIP# crtPanel, strp
2530         INK# crtPanel, 0
2532         IF GetFFlg(FileList$, Index) > 1
2534             INK# crtPanel, 2
2536         ELSE
2538             INK# crtPanel, 0
2540         END IF
2542         AT# crtPanel, Linepos, 0
2544         PRINT# crtPanel, a$;
2546         STRIP# crtPanel, ppr
2548         INK# crtPanel, ik
2550     ELSE
2552         IF GetFFlg(FileList$, Index) > 1
2554             INK# crtPanel, 2
2556         ELSE
2558             INK# crtPanel, ik
2560         END IF
2562         AT# crtPanel, Linepos, 0
2564         PRINT# crtPanel, a$;
2566     END IF
2568 END DEFine
2570 :
2572 :
2574 REMark ''-----------------------------------------------------------
2576 DEFine PROCedure ChangePanel
2578     IF crtPanel = 7
2580         IF LIndex <= LSizedir + LSizeFile
2582             REMark ''LONGLINE
2584             ShowHideCursor LIndex - LStartPos, LIndex, LeftFiles$, 0
2586         END IF
2588         crtPanel = 8
2590         IF RIndex <= RSizedir + RSizeFile
2592             REMark ''LONGLINE
2594             ShowHideCursor RIndex - RStartPos, RIndex, RightFiles$, 1
2596         END IF
2598         BORDER# 8, 1, brd
2600         BORDER# 7, 1, brd, 1 ,3
2602     ELSE
2604         IF RIndex <= RSizedir + RSizeFile
2606             REMark ''LONGLINE
2608             ShowHideCursor RIndex - RStartPos, RIndex, RightFiles$, 0
2610         END IF
2612         crtPanel = 7
2614         IF LIndex <= LSizedir + LSizeFile
2616             REMark ''LONGLINE
2618             ShowHideCursor LIndex - LStartPos, LIndex, LeftFiles$, 1
2620         END IF
2622         BORDER# 7, 1, brd
2624         BORDER# 8, 1, brd, 1, 3
2626     END IF
2628 END DEFine
2630 :
2632 :
2634 REMark ''-----------------------------------------------------------
2636 DEFine PROCedure SelectFile
2638     IF crtPanel = 7
2640         REMark ''LONGLINE
2642         PutFFlg LeftFiles$, LIndex, GetFFlg(LeftFiles$, LIndex) ^^ 2
2644         REMark ''LONGLINE
2646         ShowHideCursor LIndex-LStartPos, LIndex, LeftFiles$, 1
2648     ELSE
2650         REMark ''LONGLINE
2652         PutFFlg RightFiles$, RIndex, GetFFlg(RightFiles$, RIndex) ^^ 2
2654         REMark ''LONGLINE
2656         ShowHideCursor RIndex - RStartPos, RIndex, RightFiles$, 1
2658     END IF
2660 END DEFine
2662 :
2664 :
2666 REMark ''-----------------------------------------------------------
2668 REMark ''reference FileList$(0,0,0),r_StartPos,r_Index
2670 REFERENCE FileList$(0, 0), r_StartPos, r_Index
2672 DEFine PROCedure MovePageDown(FileList$, r_StartPos, r_Index, ch)
2674     LOCal size, x
2676 :
2678     IF ch = 7
2680         size = LSizedir + LSizeFile
2682     ELSE
2684         size = RSizedir + RSizeFile
2686     END IF
2688     IF r_Index > size THEN RETurn
2690     x = r_StartPos + 20
2692     IF x > size THEN RETurn
2694     r_StartPos = x
2696     r_Index = r_StartPos
2698     ListFiles FileList$, r_StartPos, r_Index, ch
2700 END DEFine
2702 :
2704 :
2706 REMark ''-----------------------------------------------------------
2708 REMark ''reference FileList$(0,0,0),r_StartPos,r_Index
2710 REFERENCE FileList$(0, 0), r_StartPos, r_Index
2712 DEFine PROCedure MovePageUp(FileList$, r_StartPos, r_Index, ch)
2714     LOCal top, x, size
2716 :
2718     IF ch = 7
2720         top = LMinPos
2722         size = LSizeFile + LSizedir
2724     ELSE
2726         top = RMinPos
2728         size = RSizeFile + RSizedir
2730     END IF
2732     IF r_Index > size THEN RETurn
2734     x = r_StartPos - 20
2736     IF x < top THEN x = top
2738     r_StartPos = x
2740     r_Index = r_StartPos
2742     ListFiles FileList$, r_StartPos, r_Index, ch
2744 END DEFine
2746 :
2748 :
2750 REMark ''-----------------------------------------------------------
2752 REMark ''reference FileList$(0,0,0)
2754 REFERENCE FileList$(0, 0)
2756 DEFine PROCedure OpenSubDir(FileList$, Index, ch)
2758     LOCal a$, size, d$, x, page
2760 :
2762     IF ch = 7
2764         size = LSizeFile + LSizedir
2766         d$ = leftDir$
2768     ELSE
2770         size = RSizeFile + RSizedir
2772         d$ = rightDir$
2774     END IF
2776     IF Index > size THEN RETurn
2778     IF GetFFlg(FileList$, Index) MOD 2 <> 1 THEN RETurn
2780 :
2782     IF GetFNam$(FileList$, Index) = ".."
2784         a$ = GetParentDir$(ch)
2786         IF LEN(d$) > LEN(a$)
2788             d$ = d$(LEN(a$) + 1 TO)
2790             IF d$(LEN(d$)) = "_" THEN d$ = d$(1 TO LEN(d$) - 1)
2792             IF crtPanel = 7
2794                 DIM LeftFiles$(MaxFiles, _fMax)
2796                 leftDir$ = a$
2798                 LoadDir leftDir$, LeftFiles$, 7, LSizedir, LSizeFile
2800                 IF LEN(leftDir$) = 5
2802                     LMinPos = 1
2804                 ELSE
2806                     LMinPos = 0
2808                 END IF
2810                 IF FIND(d$, id, LeftFiles$, 1, LSizedir) = 1
2812                     LIndex = id
2814                     x = id + (LMinPos = 0)
2816                     page = x DIV rowno
2818                     IF x MOD rowno > 0 THEN page = page + 1
2820                     LStartPos = (page - 1) * rowno + LMinPos
2822                     ListFiles LeftFiles$, LStartPos, LIndex, 7
2824                 ELSE
2826                     d$ = ""
2828                 END IF
2830             ELSE
2832                 DIM RightFiles$(MaxFiles, _fMax)
2834                 rightDir$ = a$
2836                 LoadDir rightDir$, RightFiles$, 8, RSizedir, RSizeFile
2838                 IF LEN(rightDir$) = 5
2840                     RMinPos = 1
2842                 ELSE
2844                     RMinPos = 0
2846                 END IF
2848                 IF FIND(d$, id, RightFiles$, 1, RSizedir) = 1
2850                     RIndex = id
2852                     x = id + (RMinPos = 0)
2854                     page = x DIV rowno
2856                     IF x MOD rowno > 0 THEN page = page + 1
2858                     RStartPos = (page - 1) * rowno + RMinPos
2860                     ListFiles RightFiles$, RStartPos, RIndex, 8
2862                 ELSE
2864                     d$ = ""
2866                 END IF
2868             END IF
2870         ELSE
2872             d$ = ""
2874         END IF
2876     ELSE
2878         d$ = ""
2880         IF ch = 7
2882             a$ = leftDir$ & GetFNam$(FileList$, Index)
2884         ELSE
2886             a$ = rightDir$ & GetFNam$(FileList$, Index)
2888         END IF
2890     END IF
2892     IF LEN(d$) = 0
2894         IF ch = 7
2896             leftDir$ = a$
2898             LShowLeftDir
2900         ELSE
2902             rightDir$ = a$
2904             LShowRightDir
2906         END IF
2908     END IF
2910 END DEFine
2912 :
2914 :
2916 REMark ''-----------------------------------------------------------
2918 DEFine FuNction GetParentDir$(ch)
2920     LOCal i, dir$
2922 :
2924     IF ch = 7
2926         dir$ = leftDir$
2928     ELSE
2930         dir$ = rightDir$
2932     END IF
2934     FOR i = LEN(dir$) - 1 TO 5 STEP -1
2936         IF dir$(i) = "_"
2938             IF FTEST(dir$(1 TO i)) = 0
2940                 REMark ''use _+ as #, __+ as \ ???
2942                 IF FTYP(\dir$(1 TO i)) = 255 THEN EXIT i
2944             END IF
2946         END IF
2948     END FOR i
2950     dir$ = dir$(1 TO i)
2952     RETurn dir$
2954 END DEFine
2956 :
2958 :
2960 REMark ''------------------------------------------------------------
2962 DEFine PROCedure InputDir(ch)
2964     LOCal a$, olddir$
2966 :
2968     PAPER# ch, 0
2970     INK# ch, 7
2972     CLS# ch
2974 :
2976     IF ch = 5
2978         olddir$ = leftDir$
2980     ELSE
2982         olddir$ = rightDir$
2984     END IF
2986 :
2988     REMark ''use _+ as #, __+ as \ ???
2990     a$ = EDIT$(#ch, olddir$, 36)
2992     CLS# ch
2994     PAPER# ch, White
2996     INK# ch, 0
2998     CLS# ch
3000 :
3002     IF a$ = "" THEN a$ = olddir$
3004     IF a$(LEN(a$)) <> "_" THEN a$ = a$ & "_"
3006     IF DirExists(a$) = 0
3008         BEEP 1390, 20
3010         PRINT# ch, olddir$
3012         RETurn
3014     END IF
3016 :
3018     IF ch = 5
3020         IF crtPanel = 8
3022             REMark ''LONGLINE
3024             ShowHideCursor RIndex - RStartPos, RIndex, RightFiles$, 0
3026         END IF
3028         leftDir$ = a$
3030         crtPanel = 7
3032         LShowLeftDir
3034         BORDER# 7, 1, brd
3036         BORDER# 8, 1, brd, 1, 3
3038     ELSE
3040         IF crtPanel = 7
3042             REMark ''LONGLINE
3044             ShowHideCursor LIndex - LStartPos, LIndex, LeftFiles$, 0
3046         END IF
3048         rightDir$ = a$
3050         crtPanel = 8
3052         LShowRightDir
3054         BORDER# 8, 1, brd
3056         BORDER# 7, 1, brd, 1, 3
3058     END IF
3060 :
3062 END DEFine
3064 :
3066 :
3068 REMark ''----------------------------------------------------------
3070 DEFine PROCedure ViewFile
3072     LOCal ext$(10), a$, x, i, ch, ch1, ch2, ch3
3074     LOCal left, windef$, wid, hgt, top
3076 :
3078     IF crtPanel = 7
3080         IF LIndex > LSizedir + LSizeFile THEN RETurn
3082         a$ = GetFNam$(LeftFiles$, LIndex)
3084     ELSE
3086         IF RIndex > RSizedir + RSizeFile THEN RETurn
3088         a$ = GetFNam$(RightFiles$, RIndex)
3090     END IF
3092     IF a$ == ".." OR a$ == "<un-named>" OR IsDir() = 1
3094         RETurn
3096     END IF
3098     REMark ''now get file extension
3100     x = LEN(a$)
3102     FOR i = 0 TO x - 1
3104         IF a$(x - i) == "_" OR a$(x - i) == "."
3106             EXIT i
3108         END IF
3110     END FOR i
3112     IF i > 0
3114         ext$ = a$(x - i + 1 TO x)
3116     ELSE
3118         ext$ = ""
3120     END IF
3122     IF crtPanel = 7
3124         a$ = leftDir$ & a$
3126     ELSE
3128         a$ = rightDir$ & a$
3130     END IF
3132     ext$ = LOWER$(ext$)
3134     x = 0
3136     IF ext$ = "fnt" THEN x = 1
3138     IF ext$ = "fat" THEN x = 2
3140     IF ext$ = "scr" THEN x = 3
3142     IF ext$ = "doc" THEN x = 4
3144     IF ext$ = "zip" THEN x = 5
3146     IF x <> 3
3148         IF x = 1 OR x = 2
3150             left = (maxWinWid - 448) DIV 2 - 2
3152             wid = 452
3154             hgt = 230
3156             REMark ''LONGLINE
3158             top = (panelWinHeight + 2 * mainFountHeight + 7 - hgt) DIV 2 + 14
3160             windef$ = "scr_452x230a" & left & "x" & top
3162             ch = FOPEN(windef$)
3164             PAPER# ch, 0
3166             INK #ch, White
3168             OUTLN# ch, 452, 230, left, top
3170             BORDER# ch, 1, 2
3172             CLS# ch
3174             windef$ = "scr_452x12a" & left & "x" & top
3176             ch1 = FOPEN(windef$)
3178             BORDER# ch1, 1, 2
3180             PAPER# ch1, 0, 2, 1
3182             CLS# ch1
3184             PAPER# ch1,0
3186             INK# ch1, White
3188             AT# ch1, 0, 37 - (LEN(a$) + 5) DIV 2
3190             PRINT# ch1, "View " & a$
3192             left = left + 2
3194             windef$ = "scr_448x204a" & left & "x" & (top + 12)
3196             ch2 = FOPEN(windef$)
3198             PAPER# ch2, 0
3200             INK# ch2, Green
3202         ELSE
3204             REMark ''LONGLINE
3206             IF maxWinWid > 600 THEN wid = 600 : ELSE wid = 452
3208             hgt = panelWinHeight + 27
3210             left = (maxWinWid - wid) DIV 2 - 2
3212             top = mainFountHeight + 4
3214             REMark ''LONGLINE
3216             windef$ = "scr_" & wid & "x" & hgt & "a" & left & "x" & top
3218             ch = FOPEN(windef$)
3220             PAPER# ch, 0
3222             INK# ch, White
3224             OUTLN# ch, wid, hgt, left, top
3226             BORDER# ch, 1, 2
3228             CLS# ch
3230             REMark ''LONGLINE
3232             windef$ = "scr_" & wid & "x12a" & left & "x" & top
3234             ch1 = FOPEN(windef$)
3236             BORDER# ch1, 1, 2
3238             PAPER# ch1, 0, 2, 1
3240             CLS# ch1
3242             PAPER# ch1, 0
3244             INK# ch1, White
3246             CURSOR# ch1,(wid - (LEN(a$) + 5) * 6) DIV 2, 0
3248             PRINT# ch1, "View " & a$
3250             left = left + 2
3252             REMark ''LONGLINE
3254             windef$ = "scr_" & (wid - 4) & "x" & (hgt - 26) & "a" & left & "x" & (top + 12)
3256             ch2 = FOPEN(windef$)
3258             PAPER# ch2, 0
3260             INK# ch2, Green
3262         END IF
3264 :
3266     END IF
3268     SELect ON x
3270         = 1:
3272             ViewFont a$, 1, ch2
3274 :
3276         = 2:
3278             ViewFont a$, 2, ch2
3280 :
3282         = 3:
3284             ViewImage a$, 4 : Set78CharSet
3286 :
3288         = 4:
3290             WINDOW# 0, wid - 4, 12, left, hgt + top - 14
3292             PAPER# 0, Green
3294             INK# 0, 0
3296             CLS# 0
3298 :
3300             IF IsQuillDoc(a$) = 1
3302                 IF FTEST(ConfigDrv$ & "quill_view") = 0
3304                     REMark ''LONGLINE
3306                     EW ConfigDrv$ & "quill_view", #ch2; "-t " & a$ & " " & TempDir$ & "quill_tmp"
3308                     IF FTEST(TempDir$ & "quill_tmp") = 0
3310                         IF mainFountBase > 0 AND wid < 600
3312                             CHAR_USE# ch2, mainFountBase, 0
3314                             CHAR_INC# ch2, 5, 10
3316                         END IF
3318                         MORE# ch2, TempDir$ & "quill_tmp"
3320                         DELETE TempDir$ & "quill_tmp"
3322                     END IF
3324                 ELSE
3326                     PRINT# ch2, "Cannot find quill_view"
3328                 END IF
3330             ELSE
3332                 MORE# ch2, a$
3334             END IF
3336 :
3338         =5:
3340             REMark ''LONGLINE
3342             WINDOW# 0, wid - 4, 12, left, hgt + top - 14
3344             PAPER# 0, Green
3346             INK# 0, 0
3348             CLS# 0
3350             IF IsZipFile(a$) = 1
3352                 IF FTEST(ConfigDrv$ & "unzip") = 0
3354                     ch3 = FOP_OVER(TempDir$ & "zip_tmp")
3356                     IF ch3 > 0
3358                         REMark ''LONGLINE
3360                         EW ConfigDrv$&"unzip", #ch3, #ch3,#ch3;"-lqq "&a$
3362                         CLOSE# ch3
3364                         MORE# ch2, TempDir$ & "zip_tmp"
3366                         DELETE TempDir$ & "zip_tmp"
3368                     ELSE
3370                         REMark ''LONGLINE
3372                         PRINT# ch2, "Cannot create temporary file"
3374                     END IF
3376                 ELSE
3378                     PRINT# ch2, "Cannot find unzip"
3380                 END IF
3382             ELSE
3384                 MORE# ch2, a$
3386             END IF
3388 :
3390         = REMAINDER :
3392             WINDOW# 0, wid - 4, 12, left, hgt + top - 14
3394             PAPER# 0, Green
3396             INK# 0, 0
3398             CLS# 0
3400             MORE# ch2, a$
3402     END SELect
3404 :
3406     IF x <> 3
3408         CHAR_USE# ch2, 0, 0
3410         CLS# ch1
3412         CLS# ch2
3414         CLOSE# ch2
3416         CLOSE# ch1
3418         WINDOW# 0, 488, 23, 12, 233
3420         PAPER# 0, 0
3422         INK# 0, White
3424         OUTLN# ch, wid, hgt, left, top
3426         CLOSE# ch
3428     END IF
3430 END DEFine
3432 :
3434 :
3436 REMark ''----------------------------------------------------------
3438 DEFine PROCedure ViewFont(file$, type, ch)
3440     LOCal lng, i, base, type$(6)
3442 :
3444     REMark ''use _+ as #, __+ as \ ???
3446     lng = FLEN(\file$)
3448     IF lng > 0
3450         AT# ch, 0, 0
3452         PRINT# ch, "Font: " & file$; "      ";
3454         AT# ch, 0, 44
3456         PRINT# ch, "Font size = "; lng; " bytes"
3458     ELSE
3460         PRINT# ch, "Font NOT FOUND"
3462         RETurn
3464     END IF
3466     base = ALCHP(lng)
3468     LBYTES file$, base
3470 :
3472     IF type = 1 THEN type = TestFount(base)
3474     IF type = 1 THEN type$ = "(5x9)" : ELSE type$ = "(8x9)"
3476     AT# ch, 0, 7 + LEN(file$)
3478     PRINT #ch, type$;
3480 :
3482     AT# ch, 1, 0
3484     REMark ''LONGLINE
3486     PRINT# ch, "Lowest character code = "; PEEK(base); "        ";
3488     AT# ch, 1, 44
3490     PRINT# ch, "Number of characters  = "; PEEK(base+1) + 1
3492     PRINT# ch,"  "
3494     CHAR_USE# ch, base, 0
3496     CSIZE# ch, (type = 2), 0
3498     CHAR_INC# ch, 6 + 2 * (type = 2), 10
3500     FOR i = 0 TO 9
3502         PRINT# ch, CHR$(i);
3504         NEXT i
3506     END FOR i
3508     PRINT# ch, " ";
3510     FOR i = 11 TO 255 : PRINT# ch, CHR$(i); :NEXT i: END FOR i
3512     PRINT# ch, CHR$(10)
3514     PRINT# ch, "The quick brown fox jumped over the lazy dog"
3516     CSIZE# ch, 2 + (type = 2), 0
3518     CHAR_INC# ch, 12 + 4 * (type = 2), 10
3520     PRINT# ch, "The quick brown fox jumped over the lazy dog"
3522     CSIZE# ch, 2 + (type = 2), 1
3524     CHAR_INC# ch, 12 + 4 * (type = 2), 20
3526     PRINT# ch, "The quick brown fox jumped over the lazy dog"
3528     CHAR_USE# ch, 0, 0
3530     RECHP base
3532     xx$ = INKEY$(-1)
3534 END DEFine
3536 :
3538 :
3540 REMark ''----------------------------------------------------------
3542 DEFine PROCedure MessageWnd(WIDTH, height, type, text$)
3544     LOCal ch, k$, AtX,AtY
3546 :
3548     AtX = (maxWinWid - WIDTH) DIV 2
3550     AtY = (256 - height) DIV 2
3552     ch = FOPEN("con")
3554     OUTLN# ch; WIDTH - 2, height, AtX, AtY, 4, 3
3556 :
3558     SELect ON type
3560       = 1:
3562           PAPER# ch, Green
3564           INK# ch, 0
3566           CLS# ch
3568           BLOCK# ch, WIDTH - 4, 8, 1, 1, Green, 1, 1
3570           AT# ch, 1, 1
3572           PRINT# ch, text$
3574 :
3576       = 2:
3578           PAPER# ch, 2
3580           INK# ch, White
3582           CLS# ch
3584           BLOCK# ch, WIDTH - 4, 8, 1, 1, 2, 1, 1
3586           CURSOR# ch, (WIDTH - 49) DIV 2, 1
3588           PRINT# ch, " ERROR "
3590           AT# ch, 1, 1
3592           PRINT# ch, text$
3594 :
3596       = 3:
3598           PAPER# ch, White
3600           INK# ch, 0
3602           BORDER# ch, 1, 2
3604           CLS# ch
3606           BLOCK# ch, WIDTH - 8, 8, 1, 1, 2 ,0 , 1
3608           CURSOR# ch, (WIDTH - 49) DIV 2, 1
3610           PRINT# ch, " ABOUT "
3612           CURSOR#ch, 2, 15
3614           PRINT# ch, text$
3616 :
3618     END SELect
3620 :
3622     CURSOR# ch, (WIDTH - 130) DIV 2, 48
3624     PRINT# ch, "... press any key ..."
3626     k$ = INKEY$(-1)
3628     OUTLN# ch; WIDTH, height, AtX, AtY
3630     CLOSE# ch
3632 END DEFine
3634 :
3636 :
3638 REMark ''----------------------------------------------------------
3640 REMark ''_ used as placeholder, CAN be used ith () parentheses !!!
3642 DEFine FuNction IsDir(_)
3644     LOCal k
3646 :
3648     IF crtPanel = 7
3650         k = GetFFlg(LeftFiles$, LIndex) MOD 2
3652     ELSE
3654         k = GetFFlg(RightFiles$, RIndex) MOD 2
3656     END IF
3658     RETurn k
3660 END DEFine
3662 :
3664 :
3666 REMark ''----------------------------------------------------------
3668 DEFine PROCedure ViewImage(a$, m)
3670     LOCal ch, ch1, scrSz, scrBuf, maxScrSz
3672 :
3674     IF maxWinHgt > 256 OR maxWinWid > 512 OR RMODE > 8
3676         REMark ''LONGLINE
3678         MessageWnd 200, 60, 2, CHR$(10) & " _scr images can only be viewed" & CHR$(10) & "  on classic QL configuration"
3680         RETurn
3682     END IF
3684     maxScrSz = 32768
3686     REMark ''use _+ as #, __+ as \ ???
3688     scrSz = FLEN(\a$)
3690     IF scrSz > maxScrSz
3692         scrBuf = ALCHP(scrSz)
3694         IF scrBuf < 0 THEN BEEP 1390,10 : RETurn
3696         LBYTES a$, scrBuf
3698         a$ = TempDir$ & "tmp_scr"
3700         SBYTES_O a$, scrBuf, maxScrSz
3702         RECHP scrBuf
3704     END IF
3706     ch = FOPEN("con")
3708     OUTLN# ch; 512, 256, 0, 0
3710     IF m = 4 THEN MODE 4 : ELSE MODE 8
3712     LBYTES a$, 131072
3714     PAUSE 10
3716     k = CODE(INKEY$(-1))
3718 :
3720     SELect ON k
3722       = 52:
3724         OUTLN# ch; 512, 256, 0, 0
3726         CLOSE# ch
3728         ViewImage a$, 4
3730 :
3732       = 56:
3734         OUTLN# ch; 512, 256, 0, 0
3736         CLOSE# ch
3738         ViewImage a$, 8
3740 :
3742       = REMAINDER :
3744         MODE 4
3746         OUTLN# ch; 512, 256, 0, 0
3748         CLOSE# ch
3750         DELETE TempDir$ & "tmp_scr"
3752 :
3754     END SELect
3756 :
3758 END DEFine
3760 :
3762 :
3764 REMark ''----------------------------------------------------------
3766 DEFine FuNction InputWnd$(WIDTH, height, title$, text$, start$)
3768     LOCal ch, ch1, k$, AtX,AtY
3770 :
3772     AtX = (maxWinWid - WIDTH) DIV 2
3774     AtY = (256 - height) DIV 2
3776     ch = FOPEN("con")
3778     OUTLN# ch; WIDTH, height, AtX, AtY, 4, 3
3780     BORDER# ch, 1, 4
3782     PAPER# ch, White
3784     INK# ch, 0
3786     CLS# ch
3788     BLOCK# ch, WIDTH - 4, 10, 0, 0, Green, 1, 1
3790     PAPER# ch, Green
3792     INK# ch, 0
3794     CURSOR# ch,(WIDTH - 6 - LEN(title$) * 6) DIV 2, 0
3796     PRINT# ch, title$
3798     PAPER# ch, White
3800     INK# ch, 0
3802     CURSOR# ch, 6, 16
3804     PRINT# ch, text$
3806     CURSOR# ch, (WIDTH - 198) DIV 2, 48
3808     PRINT# ch, "... leave it empty to cancel ..."
3810     ch1 = FOPEN("con")
3812     WINDOW# ch1, WIDTH - 18, 12, AtX + 8, AtY + 28
3814     PAPER# ch1, 0
3816     INK# ch1, White
3818     CLS# ch1
3820     REMark ''use _+ as #, __+ as \ ???
3822     k$ = EDIT$(#ch1, start$, 36)
3824     CLOSE# ch1
3826     OUTLN# ch; WIDTH, height, AtX, AtY
3828     CLOSE# ch
3830     RETurn k$
3832 END DEFine
3834 :
3836 :
3838 REMark ''----------------------------------------------------------
3840 DEFine FuNction DirExists(name$)
3842     LOCal er, ch, d$, dname$
3844 :
3846     dbg name$
3848     dname$ = name$
3850     IF dname$(LEN(dname$)) <> "_"
3852         dname$ = dname$ & "_"
3854     END IF
3856     IF LEN(dname$) = 5
3858         d$ = DATAD$
3860         DATA_USE CHR$(0)
3862         ch = FOP_DIR(dname$)
3864         DATA_USE d$
3866         IF ch < 0
3868             er = 0
3870         ELSE
3872             CLOSE# ch
3874             er = 1
3876         END IF
3878     ELSE
3880         IF FTEST(dname$) = 0
3882             REMark ''use _+ as #, __+ as \ ???
3884             IF FTYP(\dname$) = 255
3886                 er = 1
3888             ELSE
3890                 er = 0
3892             END IF
3894         ELSE
3896             er = 0
3898         END IF
3900     END IF
3902     RETurn er
3904 END DEFine
3906 :
3908 :
3910 REMark ''----------------------------------------------------------
3912 DEFine PROCedure CreateDir
3914     LOCal x, DirName$, FullDirName$
3916 :
3918     REMark ''LONGLINE
3920     DirName$ = InputWnd$(240, 60, " Create Directory ", "Directory Name:", "")
3922     DirName$ = UPPER$(DirName$)
3924     IF DirName$ = "" THEN RETurn
3926     IF crtPanel = 7
3928         FullDirName$ = leftDir$ & DirName$
3930     ELSE
3932         FullDirName$ = rightDir$ & DirName$
3934     END IF
3936     x = Create1Dir(DirName$, FullDirName$, crtPanel, 1, 1, 1)
3938 END DEFine
3940 :
3942 :
3944 REMark ''----------------------------------------------------------
3946 DEFine FuNction Create1Dir(DirName$, FullDirName$, panel, UpdateWnd, CheckNoQ, UpdateList)
3948     LOCal res, fres, page, msg$
3950 :
3952     IF LEN(FullDirName$) > 41
3954         IF UpdateWnd = 1
3956             REMark ''LONGLINE
3958             MessageWnd 200, 60, 2, CHR$(10) & "          Name too long !"
3960             RETurn 0
3962         ELSE
3964           INK# 0, 2
3966           PRINT# 0, "Directory not created  Name too long"
3968           INK# 0, White
3970           RETurn 0
3972         END IF
3974     END IF
3976     IF (Qubide = 1) AND (CheckNoQ = 1)
3978         IF TestQubideRestriction(DirName$, panel) = 1
3980             IF UpdateWnd = 1
3982                 REMark ''LONGLINE
3984                 MessageWnd 200, 60, 2, "   Cannot create Directory !" & CHR$(10) & "  QUBIDE limitation: Files will" & CHR$(10) & "     fall in the directory !"
3986                 RETurn 0
3988             ELSE
3990                 INK# 0, 2
3992                 REMark ''LONGLINE
3994                 PRINT# 0, "Directory not created QUBIDE limitation: Files will fall in the directory"
3996                 INK# 0, White
3998                 RETurn 0
4000             END IF
4002         END IF
4004     END IF
4006     IF DirName$(LEN(DirName$)) = "_"
4008         DirName$ = DirName$(1 TO LEN(DirName$) - 1)
4010     END IF
4012     IF panel = 7
4014         REMark ''LONGLINE
4016         IF (CheckNoQ = 1) AND (LSizedir + LSizeFile + 1 >= MaxFiles)
4018             IF UpdateWnd = 1
4020                 REMark ''LONGLINE
4022                 MessageWnd 200,60,2, CHR$(10) & "   Cannot create Directory !" & CHR$(10) & CHR$(10) & "     maximum number reached !"
4024                 RETurn 0
4026             ELSE
4028                 INK# 0, 2
4030                 REMark ''LONGLINE
4032                 PRINT# 0,"Directory not created. You have reached the maximum number of files and directories"
4034                 INK# 0, White
4036                 RETurn -1
4038             END IF
4040         ELSE
4042             fres = FMAKE_DIR(FullDirName$)
4044             IF (UpdateList = 1) AND (fres >= 0)
4046                 REMark ''LONGLINE
4048                 res = FIND(DirName$, id, LeftFiles$, 1, LSizedir)
4050                 IF res = 0
4052                     REMark ''LONGLINE
4054                     res = Insert(DirName$, id, LeftFiles$, 1, LSizedir, LSizeFile, "0")
4056                 END IF
4058                 LIndex = id
4060                 IF UpdateWnd = 1
4062                     id = id + (LMinPos = 0)
4064                     page = id DIV rowno
4066                     REMark ''LONGLINE
4068                     IF id MOD rowno > 0 THEN page = page + 1
4070                     LStartPos = (page - 1) * rowno + LMinPos
4072                     ListFiles LeftFiles$, LStartPos, LIndex, 7
4074                 END IF
4076                 RETurn 1
4078             ELSE
4080                 IF fres >= 0 THEN RETurn 1
4082             END IF
4084         END IF
4086     ELSE
4088         REMark ''LONGLINE
4090         IF (CheckNoQ = 1) AND (RSizedir + RSizeFile + 1 >= MaxFiles)
4092             IF UpdateWnd = 1
4094                 REMark ''LONGLINE
4096                 MessageWnd 200, 60, 2, CHR$(10) & "   Cannot create Directory !" & CHR$(10) & CHR$(10) & "     maximum number reached !"
4098                 RETurn 0
4100             ELSE
4102                 INK# 0, 2
4104                 REMark ''LONGLINE
4106                 PRINT# 0, "Directory not created. You have reached the maximum number of files and directories"
4108                 INK# 0, White
4110                 RETurn -1
4112             END IF
4114         ELSE
4116             fres = FMAKE_DIR(FullDirName$)
4118             IF (UpdateList = 1) AND (fres >= 0)
4120                 REMark ''LONGLINE
4122                 res = FIND(DirName$, id, RightFiles$, 1, RSizedir)
4124                 IF res = 0
4126                     REMark ''LONGLINE
4128                     res = Insert(DirName$, id, RightFiles$, 1, RSizedir, RSizeFile, "0")
4130                 END IF
4132                 RIndex = id
4134                 IF UpdateWnd = 1
4136                     id = id + (RMinPos = 0)
4138                     page = id DIV rowno
4140                     REMark ''LONGLINE
4142                     IF id MOD rowno > 0 THEN page = page + 1
4144                     RStartPos = (page - 1) * rowno + RMinPos
4146                     ListFiles RightFiles$, RStartPos, RIndex, 8
4148                 END IF
4150                 RETurn 1
4152             ELSE
4154                 IF fres >= 0 THEN RETurn 1
4156             END IF
4158         END IF
4160     END IF
4162 :
4164     SELect ON fres
4166       = -8, -9:
4168         REMark ''LONGLINE
4170         msg$ = "   Cannot create Directory !" & CHR$(10) & "    A file or a directory with" & CHR$(10) & "    same name already exists !"
4172 :
4174       = -11:
4176         REMark ''LONGLINE
4178         msg$ = CHR$(10) & "    Cannot create Directory" & CHR$(10) & "            Drive full"
4180 :
4182       = -15:
4184         REMark ''LONGLINE
4186         msg$ = CHR$(10) & "    Cannot create Directory" & CHR$(10) & "       Drive is not Level2"
4188 :
4190       = -19:
4192         REMark ''LONGLINE
4194         msg$ = CHR$(10) & "    Cannot create Directory" & CHR$(10) & "       Not implemented yet"
4196 :
4198       = -20:
4200         REMark ''LONGLINE
4202         msg$ = CHR$(10) & "    Cannot create Directory" & CHR$(10) & "        Drive is Read Only "
4204 :
4206       = REMAINDER :
4208         REMark ''LONGLINE
4210         msg$ = CHR$(10) & "    Cannot create Directory" & CHR$(10) & "            Error " & fres
4212 :
4214     END SELect
4216 :
4218     IF UpdateWnd = 1
4220         MessageWnd 200, 60, 2, msg$
4222         IF (fres = -15) OR (fres = -19)
4224             DELETE FullDirName$
4226         END IF
4228         RETurn 0
4230     ELSE
4232         SELect ON fres
4234           = -8, -9:
4236             INK# 0,2
4238             REMark ''LONGLINE
4240             PRINT# 0, "Directory not created  A file or a directory with same name already exists"
4242             INK# 0, White
4244             RETurn 0
4246 :
4248           REMark ''= -9:
4250           REMark ''  ink# 0, 2
4252           REMark ''  print# 0, "Directory not created  A directory with same name already exists"
4254           REMark ''  ink# 0, White
4256           REMark ''  Return 0
4258 :
4260           = -11:
4262             INK# 0,2
4264             PRINT# 0, "Directory not created Drive full"
4266             INK# 0, White
4268             RETurn -1
4270 :
4272           = -15:
4274             INK# 0, 2
4276             REMark ''LONGLINE
4278             PRINT# 0, "Directory not created  Drive is not Level2"
4280             INK# 0, White
4282             RETurn -1
4284 :
4286           = -19:
4288             INK# 0, 2
4290             REMark ''LONGLINE
4292             PRINT# 0, "Directory not created  Operation not implemented yet for this drive type"
4294             INK# 0, White
4296             RETurn -1
4298 :
4300           = -20:
4302             INK# 0, 2
4304             REMark ''LONGLINE
4306             PRINT# 0, "Directory not created  Drive is Read Only "
4308             INK# 0, White
4310             RETurn -1
4312 :
4314           = REMAINDER :
4316             INK# 0, 2
4318             PRINT# 0, "Directory not created  Error " & fres
4320             INK# 0, White
4322             RETurn 0
4324         END SELect
4326     END IF
4328 :
4330 END DEFine
4332 :
4334 :
4336 REMark ''-----------------------------------------------------------
4338 REMark ''_ as placeholder, CAN be used with () parentheses !!!
4340 DEFine FuNction CountSelected(_)
4342     LOCal i, counter
4344 :
4346     counter = 0
4348 :
4350     IF crtPanel = 7
4352         FOR i = 1 TO LSizedir + LSizeFile
4354             IF GetFFlg(LeftFiles$, i) > 1
4356                 counter = counter + 1
4358             END IF
4360         END FOR i
4362     ELSE
4364         FOR i = 1 TO RSizedir + RSizeFile
4366             IF GetFFlg(RightFiles$,i) > 1
4368                 counter = counter + 1
4370             END IF
4372         END FOR i
4374     END IF
4376     RETurn counter
4378 END DEFine
4380 :
4382 :
4384 REMark ''---------------------------------------------------------
4386 DEFine FuNction DlgWnd(WIDTH, height, title$, text$)
4388     LOCal ch, a$, k, AtX, AtY, loopa
4390 :
4392     AtX = (maxWinWid - WIDTH) DIV 2
4394     AtY = (256 - height) DIV 2
4396     ch = FOPEN("con")
4398     OUTLN# ch; WIDTH, height, AtX, AtY, 4, 3
4400     BORDER# ch, 1, Green
4402     PAPER# ch, White
4404     INK# ch, 0
4406     CLS# ch
4408     BLOCK# ch, WIDTH - 4, 10, 0, 0, Green, 1, 1
4410     PAPER# ch, Green
4412     INK# ch, 0
4414     CURSOR# ch, (WIDTH - 6 - LEN(title$) * 6) DIV 2, 0
4416     PRINT# ch, title$
4418     PAPER# ch, White
4420     INK# ch, 0
4422     CURSOR# ch, 6, 16
4424     PRINT# ch, text$
4426     CURSOR# ch, (WIDTH - 198) DIV 2, 48:
4428     INK# ch, 2
4430     PRINT# ch, "    C";
4432     INK# ch, 0
4434     PRINT# ch, "ancel                ";
4436     INK# ch, 2
4438     PRINT# ch, "O";
4440     INK# ch, 0
4442     PRINT# ch, "k"
4444     REPeat loopa
4446        a$ = INKEY$(-1)
4448        REMark ''LONGLINE
4450        IF a$ INSTR "oO" & CHR$(10) THEN k = 1: EXIT loopa
4452        REMark ''LONGLINE
4454        IF a$ INSTR "cC" & CHR$(27) THEN k = 0: EXIT loopa
4456     END REPeat loopa
4458     OUTLN# ch; WIDTH, height, AtX, AtY
4460     CLOSE# ch
4462     RETurn k
4464 END DEFine
4466 :
4468 :
4470 REMark ''----------------------------------------------------------
4472 DEFine FuNction TestQubideRestriction(DirName$, panel)
4474     LOCal i, name$
4476 :
4478     name$ = DirName$
4480     IF name$(LEN(name$)) <> "_" THEN name$ = name$ & "_"
4482     IF panel = 7
4484         FOR i = LSizedir + 1 TO LSizedir + LSizeFile
4486             REMark ''LONGLINE
4488             IF name$ INSTR LeftFiles$(i) = 1 THEN RETurn 1
4490         END FOR i
4492     ELSE
4494         FOR i = RSizedir + 1 TO RSizedir + RSizeFile
4496             REMark ''LONGLINE
4498             IF name$ INSTR RightFiles$(i) = 1 THEN RETurn 1
4500         END FOR i
4502     END IF
4504     RETurn 0
4506 END DEFine
4508 :
4510 :
4512 REMark ''----------------------------------------------------------
4514 DEFine FuNction IsQuillDoc(a$)
4516     LOCal ch, q$, i, k
4518 :
4520     ch = FOPEN(a$)
4522     IF ch <= 0 THEN RETurn 0
4524     q$ = ""
4526     BGET# ch\1, k : REMark ''FIXME mixworx \ ???
4528     FOR i = 1 TO 8
4530         BGET# ch, k
4532         q$ = q$ & CHR$(k)
4534         NEXT i
4536     END FOR i
4538     CLOSE# ch
4540     IF q$ = "vrm1qdf0" THEN RETurn 1 : ELSE RETurn 0
4542 END DEFine
4544 :
4546 :
4548 REMark ''-----------------------------------------------------------
4550 DEFine FuNction IsZipFile(a$)
4552     LOCal ch, q$, i, k
4554 :
4556     ch = FOPEN(a$)
4558     IF ch <= 0 THEN RETurn 0
4560     q$ = ""
4562     FOR i = 1 TO 4
4564         BGET# ch, k
4566         q$ = q$ & CHR$(k)
4568         NEXT i
4570     END FOR i
4572     CLOSE# ch
4574     IF q$ = "PK" & CHR$(3) & CHR$(4)
4576         RETurn 1
4578     ELSE
4580         RETurn 0
4582     END IF
4584 END DEFine
4586 :
4588 :
4590 REMark ''----------------------------------------------------------
4592 DEFine PROCedure RenameFile
4594     LOCal NewFileName$, filename$, sourcepath$
4596     LOCal res, i, x, filelen$, page
4598 :
4600     IF crtPanel = 7
4602         IF LIndex > LSizeFile + LSizedir THEN RETurn
4604     ELSE
4606         IF RIndex > RSizeFile + RSizedir THEN RETurn
4608     END IF
4610     IF crtPanel = 7
4612         filename$ = GetFNam$(LeftFiles$, LIndex)
4614         sourcepath$ = leftDir$
4616     ELSE
4618        filename$ = GetFNam$(RightFiles$, RIndex)
4620        sourcepath$ = rightDir$
4622     END IF
4624     IF filename$ = ".." THEN RETurn
4626     IF IsDir() = 1
4628         REMark ''LONGLINE
4630         MessageWnd 200, 60, 2, CHR$(10) & "   Cannot rename a Directory!"
4632         RETurn
4634     END IF
4636     res = FTEST(sourcepath$ & filename$)
4638     IF res = -9
4640         REMark ''LONGLINE
4642         MessageWnd 200, 60, 2, CHR$(10) & "   File in Use! Cannot rename!"
4644         RETurn
4646     END IF
4648     IF res = -20
4650         REMark ''LONGLINE
4652         MessageWnd 200, 60, 2, CHR$(10) & "       File is Read Only! " & CHR$(10) & "          Cannot rename!"
4654         RETurn
4656     END IF
4658     REMark ''LONGLINE
4660     NewFileName$ = InputWnd$(240, 60, " Rename File ", "Rename " & filename$ & " to:", filename$)
4662     IF NewFileName$ = "" THEN RETurn
4664     IF LEN(sourcepath$ & NewFileName$) > 36
4666         REMark ''LONGLINE
4668         MessageWnd 200, 60, 2, CHR$(10) & "   Full file name is too long!"
4670         RETurn
4672     END IF
4674     IF FTEST(sourcepath$ & NewFileName$) <> -7
4676         REMark ''LONGLINE
4678         MessageWnd 200, 60, 2, CHR$(10) & "      A file with this name" & CHR$(10) & "          already exists!"
4680         RETurn
4682     END IF
4684     RENAME sourcepath$ & filename$ TO sourcepath$ & NewFileName$
4686     IF crtPanel = 7
4688         filelen$ = GetFLen(LeftFiles$, LIndex)
4690         REMark ''LONGLINE
4692         ShowHideCursor LIndex - LStartPos, LIndex, LeftFiles$, 0
4694         FOR i = LIndex + 1 TO LSizedir + LSizeFile
4696             CopyRec LeftFiles$, i TO LeftFiles$, i - 1
4698         END FOR i
4700         LSizeFile = LSizeFile - 1
4702         REMark ''LONGLINE
4704         x = FIND(NewFileName$, id, LeftFiles$, LSizedir + 1, LSizedir + LSizeFile)
4706         REMark ''LONGLINE
4708         x = Insert(NewFileName$, id, LeftFiles$, 0, LSizedir, LSizeFile, filelen$)
4710         LIndex = id
4712         x = id + (LMinPos = 0)
4714         page = x DIV rowno
4716         IF x MOD rowno > 0 THEN page = page + 1
4718         LStartPos = (page - 1) * rowno + LMinPos
4720         ListFiles LeftFiles$, LStartPos, LIndex, 7
4722     ELSE
4724         filelen$ = GetFLen(RightFiles$, RIndex)
4726         REMark ''LONGLINE
4728         ShowHideCursor RIndex - RStartPos, RIndex, RightFiles$, 0
4730         FOR i = RIndex + 1 TO RSizedir + RSizeFile
4732             CopyRec RightFiles$, i TO RightFiles$, i - 1
4734         END FOR i
4736         RSizeFile = RSizeFile - 1
4738         REMark ''LONGLINE
4740         x = FIND(NewFileName$, id, RightFiles$, RSizedir + 1, RSizedir + RSizeFile)
4742         REMark ''LONGLINE
4744         x = Insert(NewFileName$, id, RightFiles$, 0, RSizedir, RSizeFile, filelen$)
4746         RIndex = id
4748         x = id + (RMinPos = 0)
4750         page = x DIV rowno
4752         IF x MOD rowno > 0 THEN page = page + 1
4754         RStartPos = (page - 1) * rowno + RMinPos
4756         ListFiles RightFiles$, RStartPos, RIndex, 8
4758     END IF
4760 END DEFine
4762 :
4764 :
4766 :
4768 REMark ''-----------------------------------------------------------
4770 DEFine PROCedure ShowInfo
4772    LOCal filename$(36), path$(36), chf, ch, ch1, ch2
4774    LOCal x, k$(2), windef$, left, top
4776 :
4778     IF crtPanel = 7
4780         IF LIndex > LSizeFile + LSizedir THEN RETurn
4782     ELSE
4784         IF RIndex > RSizeFile + RSizedir THEN RETurn
4786     END IF
4788 :
4790     IF crtPanel = 7
4792         filename$ = GetFNam$(LeftFiles$, LIndex)
4794         path$ = leftDir$
4796     ELSE
4798         filename$ = GetFNam$(RightFiles$, RIndex)
4800         path$ = rightDir$
4802     END IF
4804 :
4806     IF filename$ = ".." THEN RETurn
4808     left = (maxWinWid - 452) DIV 2
4810     IF maxWinHgt > 256 THEN top = 51: ELSE top = 14
4812     windef$ = "scr_452x230a" & left & "x" & top
4814     ch = FOPEN(windef$)
4816     PAPER# ch, 0
4818     INK# ch, White
4820     OUTLN# ch, 452, 230, left, top
4822     BORDER# ch, 1, 2
4824     CLS# ch
4826     windef$ = "scr_452x12a" & left & "x" & top
4828     ch1 = FOPEN(windef$)
4830     BORDER# ch1, 1, 2
4832     PAPER# ch1, 0, 2, 1
4834     CLS# ch1
4836     PAPER# ch1, 0
4838     INK# ch1, White
4840     AT# ch1, 0, 34
4842     PRINT# ch1, " Info "
4844     windef$ = "scr_448x204a" & (left + 2) & "x" & (top + 12)
4846     ch2 = FOPEN(windef$)
4848     PAPER# ch2, 0
4850     INK# ch2, Green
4852     PRINT# ch2, "Full name: "; path$ & filename$; CHR$(10);
4854 :
4856     chf = FOPEN(path$ & filename$)
4858     IF chf < 0
4860         INK# ch2, 2
4862         SELect ON chf
4864           = -7:
4866             PRINT# ch2, "File Not Found !"
4868 :
4870           = -9:
4872             PRINT# ch2, "File in use"
4874 :
4876           = REMAINDER :
4878             PRINT# ch2, "Error "; chf
4880 :
4882         END SELect
4884         REMark ''FIXME mixworx channel # ??? default ???
4886         INK 4
4888     ELSE
4890         GetHEAD# chf, headBuff
4892         PRINT# ch2, "File Length:";
4894         REMark ''LONGLINE
4896         PRINT_USING# ch2, "##,###,###. bytes\", PEEK_L(headBuff)
4898         x = PEEK(headBuff + 5)
4900         PRINT# ch2, "File Type:   "; x; " - ";
4902 :
4904         SELect ON x
4906           =  0:
4908             REMark ''LONGLINE
4910             PRINT# ch2, "BASIC, CALLable machine code, extensions or DATA file"
4912 :
4914           =  1:
4916             PRINT# ch2, "EXECable file"
4918 :
4920           =  2:
4922             REMark ''LONGLINE
4924             PRINT# ch2, "SROFF file used by linkers etc, a C68 Library file etc"
4926 :
4928           =  3:
4930             REMark ''LONGLINE
4932             PRINT# ch2, "THOR hard disc directory file. (I think!)"
4934 :
4936           =  4:
4938             PRINT# ch2, "A font file for The Painter"
4940 :
4942           =  5:
4944             PRINT# ch2, "A pattern file for The Painter"
4946 :
4948           =  6:
4950             REMark ''LONGLINE
4952             PRINT# ch2, "A compressed mode 4 screen in The Painter"
4954 :
4956           = 11:
4958             REMark ''LONGLINE
4960             PRINT# ch2, "A compressed mode 8 screen in The Painter"
4962 :
4964           =255:
4966             REMark ''LONGLINE
4968             PRINT# ch2, "Level 2 driver directory or sub-directory file"
4970 :
4972           =REMAINDER :
4974             PRINT# ch2, " "
4976         END SELect
4978 :
4980         PRINT# ch2, "Data-space: ";
4982         IF x = 1
4984             REMark ''LONGLINE
4986             PRINT_USING# ch2, "##,###,###. bytes\", PEEK_L(headBuff + 6)
4988         ELSE
4990             PRINT# ch2, "   n/a"
4992         END IF
4994         PRINT# ch2, "File Version:  "; PEEK_W(headBuff + 56)
4996         PRINT# ch2, "Last modified: ";
4998         d = PEEK_L(headBuff + 52)
5000         IF d
5002             PRINT# ch2, DATE$(d)
5004         ELSE
5006             PRINT# ch2, "<not-set>"
5008         END IF
5010         PRINT# ch2, "Backup date:   ";
5012         d = PEEK_L(headBuff + 60)
5014         IF d
5016             PRINT# ch2, DATE$(d)
5018         ELSE
5020             PRINT# ch2, "<not-set>"
5022         END IF
5024         CLOSE# chf
5026     END IF
5028 :
5030     REMark ''LONGLINE
5032     PRINT# ch2, CHR$(10); "------------------------------------------------------------------------"; CHR$(10)
5034     PRINT# ch2, "ROM Version:  "; VER$
5036     PRINT# ch2, "QDOS Version: "; VER$(1)
5038     PRINT# ch2, "Current RAMTOP: ";
5040     PRINT_USING# ch2, "##,###.#", RESPR(0) DIV 1024 - 128
5042     PRINT# ch2, " Kb"
5044     PRINT# ch2, "Free memory:    ";
5046     PRINT_USING# ch2, "##,###.#", FREE_MEM DIV 1024
5048     PRINT# ch2, " Kb"
5050     PRINT# ch2
5052     PRINT# ch2, "DataD$: "; DATAD$
5054     PRINT# ch2, "ProgD$: "; PROGD$
5056     PRINT# ch2, "DestD$: "; DESTD$
5058 :
5060     k$ = INKEY$(-1)
5062     CLS# ch1
5064     CLS# ch2
5066     CLOSE# ch2
5068     CLOSE# ch1
5070     OUTLN# ch, 452, 230, left, top
5072     CLOSE# ch
5074 :
5076 END DEFine
5078 :
5080 :
5082 REMark ''----------------------------------------------------------
5084 DEFine PROCedure WriteCommands(ch)
5086     LOCal l, r, px, px1, i, x, lat(9)
5088 :
5090     l = (comWinWid - 4) DIV 9
5092     r = (comWinWid - 4) MOD 9
5094     FOR i = 1 TO 9 : lat(i) = l : NEXT i
5096     IF r >= 0 THEN lat(4) = l + 1
5098     IF r >= 1 THEN lat(3) = l + 1
5100     IF r >= 2 THEN lat(5) = l + 1
5102     IF r >= 3 THEN lat(1) = l + 1
5104     IF r >= 4 THEN lat(2) = l + 1
5106     IF r >= 5 THEN lat(6) = l + 1
5108     IF r >= 6 THEN lat(7) = l + 1
5110     IF r >= 7 THEN lat(8) = l + 1
5112     IF r >= 8 THEN lat(9) = l + 1
5114     px = 0
5116     PAPER# ch, PPR9a, ppr9b, 3
5118 :
5120     FOR i = 1 TO 9
5122         REMark ''LONGLINE
5124         BLOCK# ch, lat(i) - 1, mainFountHeight, px, 0, PPR9a, ppr9b, 3
5126         REMark ''LONGLINE
5128         x = px + (lat(i) - 1 - LEN(cmdText$(i)) * comFountWid) DIV 2
5130         CURSOR# ch, x, 0
5132         PRINT# ch, cmdText$(i);
5134         px = px + lat(i)
5136     END FOR i
5138 :
5140 END DEFine
5142 :
5144 :
5146 REMark ''----------------------------------------------------------
5148 DEFine FuNction IsReadOnly(a$)
5150     LOCal res
5152 :
5154     res = FOPEN(a$ & CHR$(0))
5156     IF res = -20 THEN RETurn 1
5158     IF res > 0 THEN DELETE a$ & CHR$(0)
5160     RETurn 0
5162 END DEFine
5164 :
5166 :
5168 REMark ''----------------------------------------------------------
5170 DEFine PROCedure CopyFiles
5172     LOCal k, x, name$, source$, dest$, filelen$, panel
5174 :
5176     x = CountSelected()
5178     IF crtPanel = 7
5180         source$ = leftDir$ : dest$ = rightDir$
5182         name$ = GetFNam$(LeftFiles$, LIndex)
5184         filelen$ = GetFLen(LeftFiles$, LIndex)
5186         panel = 8
5188     ELSE
5190         dest$ = leftDir$ : source$ = rightDir$
5192         name$ = GetFNam$(RightFiles$, RIndex)
5194         filelen$ = GetFLen(RightFiles$, RIndex)
5196         panel = 7
5198     END IF
5200 :
5202     IF IsReadOnly(dest$)
5204         REMark ''LONGLINE
5206         MessageWnd 200, 60, 2, CHR$(10) & "    Destination is Read Only! " & CHR$(10) & "           Cannot copy!"
5208         RETurn
5210     END IF
5212 :
5214     IF x > 0
5216         REMark ''LONGLINE
5218         k = DlgWnd(240, 60, " Copy Files ", "    Are you sure you want to copy" & CHR$(10) & "     " & x & " files and directories ?")
5220         IF k = 1 THEN CopyMultipleFiles x
5222     ELSE
5224         IF IsDir() = 1
5226             CopySingleDir name$, source$, dest$, panel
5228         ELSE
5230             IF LEN(dest$&name$) > 41
5232                 REMark ''LONGLINE
5234                 MessageWnd 200, 60, 2, CHR$(10)&"        Cannot copy file"&CHR$(10)&"          Name too long !"
5236                 RETurn
5238             END IF
5240             k = FTEST(dest$ & name$)
5242             IF k = -7
5244                 IF crtPanel = 7
5246                     IF RSizedir + RSizeFile + 1 >= MaxFiles
5248                         REMark ''LONGLINE
5250                         MessageWnd 200, 60, 2, CHR$(10) & "        Cannot copy file" & CHR$(10) & "      maximum number reached !"
5252                         RETurn
5254                     END IF
5256                 ELSE
5258                     IF LSizedir + LSizeFile + 1 >= MaxFiles
5260                         REMark ''LONGLINE
5262                         MessageWnd 200, 60, 2, CHR$(10) & "        Cannot copy file" & CHR$(10) & "      maximum number reached !"
5264                         RETurn
5266                     END IF
5268                 END IF
5270                 Copy1File name$, source$, dest$, filelen$, 1
5272                 RETurn
5274             ELSE
5276                 IF k = 0
5278                     REMark ''LONGLINE
5280                     x = DlgWnd(240, 60, " Copy Files ", "   Destination file already exists" & CHR$(10) & "              Overwrite ?")
5282                     IF x = 1
5284                         Copy1File name$, source$, dest$, filelen$, 1
5286                         RETurn
5288                     END IF
5290                 ELSE
5292                    SELect ON k
5294                      =  -9:
5296                         REMark ''LONGLINE
5298                        MessageWnd 200, 60, 2, CHR$(10) & "      Destination is in use " & CHR$(10) & "           Cannot copy!" : RETurn
5300 :
5302                      = -11:
5304                         REMark ''LONGLINE
5306                        MessageWnd 200, 60, 2, CHR$(10) & "    Destination drive is full" & CHR$(10) & "           Cannot copy!" : RETurn
5308 :
5310                      = -16:
5312                         REMark ''LONGLINE
5314                        MessageWnd 200, 60, 2, CHR$(10) & "      Bad or Changed Medium" & CHR$(10) & "           Cannot copy!" : RETurn
5316 :
5318                      = -20:
5320                         REMark ''LONGLINE
5322                        MessageWnd 200, 60, 2, CHR$(10) & "    Destination is Read Only! " & CHR$(10) & "           Cannot copy!" : RETurn
5324 :
5326                      = REMAINDER :
5328                         REMark ''LONGLINE
5330                        MessageWnd 200, 60, 2, CHR$(10) & "     Error copying file : " & k : RETurn
5332                    END SELect
5334                 END IF
5336             END IF
5338         END IF
5340 :
5342         IF crtPanel = 7
5344             id = RIndex + (RMinPos = 0)
5346             page = id DIV rowno
5348             IF id MOD rowno > 0 THEN page = page + 1
5350             RStartPos = (page - 1) * rowno + RMinPos
5352             ListFiles RightFiles$, RStartPos, RIndex, 8
5354         ELSE
5356             id = LIndex + (LMinPos = 0)
5358             page = id DIV rowno
5360             IF id MOD rowno > 0 THEN page = page + 1
5362             LStartPos = (page - 1) * rowno + LMinPos
5364             ListFiles LeftFiles$, LStartPos, LIndex, 7
5366         END IF
5368 :
5370     END IF
5372 END DEFine
5374 :
5376 :
5378 REMark ''-----------------------------------------------------------
5380 DEFine PROCedure Copy1File(name$, source$, dest$, filelen$, UpdateList)
5382     LOCal x, page
5384 :
5386     COPY_O source$ & name$ TO dest$ & name$
5388     IF crtPanel = 8
5390         REMark ''LONGLINE
5392         x = FIND(name$, id, LeftFiles$, LSizedir + 1, LSizedir + LSizeFile)
5394         IF x = 0
5396             REMark ''LONGLINE
5398             x = Insert(name$, id, LeftFiles$, 0, LSizedir, LSizeFile, filelen$)
5400         ELSE
5402             PutFLen LeftFiles$, id, filelen$
5404         END IF
5406         LIndex = id
5408         IF UpdateList = 1
5410             id = id + (LMinPos = 0)
5412             page = id DIV rowno
5414             IF id MOD rowno > 0 THEN page = page + 1
5416             LStartPos = (page - 1) * rowno + LMinPos
5418             ListFiles LeftFiles$, LStartPos, LIndex, 7
5420         END IF
5422     ELSE
5424         REMark ''LONGLINE
5426         x = FIND(name$, id, RightFiles$, RSizedir + 1, RSizedir + RSizeFile)
5428         IF x = 0
5430             REMark ''LONGLINE
5432             x = Insert(name$, id, RightFiles$, 0, RSizedir, RSizeFile, filelen$)
5434         ELSE
5436             PutFLen RightFiles$, id, filelen$
5438         END IF
5440         RIndex = id
5442         IF UpdateList = 1
5444             id = id + (RMinPos = 0)
5446             page = id DIV rowno
5448             IF id MOD rowno > 0 THEN page = page + 1
5450             RStartPos = (page - 1) * rowno + RMinPos
5452             ListFiles RightFiles$, RStartPos, RIndex, 8
5454         END IF
5456     END IF
5458 END DEFine
5460 :
5462 :
5464 REMark ''----------------------------------------------------------
5466 DEFine PROCedure CopyDirFiles(name$, source$, dest$, CreateWnd)
5468     LOCal ch, ch1
5470 :
5472     IF CreateWnd = 1
5474         ch = FOPEN("scr_400x156a56x50")
5476         PAPER# ch, 0
5478         INK# ch, 7
5480         OUTLN# ch, 400, 156, 56, 50
5482         BORDER# ch, 1, 2
5484         CLS# ch
5486         ch1 = FOPEN("scr_398x12a57x51")
5488         BORDER# ch1, 1, 2
5490         PAPER# ch1, 0, 2, 1
5492         CLS# ch1
5494         PAPER# ch1, 0
5496         INK# ch1, 7
5498         AT# ch1, 0, 25
5500         PRINT# ch1, " Copy Directory "
5502         WINDOW# 0, 396, 140, 58, 63
5504         PAPER# 0, 0
5506         INK# 0, White
5508         CLS# 0
5510     END IF
5512 :
5514     PRINT# 0, "Copy " & source$ & name$ & " to " & dest$ & name$
5516     WCOPY source$ & name$ TO dest$ & name$
5518     IF CreateWnd = 1
5520         INK# 0, Green
5522         REMark ''LONGLINE
5524         PRINT# 0, "Copy process ended - press any key to close window"
5526         INK# 0, White
5528         x = KEYROW(0)
5530         a$ = INKEY$(-1)
5532         WINDOW# 0, 448, 12, 32, 231:
5534         CLOSE# ch1
5536         OUTLN# ch, 400, 156, 56, 50
5538         CLOSE# ch
5540     END IF
5542 END DEFine
5544 :
5546 :
5548 REMark ''----------------------------------------------------------
5550 DEFine PROCedure CopyMultipleFiles(k)
5552     LOCal ch, ch1, i, x, a$, Index, panel
5554     LOCal page, id, left, windef$, hgt, wid
5556 :
5558     IF panelWinWid * 2 > 602
5560         wid = 600
5562     ELSE
5564         wid = 400
5566     END IF
5568 :
5570     hgt = panelWinHeight * 8 DIV 10
5572     left = (maxWinWid - wid) DIV 2
5574     windef$ = "scr_" & wid & "x" & hgt & "a" & left & "x50"
5576     ch = FOPEN(windef$)
5578     PAPER# ch, 0
5580     INK# ch, White
5582     OUTLN# ch, wid, hgt, left, 50
5584     BORDER# ch, 1, 2
5586     CLS# ch
5588     left = left + 1
5590     windef$ = "scr_" & (wid - 2) & "x12a" & left & "x51"
5592     ch1 = FOPEN(windef$)
5594     BORDER# ch1, 1, 2
5596     PAPER# ch1, 0, 2, 1
5598     CLS# ch1
5600     PAPER# ch1, 0
5602     INK# ch1, White
5604     CURSOR# ch1, (wid - 90) DIV 2, 0
5606     PRINT# ch1, " Copy Selected "
5608     WINDOW# 0, wid - 4, hgt - 16, left + 1, 63
5610     PAPER# 0, 0
5612     INK# 0, White
5614     CLS# 0
5616     REMark ''LONGLINE
5618     PRINT# 0, "Copy Selected list: " & k & " files and/or directories"
5620 :
5622     IF crtPanel = 7
5624         source$ = leftDir$
5626         dest$ = rightDir$
5628         Index = LIndex
5630         panel = 8
5632         FOR i = 1 TO LSizedir + LSizeFile
5634             LIndex = i
5636             IF GetFFlg(LeftFiles$, i) > 1
5638                 IF GetFFlg(LeftFiles$, i) = 2
5640                     REMark ''LONGLINE
5642                     PRINT# 0, "Copying file " & GetFNam$(LeftFiles$, i) & " ..."
5644                     REMark ''LONGLINE
5646                     x = CopyAListFile(GetFNam$(LeftFiles$, i), source$, dest$, GetFLen(LeftFiles$, i), 8)
5648                 ELSE
5650                     REMark ''LONGLINE
5652                     PRINT# 0, "Copying directory " & GetFNam$(LeftFiles$, i) & " ..."
5654                     REMark ''LONGLINE
5656                     x = CopyFullDir(GetFNam$(LeftFiles$, i), source$, dest$, 8, 0, 1, 1)
5658                 END IF
5660                 IF x = -1 THEN EXIT i
5662                 REMark ''LONGLINE
5664                 PutFFlg LeftFiles$, i, GetFFlg(LeftFiles$, i) ^^ 2
5666             END IF
5668             NEXT i
5670         END FOR i
5672         LIndex = Index
5674     ELSE
5676         source$ = rightDir$
5678         dest$ = leftDir$
5680         Index = RIndex
5682         FOR i = 1 TO RSizedir + RSizeFile
5684             RIndex = i
5686             IF GetFFlg(RightFiles$, i) > 1
5688                 IF GetFFlg(RightFiles$,i) = 2
5690                     REMark ''LONGLINE
5692                     PRINT# 0, "Copying file " & GetFNam$(RightFiles$, i) & " ..."
5694                     REMark ''LONGLINE
5696                     x = CopyAListFile(GetFNam$(RightFiles$, i), source$, dest$, GetFLen(RightFiles$, i), 7)
5698                 ELSE
5700                     REMark ''LONGLINE
5702                     PRINT# 0, "Copying directory " & GetFNam$(RightFiles$, i) & " ..."
5704                     REMark ''LONGLINE
5706                     x = CopyFullDir(GetFNam$(RightFiles$, i), source$, dest$, 7, 0, 1, 1)
5708                 END IF
5710                 IF x = -1 THEN EXIT i
5712                 REMark ''LONGLINE
5714                 PutFFlg RightFiles$, i, GetFFlg(RightFiles$, i) ^^ 2
5716             END IF
5718             NEXT i
5720         END FOR i
5722         RIndex = Index
5724     END IF
5726 :
5728     INK# 0, Green
5730     REMark ''LONGLINE
5732     PRINT# 0, "Copy process ended - press any key to close window"
5734     INK# 0, White
5736     x = KEYROW(0)
5738     a$ = INKEY$(-1)
5740     WINDOW# 0, 448, 12, 32, 231
5742     CLOSE# ch1
5744     OUTLN# ch, wid, hgt, left - 1, 50
5746     CLOSE# ch
5748     id = RIndex + (RMinPos = 0)
5750     page = id DIV rowno
5752     IF id MOD rowno > 0 THEN page = page + 1
5754     RStartPos = (page - 1) * rowno + RMinPos
5756     ListFiles RightFiles$, RStartPos, RIndex, 8
5758     id = LIndex + (LMinPos = 0)
5760     page = id DIV rowno
5762     IF id MOD rowno > 0 THEN page = page + 1
5764     LStartPos = (page - 1) * rowno + LMinPos
5766     ListFiles LeftFiles$, LStartPos, LIndex, 7
5768 END DEFine
5770 :
5772 :
5774 REMark ''----------------------------------------------------------
5776 DEFine FuNction CopyAListFile(name$, source$, dest$, filelen$, panel)
5778     LOCal k
5780 :
5782     IF LEN(dest$ & name$) > 41
5784         INK# 0, 2
5786         PRINT# 0, name$ & " not copied. Name too long"
5788         INK# 0, White
5790         RETurn 0
5792     END IF
5794 :
5796     k = FTEST(dest$ & name$)
5798 :
5800     IF k = -7
5802         IF panel = 8
5804             IF RSizedir + RSizeFile + 1 >= MaxFiles
5806                 INK# 0, 2
5808                 REMark ''LONGLINE
5810                 PRINT# 0, "Maximum number reached on destination directory!"
5812                 INK# 0, White
5814                 RETurn -1
5816             END IF
5818         ELSE
5820             IF LSizedir + LSizeFile + 1 >= MaxFiles
5822                 INK# 0, 2
5824                 REMark ''LONGLINE
5826                 PRINT# 0, "Maximum number reached on destination directory!"
5828                 INK# 0, White
5830                 RETurn -1
5832             END IF
5834         END IF
5836         Copy1File name$, source$, dest$, filelen$, 0
5838         RETurn 1
5840     ELSE
5842         IF k = 0
5844             PRINT# 0, "File already exists Overwrite (Y/N) ?"
5846             REPeat loopa
5848                 a$ = INKEY$(-1)
5850                 IF a$ INSTR "yYnN" THEN EXIT loopa
5852             END REPeat loopa
5854             IF a$ = "y" OR a$ = "Y"
5856                 Copy1File name$, source$, dest$, filelen$, 0
5858                 RETurn 1
5860             ELSE
5862                 RETurn 0
5864             END IF
5866         ELSE
5868             SELect ON k
5870               =  -9:
5872                 INK# 0, 2
5874                 REMark ''LONGLINE
5876                 PRINT# 0, name$ & "not copied. Destination is in use"
5878                 INK# 0, White
5880                 RETurn 0
5882 :
5884               = -11:
5886                 INK# 0, 2
5888                 REMark ''LONGLINE
5890                 PRINT# 0, name$ & "not copied. Destination drive is full"
5892                 INK# 0, White
5894                 RETurn -1
5896 :
5898               = -16:
5900                 INK# 0, 2
5902                 REMark ''LONGLINE
5904                 PRINT# 0, name$ & "not copied. Destination Bad or Changed Medium"
5906                 INK# 0, White
5908                 RETurn -1
5910 :
5912               = -20:
5914                 INK# 0, 2
5916                 REMark ''LONGLINE
5918                 PRINT# 0, name$ & "not copied. Destination is Read Only! "
5920                 INK# 0, White
5922                 RETurn 0
5924 :
5926               = REMAINDER :
5928                 INK# 0, 2
5930                 PRINT# 0, name$ & "not copied. Error " & k
5932                 INK# 0, White
5934                 RETurn 0
5936 :
5938             END SELect
5940         END IF
5942     END IF
5944 END DEFine
5946 :
5948 :
5950 REMark ''-----------------------------------------------------------
5952 DEFine PROCedure DeleteFiles
5954     LOCal source$, name$, panel, x, k, a$, ch, ch1
5956     LOCal Index, left, windef$, hgt, wid
5958 :
5960     IF crtPanel = 7
5962         source$ = leftDir$
5964         name$ = GetFNam$(LeftFiles$, LIndex)
5966         panel = 7
5968         Index = LIndex
5970     ELSE
5972         source$ = rightDir$
5974         name$ = GetFNam$(RightFiles$, RIndex)
5976         panel = 8
5978         Index = RIndex
5980     END IF
5982 :
5984     IF IsReadOnly(source$)
5986         REMark ''LONGLINE
5988         MessageWnd 200, 60, 2, CHR$(10) & "       Drive is Read Only! "
5990         RETurn
5992     END IF
5994 :
5996     x = CountSelected()
5998 :
6000     IF x > 0
6002         REMark ''LONGLINE
6004         k = DlgWnd(240, 60, " Delete Files ", "   Are you sure you want to delete" & CHR$(10) & "     " & x & " files and directories ?")
6006     ELSE
6008         IF IsDir() = 1
6010             a$ = "directory " & name$
6012         ELSE
6014             a$ = "file " & name$
6016         END IF
6018         k = (39 - LEN(a$)) DIV 2
6020         IF k < 0 THEN k = 0
6022         REMark ''LONGLINE
6024         a$ = "   Are you sure you want to delete" & CHR$(10) & FILL$(" ", k) & a$
6026         k = DlgWnd(240, 60, " Delete File ", a$)
6028     END IF
6030 :
6032     IF k = 0 THEN RETurn
6034     IF panelWinWid * 2 > 602
6036         wid = 600
6038     ELSE
6040         wid = 400
6042     END IF
6044     hgt = panelWinHeight * 8 DIV  10
6046     left = (maxWinWid - wid) DIV 2
6048     windef$ = "scr_" & wid & "x" & hgt & "a" & left & "x50"
6050     ch = FOPEN(windef$)
6052     PAPER# ch, 0
6054     INK# ch, White
6056     OUTLN# ch, wid, hgt, left, 50
6058     BORDER# ch, 1, 2
6060     CLS# ch
6062     left = left + 1
6064     windef$ = "scr_" & (wid - 2) & "x12a" & left & "x51"
6066     ch1 = FOPEN(windef$)
6068     BORDER# ch1, 1, 2
6070     PAPER# ch1, 0, 2, 1
6072     CLS# ch1
6074     PAPER# ch1, 0
6076     INK# ch1, White
6078     CURSOR# ch1, (wid - 84) DIV 2, 0
6080     PRINT# ch1, " Delete Files "
6082     WINDOW# 0, wid - 4, hgt - 16, left + 1, 63
6084     PAPER# 0, 0
6086     INK# 0, White
6088     CLS# 0
6090 :
6092     IF x = 0
6094         IF IsDir() = 0
6096             PRINT# 0, "Deleting file " & source$ & name$
6098             DELETE source$ & name$
6100         ELSE
6102             IF DeleteDirectory(source$, name$) = 0
6104                 INK# 0, 2
6106                 REMark ''LONGLINE
6108                 PRINT# 0, "Could not delete all of " & source$ & name$ & "_"
6110                 INK# 0, White
6112             END IF
6114         END IF
6116     ELSE
6118         REMark ''LONGLINE
6120         PRINT# 0, "Delete Selected list: " & x & " files and/or directories"
6122         IF crtPanel = 7
6124             FOR k = 1 TO LSizedir + LSizeFile
6126                 IF GetFFlg(LeftFiles$,k) > 1
6128                     IF GetFFlg(LeftFiles$,k) = 2
6130                         REMark ''LONGLINE
6132                         PRINT# 0, "Deleting file " & GetFNam$(LeftFiles$, k) & " ..."
6134                         REMark ''LONGLINE
6136                         DELETE source$ & GetFNam$(LeftFiles$, k)
6138                     ELSE
6140                         REMark ''LONGLINE
6142                         IF DeleteDirectory(source$, GetFNam$(LeftFiles$, k)) = 0
6144                             INK# 0, 2
6146                             REMark ''LONGLINE
6148                             PRINT# 0, "Could not delete all of " & source$ & GetFNam$(LeftFiles$, k) & "_"
6150                             INK# 0, White
6152                         END IF
6154                     END IF
6156                 END IF
6158                 NEXT k
6160             END FOR k
6162         ELSE
6164             FOR k = 1 TO RSizedir + RSizeFile
6166                 IF GetFFlg(RightFiles$, k) > 1
6168                     IF GetFFlg(RightFiles$, k) = 2
6170                         REMark ''LONGLINE
6172                         PRINT# 0, "Deleting file " & GetFNam$(RightFiles$, k) & " ..."
6174                         REMark ''LONGLINE
6176                         DELETE source$ & GetFNam$(RightFiles$, k)
6178                     ELSE
6180                         REMark ''LONGLINE
6182                         IF DeleteDirectory(source$, GetFNam$(RightFiles$, k))
6184                             INK# 0, 2
6186                             REMark ''LONGLINE
6188                             PRINT# 0, "Could not delete all of " & source$ & GetFNam$(RightFiles$, k) & "_"
6190                             INK# 0, White
6192                         END IF
6194                     END IF
6196                 END IF
6198                 NEXT k
6200             END FOR k
6202         END IF
6204     END IF
6206 :
6208     INK# 0, Green
6210     REMark ''LONGLINE
6212     PRINT# 0, "Delete process ended - press any key to close window"
6214     INK# 0, White
6216 :
6218     x = KEYROW(0)
6220     a$ = INKEY$(-1)
6222 :
6224     WINDOW# 0, 448, 12, 32, 231:
6226     CLOSE# ch1
6228     OUTLN# ch, wid, hgt, left - 1, 50
6230     CLOSE# ch
6232 :
6234     IF crtPanel = 7
6236         ReloadPanel 7, Index
6238     ELSE
6240         ReloadPanel 8, Index
6242     END IF
6244 END DEFine
6246 :
6248 :
6250 REMark ''-----------------------------------------------------------
6252 DEFine PROCedure EXecFile
6254     LOCal filename$, path$, chf, x
6256 :
6258     IF crtPanel = 7
6260         IF LIndex > LSizeFile + LSizedir THEN RETurn
6262         filename$ = GetFNam$(LeftFiles$, LIndex)
6264         path$ = leftDir$
6266     ELSE
6268         IF RIndex > RSizeFile + RSizedir THEN RETurn
6270         filename$ = GetFNam$(RightFiles$, RIndex)
6272         path$ = rightDir$
6274     END IF
6276     chf = FOPEN(path$ & filename$)
6278     IF chf < 0
6280         SELect ON chf
6282           = -7:
6284             REMark ''LONGLINE
6286             MessageWnd 200, 60, 2, CHR$(10) & "         File Not Found !"
6288 :
6290           = -9:
6292             REMark ''LONGLINE
6294             MessageWnd 200, 60, 2, CHR$(10) & "           File in use"
6296 :
6298           = REMAINDER :
6300             REMark ''LONGLINE
6302             MessageWnd 200, 60, 2, CHR$(10) & "             Error " & chf
6304         END SELect
6306      ELSE
6308         CLOSE# chf
6310         REMark ''use _+ as #, __+ as \ ???
6312         x = FTYP(\path$ & filename$)
6314         IF x <> 1
6316             REMark ''LONGLINE
6318             MessageWnd 200, 60, 2, CHR$(10) & "   This is not a EXECable file"
6320         ELSE
6322             EX path$ & filename$
6324         END IF
6326     END IF
6328 END DEFine
6330 :
6332 :
6334 REMark ''----------------------------------------------------------
6336 DEFine FuNction getKey$(c)
6338     LOCal k$(2)
6340 :
6342     CURSEN #c
6344     k$ = INKEY$(c, -1)
6346     CURDIS #c
6348     RETurn k$
6350 END DEFine getKey$
6352 :
6354 :
6356 REMark ''----------------------------------------------------------
6358 DEFine PROCedure OnEnter
6360     LOCal ext$(10), path$, a$, x, i
6362 :
6364     IF crtPanel = 7
6366         IF LIndex > LSizedir + LSizeFile THEN RETurn
6368         a$ = GetFNam$(LeftFiles$, LIndex)
6370         path$ = leftDir$
6372     ELSE
6374         IF RIndex > RSizedir + RSizeFile THEN RETurn
6376         a$ = GetFNam$(RightFiles$, RIndex)
6378         path$ = rightDir$
6380     END IF
6382     IF a$ == ".." OR IsDir() = 1
6384         IF crtPanel = 7
6386             OpenSubDir LeftFiles$, LIndex, 7
6388         ELSE
6390             OpenSubDir RightFiles$, RIndex, 8
6392         END IF
6394         RETurn
6396     END IF
6398 :
6400     REMark ''use _+ as #, __+ as \ ???
6402     IF FTYP(\path$ & a$) = 1
6404         EXecFile
6406         RETurn
6408     END IF
6410 :
6412     REMark ''now get file extension
6414     x = LEN(a$)
6416     FOR i = 0 TO x - 1
6418         IF a$(x - i) == "_" THEN EXIT i
6420         NEXT i
6422     END FOR i
6424     IF i > 0
6426         ext$ = a$(x - i TO x)
6428     ELSE
6430         ext$ = ""
6432     END IF
6434     ext$ = LOWER$(ext$) : x = 0
6436 :
6438     IF ext$ = "_bas" THEN x = 1
6440     REMark ''LONGLINE
6442     IF ext$ = "_cde" OR ext$ = "_code" OR ext$ = "_rext" THEN x = 2
6444     IF ext$ = "_zip" THEN x = 3
6446     IF ext$ = "_doc" THEN x = 4
6448     IF ext$ = "_aba" THEN x = 5
6450     IF ext$ = "_grf" THEN x = 6
6452     IF ext$ = "_dbf" THEN x = 7
6454     IF ext$ = "_ssb" THEN x = 9
6456     IF a$ = "boot" THEN x = 1
6458 :
6460     SELect ON x
6462       = 1:
6464         dbg(path$ & a$)
6466         LoadBasFile(path$ & a$)
6468 :
6470       = 2:
6472         DoLrespr path$ & a$
6474 :
6476       = 3:
6478         IF IsZipFile(path$ & a$) = 1 THEN UnzipFile path$ & a$
6480 :
6482       = 4:
6484         IF IsQuillDoc(path$ & a$) = 1
6486             IF Xchangeprog$ <> ""
6488                 ExecXchange path$, path$ & a$
6490             END IF
6492         END IF
6494 :
6496       = 5:
6498         IF IsAbacusDoc(path$ & a$) = 1
6500             IF Xchangeprog$ <> ""
6502                 ExecXchange path$, path$ & a$
6504             END IF
6506         END IF
6508 :
6510       = 6:
6512         IF Xchangeprog$ <> ""
6514             ExecXchange path$, path$ & a$
6516         END IF
6518 :
6520       = 7:
6522         IF IsArchiveDoc(path$ & a$) = 1
6524             IF Xchangeprog$ <> ""
6526                 ExecXchange path$, path$ & a$
6528             END IF
6530         END IF
6532 :
6534       = 8:
6536         REMark ''LONGLINE
6538         x = DlgWnd(240, 60, " Archive Prg ", "     " & a$ & CHR$(10) & "      Open with Xchange Archive ?")
6540         IF x = 0 THEN RETurn
6542         ExecXchange path$, path$ & a$
6544 :
6546       = 9:
6548         dbg(path$ & a$)
6550         LoadSsbFile(path$ & a$)
6552 :
6554     END SELect
6556 END DEFine
6558 :
6560 :
6562 REMark ''----------------------------------------------------------
6564 DEFine PROCedure UnzipFile (filename$)
6566     LOCal path$, ch, ch1, ch2
6568 :
6570     IF crtPanel = 7
6572         IF LIndex > LSizedir + LSizeFile THEN RETurn
6574         path$ = rightDir$
6576     ELSE
6578         IF RIndex > RSizedir + RSizeFile THEN RETurn
6580         path$ = leftDir$
6582     END IF
6584 :
6586     REMark ''LONGLINE
6588     ch = DlgWnd(240, 60, " Unzip File ", "    Are you sure you want to unzip" & CHR$(10) & "     " & filename$ & " ?")
6590     IF ch = 0 THEN RETurn
6592     ch = FOPEN("scr_452x230a30x14")
6594     PAPER# ch, 0
6596     INK# ch, 7
6598     OUTLN# ch, 452, 230, 30, 14
6600     BORDER# ch, 1, 2
6602     CLS# ch
6604     ch1 = FOPEN("scr_452x12a31x14")
6606     BORDER# ch1, 1, 2
6608     PAPER# ch1, 0, 2, 1
6610     CLS# ch1
6612     PAPER# ch1, 0
6614     INK# ch1, 7
6616     AT# ch1, 0, 37 - (LEN(a$) + 5) DIV 2
6618     PRINT# ch1, "Unzip" & a$
6620     ch2 = FOPEN("scr_448x204a32x26")
6622     PAPER# ch2, 0
6624     INK# ch2, 4
6626     REMark ''LONGLINE
6628     EW ConfigDrv$ & "unzip", #ch2; "-D" & path$ & " -o " & filename$
6630     PRINT# ch2, "Press any key ..."
6632     path$ = INKEY$(-1)
6634     CLS# ch1
6636     CLS# ch2
6638     CLOSE# ch2
6640     CLOSE# ch1
6642     WINDOW# 0, 488, 23, 12, 233
6644     PAPER# 0, 0
6646     INK# 0, White
6648     OUTLN# ch, 452, 230, 30, 14
6650     CLOSE# ch
6652 :
6654     IF crtPanel = 7
6656         ReloadPanel 8, RIndex
6658     ELSE
6660         ReloadPanel 7, LIndex
6662     END IF
6664 END DEFine
6666 :
6668 :
6670 REMark ''----------------------------------------------------------
6672 DEFine PROCedure ExecXchange(path$, filename$)
6674     LOCal savedDATAD$(36), savedPROGD$(36)
6676 :
6678     savedDATAD$ = DATAD$
6680     savedPROGD$ = PROGD$
6682     DATA_USE path$
6684     PROG_USE Xchangepath$
6686     EX Xchangepath$ & Xchangeprog$; filename$
6688     DATA_USE savedDATAD$
6690     PROG_USE savedPROGD$
6692 END DEFine
6694 :
6696 :
6698 REMark ''-----------------------------------------------------------
6700 DEFine PROCedure EditFile(path$, filename$)
6702     LOCal savedDATAD$(36), savedPROGD$(36)
6704 :
6706     savedDATAD$ = DATAD$
6708     savedPROGD$ = PROGD$
6710     DATA_USE path$
6712     PROG_USE EditPath$
6714     EX EditPath$ & Editprog$; path$ & filename$
6716     DATA_USE savedDATAD$
6718     PROG_USE savedPROGD$
6720 END DEFine
6722 :
6724 :
6726 REMark ''-----------------------------------------------------------
6728 DEFine PROCedure AttachBasFileShell(filename$)
6730     TYPE_IN "merge " & "dos1_qlc_cmd_bas" & CHR$(10)
6732     REMark ''LONGLINE
6734     TYPE_IN "32604   QLC_GlobalFilename$ = '" & filename$ & "'" & CHR$(10) : REMark '' odd '
6736 END DEFine
6738 :
6740 :
6742 REMark ''-----------------------------------------------------------
6744 DEFine PROCedure LoadBasFile(filename$)
6746     LOCal x
6748 :
6750     REMark ''QLC_GlobalFilename$ = filename$
6752     SBASIC
6754     COMMAND_LINE
6756     PAUSE 5
6758     TYPE_IN "load " & filename$ & CHR$(10)
6760     REMark ''type_in "dline 32600 to" & chr$(10)
6762 :
6764     AttachBasFileShell filename$
6766 :
6768     TYPE_IN "QLC_INIT" & CHR$(10)
6770     REMark ''type_in "SAVE_O " & filename$ & chr$(10)
6772     TYPE_IN "wtv" & CHR$(10)
6774     AT 2,0
6776     TYPE_IN "rem CMD: h/W/r/e/x/q/s/l/u" & CHR$(10)
6778     TYPE_IN "ED" & CHR$(10)
6780 END DEFine
6782 :
6784 :
6786 REMark ''-----------------------------------------------------------
6788 REMark ''QLXC IDE simplified SSB to BAS conversion
6790 REMark ''- missing support for @Lables and #include, now !!!
6792 DEFine FuNction CompileSsb2Bas(ssb_filename$, bas_filename$)
6794   LOCal i, x$, ierr, oerr
6796 :
6798   REMark ''use _+ as #, __+ as \ ???
6800   ierr = FOP_IN(#10, ssb_filename$)
6802   oerr = FOP_OVER(#11, bas_filename$)
6804   PRINT# 11, "1 rem &&SSBGEN"
6806   linenum = 10
6808   REPeat linenum
6810     INPUT# 10, in$
6812     REMark ''use _+ as #, __+ as \ ???
6814     IF EOF(#10) THEN EXIT
6816     IF (CHR$(38) & CHR$(38) & "QLCGEN") INSTR in$ THEN EXIT
6818     out$ = in$
6820     IF in$ = "" THEN out$ = ":"
6822     pos = (CHR$(39) & CHR$(39) INSTR in$)
6824     REMark ''or ("##" instr in$) or ("//" instr in$) + odd '
6826     IF pos > 0
6828       IF pos > 1
6830         FOR i = 1 TO pos : IF in$(i) <> " " THEN EXIT linenum : NEXT i
6832         IF i < pos
6834             comment$ = ": rem"
6836         ELSE
6838             comment$ = "rem "
6840         END IF
6842         out$ = in$(1 TO pos - 1) & comment$
6844       ELSE out$ = "rem "
6846       END IF
6848       out$ = out$ & in$(pos TO)
6850     END IF
6852     PRINT# 11, linenum & " " & out$
6854     linenum = linenum + 2
6856   END REPeat
6858   CLOSE# 10
6860   CLOSE# 11
6862   RETurn 0
6864 END DEFine
6866 :
6868 :
6870 REMark ''-----------------------------------------------------------
6872 DEFine PROCedure LoadSsbFile(filename$)
6874     LOCal ssb_filename$, bas_filename$, i, x$
6876 :
6878     ssb_filename$ = filename$
6880     REMark ''LONGLINE
6882     bas_filename$ = ssb_filename$(1 TO LEN(ssb_filename$) - 4) & "_bas"
6884 :
6886     _err = CompileSsb2Bas(ssb_filename$, bas_filename$)
6888     LoadBasFile bas_filename$
6890 END DEFine
6892 :
6894 :
6896 REMark ''----------------------------------------------------------
6898 DEFine PROCedure DoEdit
6900     LOCal path$, a$
6902 :
6904     IF crtPanel = 7
6906         IF LIndex > LSizedir + LSizeFile THEN RETurn
6908         a$ = GetFNam$(LeftFiles$, LIndex)
6910         path$ = leftDir$
6912     ELSE
6914         IF RIndex > RSizedir + RSizeFile THEN RETurn
6916         a$ = GetFNam$(RightFiles$, RIndex)
6918         path$ = rightDir$
6920     END IF
6922 :
6924     REMark ''FIXME mixworx nonsese, this function HAS NO ARGS !!!
6926     IF IsDir(path$ & a$) = 1 THEN RETurn
6928     IF IsQuillDoc(path$ & a$) = 1
6930         IF Xchangeprog$ <> ""
6932             ExecXchange path$, path$ & a$
6934             RETurn
6936         END IF
6938     ELSE
6940         EditFile path$, a$
6942     END IF
6944 END DEFine
6946 :
6948 :
6950 REMark ''-----------------------------------------------------------
6952 DEFine PROCedure DoLrespr(filename$)
6954     LOCal x
6956 :
6958     REMark ''LONGLINE
6960     x = DlgWnd(240, 60, " lrespr File ", "    Are you sure you want to lrespr" & CHR$(10) & "     " & filename$ & " ?")
6962     IF x = 0 THEN RETurn
6964     COMMAND_LINE
6966     PAUSE 5
6968     TYPE_IN "lrespr " & filename$ & CHR$(10)
6970 END DEFine
6972 :
6974 :
6976 REMark ''----------------------------------------------------------
6978 DEFine FuNction IsAbacusDoc(a$)
6980     LOCal ch, q$, i, k
6982 :
6984     ch = FOPEN(a$)
6986     IF ch <= 0 THEN RETurn 0
6988     q$ = ""
6990     FOR i = 1 TO 4
6992         BGET# ch, k
6994         q$ = q$ & CHR$(k)
6996         NEXT i
6998     END FOR i
7000     CLOSE# ch
7002     IF q$ = "ABM1" THEN RETurn 1 : ELSE RETurn 0
7004 END DEFine
7006 :
7008 :
7010 REMark ''-----------------------------------------------------------
7012 DEFine FuNction IsArchiveDoc(a$)
7014     LOCal ch, q$, i, k
7016 :
7018     ch = FOPEN(a$)
7020     IF ch <= 0 THEN RETurn 0
7022     q$ = ""
7024     BGET# ch\1, k : REMark ''FIXME mixworx \ ???
7026     FOR i = 1 TO 8
7028         BGET# ch, k
7030         q$ = q$ & CHR$(k)
7032         NEXT i
7034     END FOR i
7036     CLOSE# ch
7038     IF q$ = "vrm1dbf0" THEN RETurn 1 : ELSE RETurn 0
7040 END DEFine
7042 :
7044 :
7046 REMark ''-----------------------------------------------------------
7048 DEFine PROCedure ReloadPanel(panel, Index)
7050     LOCal page, x
7052 :
7054     IF panel = 7
7056         DIM LeftFiles$(MaxFiles, _fMax)
7058         LoadDir leftDir$, LeftFiles$, 7, LSizedir, LSizeFile
7060         IF LEN(leftDir$) = 5
7062             LMinPos = 1
7064         ELSE
7066             LMinPos = 0
7068         END IF
7070         IF Index < LMinPos
7072             Index = LMinPos
7074         END IF
7076         IF Index > LSizedir + LSizeFile
7078             Index = LMinPos
7080         END IF
7082         LIndex = Index
7084         x = Index + (LMinPos = 0)
7086         page = x DIV rowno
7088         IF x MOD rowno > 0 THEN page = page + 1
7090         LStartPos = (page - 1) * rowno + LMinPos
7092         ListFiles LeftFiles$, LStartPos, LIndex, 7
7094     ELSE
7096         DIM RightFiles$(MaxFiles, _fMax)
7098         LoadDir rightDir$, RightFiles$, 8, RSizedir, RSizeFile
7100         IF LEN(rightDir$) = 5
7102             RMinPos = 1
7104         ELSE
7106             RMinPos = 0
7108         END IF
7110         IF Index < RMinPos THEN Index = RMinPos
7112         IF Index > RSizedir + RSizeFile
7114             Index = RMinPos
7116         END IF
7118         RIndex = Index
7120         x = Index + (RMinPos = 0)
7122         page = x DIV rowno
7124         IF x MOD rowno > 0 THEN page = page + 1
7126         RStartPos = (page - 1) * rowno + RMinPos
7128         ListFiles RightFiles$, RStartPos, RIndex, 8
7130     END IF
7132 END DEFine
7134 :
7136 :
7138 REMark ''-----------------------------------------------------------
7140 DEFine PROCedure SelectAll
7142     LOCal i
7144 :
7146     IF crtPanel = 7
7148         FOR i = 1 TO LSizedir + LSizeFile
7150             REMark ''LONGLINE
7152             IF GetFFlg(LeftFiles$, i) < 2 THEN PutFFlg LeftFiles$, i, GetFFlg(LeftFiles$, i) ^^ 2
7154         END FOR i
7156         ListFiles LeftFiles$, LStartPos, LIndex, 7
7158     ELSE
7160         FOR i = 1 TO RSizedir + RSizeFile
7162             REMark ''LONGLINE
7164             IF GetFFlg(RightFiles$, i) < 2 THEN PutFFlg RightFiles$, i, GetFFlg(RightFiles$, i) ^^ 2
7166         END FOR i
7168         ListFiles RightFiles$, RStartPos, RIndex, 8
7170     END IF
7172 END DEFine
7174 :
7176 :
7178 REMark ''-----------------------------------------------------------
7180 DEFine PROCedure UnSelectAll
7182     LOCal i
7184 :
7186     IF crtPanel = 7
7188         FOR i = 1 TO LSizedir + LSizeFile
7190             REMark ''LONGLINE
7192             IF GetFFlg(LeftFiles$, i) > 1 THEN PutFFlg LeftFiles$, i, GetFFlg(LeftFiles$, i) ^^ 2
7194         END FOR i
7196         ListFiles LeftFiles$, LStartPos, LIndex, 7
7198     ELSE
7200         FOR i = 1 TO RSizedir + RSizeFile
7202             REMark ''LONGLINE
7204             IF GetFFlg(RightFiles$, i) > 1 THEN PutFFlg RightFiles$, i, GetFFlg(RightFiles$, i) ^^ 2
7206         END FOR i
7208         ListFiles RightFiles$, RStartPos, RIndex, 8
7210     END IF
7212 END DEFine
7214 :
7216 :
7218 REMark ''-----------------------------------------------------------
7220 REMark ''On QPC2 the char width gets reset so we have to set it again
7222 DEFine PROCedure Set78CharSet
7224 :
7226     IF mainFountBase > 0
7228         IF ClassicFont = 0
7230             CHAR_USE# leftPanelWin, mainFountBase, 0
7232             CHAR_INC# leftPanelWin, 5, 10
7234             CHAR_USE# rightPanelWin, mainFountBase, 0
7236             CHAR_INC# rightPanelWin, 5, 10
7238         END IF
7240     END IF
7242 END DEFine
7244 :
7246 :
7248 REMark ''----------------------------------------------------------
7250 DEFine FuNction TestFount(fountBase)
7252     LOCal fountMask, fountMax, char, row
7254 :
7256     fountMask = 3 : REMark ''*** ------XX
7258     fountMax = PEEK(fountBase + 1)
7260     FOR char = 0 TO fountMax
7262     FOR row = 0 TO 8
7264         REMark ''*** appears to be a FAT fount
7266         REMark ''LONGLINE
7268         IF PEEK(fountBase + 2 + char * 9 + row) && fountMask THEN RETurn 2
7270     END FOR row
7272     END FOR char
7274 :
7276     RETurn 1 : REMark ''*** Does not appear to be a FAT fount
7278 :
7280 END DEFine
7282 :
7284 :
7286 REMark ''----------------------------------------------------------
7288 REFERENCE fList$(0, 0)
7290 DEFine FuNction GetFNam$(fList$, fIndex)
7292     REMark ''LONGLINE
7294     REMark ''STRING_percent
7296     RETurn fList$(fIndex, 3 TO 2 + STRING%(fList$(fIndex, 1 TO 2)))
7298 END DEFine
7300 :
7302 :
7304 REMark ''----------------------------------------------------------
7306 REFERENCE fList$(0, 0)
7308 DEFine FuNction GetFLen(fList$, fIndex)
7310     RETurn LONGINTEGER(fList$(fIndex, _fLen TO _fTyp - 1))
7312 END DEFine
7314 :
7316 :
7318 REMark ''-----------------------------------------------------------
7320 REFERENCE fList$(0, 0)
7322 DEFine FuNction GetFTyp(fList$)
7324     REMark ''STRING_percent
7326     RETurn STRING%(fList$(fIndex, _fTyp TO _fDat - 1))
7328 END DEFine
7330 :
7332 :
7334 REMark ''-----------------------------------------------------------
7336 REFERENCE fList$(0, 0)
7338 DEFine FuNction GetFDat(fList$, fIndex)
7340     RETurn LONGINTEGER(fList$(fIndex, _fDat TO _fPar - 1))
7342 END DEFine
7344 :
7346 :
7348 REMark ''-----------------------------------------------------------
7350 REFERENCE fList$(0, 0)
7352 DEFine FuNction GetFPar(fList$, fIndex)
7354     REMark ''STRING_percent
7356     RETurn STRING%(fList$(fIndex, _fPar TO _fFlg - 1))
7358 END DEFine
7360 :
7362 :
7364 REMark ''-----------------------------------------------------------
7366 REFERENCE fList$(0, 0)
7368 DEFine FuNction GetFFlg(fList$, fIndex)
7370     REMark ''STRING_percent
7372     RETurn STRING%(fList$(fIndex, _fFlg TO _fMax))
7374 END DEFine
7376 :
7378 :
7380 REMark ''-----------------------------------------------------------
7382 REFERENCE fList$(0, 0)
7384 DEFine PROCedure PutFNam(fList$, fIndex, newVal$)
7386     LOCal nVLen
7388 :
7390     nVLen = LEN(newVal$)
7392     IF nVLen > maxFNLen THEN nVLen = maxFNLen
7394     REMark ''LONGLINE
7396     fList$(fIndex, 1 TO 2 + nVLen) = STRING$(newVal$(1 TO nVLen))
7398 END DEFine
7400 :
7402 :
7404 REMark ''-----------------------------------------------------------
7406 REFERENCE fList$(0, 0)
7408 DEFine PROCedure PutFLen(fList$, fIndex, newVal)
7410     fList$(fIndex, _fLen TO _fTyp - 1) = LONGINTEGER$(newVal)
7412 END DEFine
7414 :
7416 :
7418 REMark ''-----------------------------------------------------------
7420 REFERENCE fList$(0, 0)
7422 DEFine PROCedure PutFTyp(fList$, fIndex, newVal)
7424     fList$(fIndex, _fTyp TO _fDat - 1) = INTEGER$(newVal)
7426 END DEFine
7428 :
7430 :
7432 REMark ''-----------------------------------------------------------
7434 REFERENCE fList$(0, 0)
7436 DEFine PROCedure PutFDat(fList$, fIndex, newVal)
7438     fList$(fIndex, _fDat TO _fPar - 1) = LONGINTEGER$(newVal)
7440 END DEFine
7442 :
7444 :
7446 REMark ''-----------------------------------------------------------
7448 REFERENCE fList$(0, 0)
7450 DEFine PROCedure PutFPar(fList$, fIndex, newVal)
7452     fList$(fIndex, _fPar TO _fFlg - 1) = INTEGER$(newVal)
7454 END DEFine
7456 :
7458 :
7460 REMark ''-----------------------------------------------------------
7462 REFERENCE fList$(0, 0)
7464 DEFine PROCedure PutFFlg(fList$, fIndex, newVal)
7466     fList$(fIndex, _fFlg TO _fMax) = INTEGER$(newVal)
7468 END DEFine
7470 :
7472 :
7474 REMark ''-----------------------------------------------------------
7476 REFERENCE fList$(0, 0), fListDest$(0, 0)
7478 DEFine PROCedure CopyRec(fList$, fIndex, fListDest$, fDestIndex)
7480     fListDest$(fDestIndex, 1 TO _fMax) = fList$(fIndex, 1 TO _fMax)
7482 END DEFine
7484 :
7486 :
7488 REMark ''-----------------------------------------------------------
7490 DEFine FuNction isBasicRunning
7492     REMark ''BASIC_B_percent, BASIC_W_percent
7494     IF BASIC_B(111) <> 0
7496         RETurn 0
7498     ELSE
7500         REMark ''FIXME mixworx weird if sequences
7502         REMark ''break - Ctrl-Space pressed
7504         IF BASIC_B(143) = 0 : RETurn 0
7506         REMark ''stop occurred
7508         IF BASIC_W(104) = BASIC_W(146) : RETurn 0
7510         REMark ''Program is running
7512         RETurn 1
7514     END IF
7516 END DEFine
7518 :
7520 :
7522 REMark ''-----------------------------------------------------------
7524 DEFine FuNction isBasicProgramLoaded
7526     REMark ''BASIC_W_percent
7528     RETurn BASIC_W(BASIC_L(16))
7530 END DEFine
7532 :
7534 :
7536 REMark ''-----------------------------------------------------------
7538 REFERENCE fList$(0, 0), r_StartPos, r_Index
7540 DEFine PROCedure MoveTop(fList$, r_StartPos, r_Index, ch)
7542     LOCal top, x, size
7544 :
7546     IF ch = 7
7548         r_StartPos = LMinPos
7550     ELSE
7552         r_StartPos = RMinPos
7554     END IF
7556     r_Index = r_StartPos
7558     ListFiles fList$, r_StartPos, r_Index, ch
7560 END DEFine
7562 :
7564 :
7566 REMark ''----------------------------------------------------------
7568 REFERENCE fList$(0, 0), r_StartPos, r_Index
7570 DEFine PROCedure MoveLast(fList$, r_StartPos, r_Index, ch)
7572     LOCal top
7574 :
7576     IF ch = 7
7578         top = LMinPos
7580         r_Index = LSizeFile + LSizedir
7582     ELSE
7584         top = RMinPos
7586         r_Index = RSizeFile + RSizedir
7588     END IF
7590     r_StartPos = r_Index - 19
7592     IF r_StartPos < top THEN r_StartPos = top
7594     ListFiles fList$, r_StartPos, r_Index, ch
7596 END DEFine
7598 :
7600 :
7602 REMark ''-----------------------------------------------------------
7604 DEFine PROCedure LRUNBasic
7606     LOCal i, a$, path$, ext$
7608 :
7610     IF crtPanel = 7
7612         IF LIndex>LSizedir + LSizeFile THEN RETurn
7614         a$ = GetFNam$(LeftFiles$, LIndex)
7616         path$ = leftDir$
7618     ELSE
7620         IF RIndex > RSizedir + RSizeFile THEN RETurn
7622         a$ = GetFNam$(RightFiles$, RIndex)
7624         path$ = rightDir$
7626     END IF
7628     IF a$ == ".." OR IsDir() = 1 THEN RETurn
7630     REMark ''now get file extension
7632     x = LEN(a$)
7634     FOR i = 0 TO x - 1
7636         IF a$(x - i) == "_" THEN EXIT i
7638         NEXT i
7640     END FOR i
7642     IF i > 0
7644         ext$ = a$(x - i TO x)
7646     ELSE
7648         ext$ = ""
7650     END IF
7652     ext$ = LOWER$(ext$)
7654     IF ext$ <> "_bas" AND a$ <> "boot" THEN RETurn
7656     IF isBasicRunning = 1
7658         REMark ''LONGLINE
7660         MessageWnd 200, 60, 2, CHR$(10) & "        BASIC is running" & CHR$(10) & "       Cannot run _bas now!"
7662         RETurn
7664     END IF
7666     IF (isBasicProgramLoaded > 0) AND (isBasicProgramEdited = 1)
7668         REMark ''LONGLINE
7670         i = DlgWnd(240, 60, " Basic program loaded ", "       A Basic program is loaded" & CHR$(10) & "         Loose any changes made?")
7672         IF i = 0 THEN RETurn
7674     END IF
7676     COMMAND_LINE
7678     PAUSE 5
7680     TYPE_IN CHR$(27) & CHR$(27) & CHR$(27)
7682     PAUSE 5
7684     TYPE_IN "LRUN " & path$ & a$ & CHR$(10)
7686 END DEFine
7688 :
7690 :
7692 REMark ''-----------------------------------------------------------
7694 DEFine PROCedure SetPalletteQL
7696     REMark ''LONGLINE
7698     PALETTE_QL 0, 0, 0, 255*256*256, 255*256*256, 255*256, 255*256, 255*256*256+255*256+255, 255*256*256+255*256+255
7700 END DEFine
7702 :
7704 :
7706 REMark ''-----------------------------------------------------------
7708 DEFine FuNction isBasicProgramEdited
7710     REMark ''BASIC_B_percent
7712     IF BASIC_B(142) = 255
7714         RETurn 1
7716     ELSE
7718         RETurn 0
7720     END IF
7722 END DEFine
7724 :
7726 :
7728 REMark ''-----------------------------------------------------------
7730 DEFine FuNction CopyFullDir(name$, source$, dest$, panel, UpdateWnd, CheckNoQ, UpdateList)
7732     LOCal x, ch, loop, d$, fp, newname$, newsource$
7734     LOCal newdest$, totrim
7736 :
7738     IF DirExists(dest$ & name$) = 0
7740         REMark ''LONGLINE
7742         x = Create1Dir(name$, dest$ & name$, panel, 0, CheckNoQ, UpdateList)
7744         IF x = 0 THEN RETurn 0
7746     END IF
7748     PRINT# 0, "Copy " & source$ & name$ & " to " & dest$ & name$
7750     WCOPY source$ & name$ TO dest$ & name$
7752 :
7754     ch = FOP_DIR(source$ & name$) : REMark ''open channel to directory
7756 :
7758     IF ch < 0 THEN RETurn : REMark ''unable to open directory
7760 :
7762     fp = 14 : REMark ''file position in directory for filename
7764 :
7766     newsource$ = source$ & name$
7768     IF newsource$(LEN(newsource$)) <> "_"
7770         newsource$ = newsource$ & "_"
7772     END IF
7774     newdest$ = dest$ & name$
7776     IF newdest$(LEN(newdest$)) <> "_"
7778         newdest$ = newdest$ & "_"
7780     END IF
7782 :
7784     REPeat loop
7786         BGET# ch\fp : REMark ''FIXME mixworx \ ???
7788         REMark ''FIXME mixworx weird if sequence
7790         REMark ''use _+ as #, __+ as \ ???
7792         IF EOF(#ch) THEN CLOSE# ch : EXIT loop
7794         GET# ch, d$ : REMark ''get a directory entry name
7796         IF LEN(d$) > 0
7798             REMark ''a directory length of 0 may be a deleted file
7800             BGET# ch\fp - 9 : REMark ''file type byte ''FIXME mixworx \ ???
7802             REMark ''use _+ as #, __+ as \ ???
7804             IF CODE(INKEY$(#ch)) = 255
7806                 REMark ''this is a subdirectory
7808                 REMark ''so we need to copy this
7810 :
7812                 REMark ''Extract file name and check length
7814                 totrim = LEN(newsource$) - 4
7816                 newname$ = d$(totrim TO)
7818                 IF LEN(newdest$ & newname$) > 36
7820                     INK# 0, 2
7822                     REMark ''LONGLINE
7824                     PRINT# 0, "Directory " & newdest$ & newname$ & " not created  Name too long"
7826                     INK# 0, White
7828                 ELSE
7830                     REMark ''LONGLINE
7832                     x = CopyFullDir(newname$, newsource$, newdest$, panel, 0, 0, 0)
7834                 END IF
7836             END IF
7838         END IF
7840         fp = fp + 64
7842     END REPeat loop
7844     RETurn 1
7846 END DEFine
7848 :
7850 :
7852 REMark ''-----------------------------------------------------------
7854 DEFine PROCedure CopySingleDir(name$, source$, dest$, panel)
7856     LOCal ch, ch1, i, x, a$, Index,page
7858     LOCal id, left,windef$, hgt, wid
7860 :
7862 :
7864     IF panelWinWid * 2 > 602
7866         wid = 600
7868     ELSE
7870         wid = 400
7872     END IF
7874     hgt = panelWinHeight * 8 DIV 10
7876     left = (maxWinWid - wid) DIV 2
7878     windef$ = "scr_" & wid & "x" & hgt & "a" & left & "x50"
7880     ch = FOPEN(windef$)
7882     PAPER# ch, 0
7884     INK# ch, White
7886     OUTLN# ch, wid, hgt, left, 50
7888     BORDER# ch, 1, 2
7890     CLS# ch
7892     left = left + 1
7894     windef$ = "scr_" & (wid - 2) & "x12a" & left & "x51"
7896     ch1 = FOPEN(windef$)
7898     BORDER# ch1, 1 , 2
7900     PAPER# ch1, 0, 2, 1
7902     CLS# ch1
7904     PAPER# ch1, 0
7906     INK# ch1, White
7908     CURSOR# ch1, (wid - 90) DIV 2, 0
7910     PRINT# ch1, " Copy Directory "
7912     WINDOW# 0, wid - 4, hgt - 16, left + 1, 63
7914     PAPER# 0, 0
7916     INK# 0, White
7918     CLS# 0
7920     REMark ''LONGLINE
7922     PRINT# 0, "Copy Directory " & source$ & name$ & " to " & dest$
7924     res = CopyFullDir(name$, source$, dest$, panel, 0, 1, 0)
7926     INK# 0, Green
7928     REMark ''LONGLINE
7930     PRINT# 0, "Copy process ended - press any key to close window"
7932     INK# 0, White
7934     x = KEYROW(0)
7936     a$ = INKEY$(-1)
7938     WINDOW# 0, 448, 12, 32, 231:
7940     CLOSE# ch1
7942     OUTLN# ch, wid, hgt, left - 1, 50
7944     CLOSE# ch
7946 :
7948     REMark ''if copy OK then Add the dir name to the list
7950     REMark ''in the destination panel and refresh screen
7952     IF res = 1
7954         IF panel = 8
7956             res = FIND(name$, id, RightFiles$, 1, RSizedir)
7958             IF res = 0
7960                 REMark ''LONGLINE
7962                 res = Insert(name$, id, RightFiles$, 1, RSizedir, RSizeFile, "0")
7964                 RIndex = id
7966                 id = id + (RMinPos = 0)
7968                 page = id DIV rowno
7970                 IF id MOD rowno > 0
7972                     page = page + 1
7974                 END IF
7976                 RStartPos = (page - 1) * rowno + RMinPos
7978                 ListFiles RightFiles$, RStartPos, RIndex, 8
7980             END IF
7982         ELSE
7984             res = FIND(name$, id, LeftFiles$, 1, LSizedir)
7986             IF res = 0
7988                 REMark ''LONGLINE
7990                 res = Insert(name$, id, LeftFiles$, 1, LSizedir, LSizeFile, "0")
7992                 LIndex = id
7994                 id = id + (LMinPos = 0)
7996                 page = id DIV rowno
7998                 IF id MOD rowno > 0
8000                     page = page + 1
8002                 END IF
8004                 LStartPos = (page - 1) * rowno + LMinPos
8006                 ListFiles LeftFiles$, LStartPos, LIndex, 7
8008             END IF
8010         END IF
8012     END IF
8014 END DEFine
8016 :
8018 :
8020 REMark ''----------------------------------------------------------
8022 DEFine FuNction DeleteDirectory(source$, name$)
8024     LOCal ch, loop, d$, newsource$, newname$, fp, totrim, x
8026 :
8028     IF name$(LEN(name$)) <> "_" THEN name$ = name$ & "_"
8030     PRINT# 0, "Deleting directory " & source$ & name$ & "..."
8032     WDEL source$ & name$
8034     ch = FOP_DIR(source$ & name$) : REMark ''open channel to directory
8036     IF ch < 0 THEN RETurn : REMark ''unable to open directory
8038     fp = 14 : REMark ''file position in directory for filename
8040     newsource$ = source$ & name$
8042     IF newsource$(LEN(newsource$)) <> "_"
8044         newsource$ = newsource$ & "_"
8046     END IF
8048     REPeat loop
8050         BGET# ch\fp : REMark ''FIXME mixworx \ ???
8052         REMark ''FIXME mixworx weird if sequence
8054         REMark ''use _+ as #, __+ as \ ???
8056         IF EOF(#ch) THEN CLOSE# ch : EXIT loop
8058         GET# ch, d$ : REMark ''get a directory entry name
8060         IF LEN(d$) > 0
8062             REMark ''a directory length of 0 may be a deleted file
8064             BGET# ch\fp - 9 : REMark ''file type byte ''FIXME mixworx \ ???
8066             REMark ''use _+ as #, __+ as \ ???
8068             IF CODE(INKEY$(#ch)) = 255
8070                 REMark ''this is a subdirectory
8072                 REMark ''so we need to delete this
8074 :
8076                 REMark ''Extract file name and check length
8078                 totrim = LEN(newsource$) - 4
8080                 newname$ = d$(totrimto)
8082                 x = DeleteDirectory(newsource$, newname$)
8084             END IF
8086         END IF
8088         fp = fp + 64
8090     END REPeat loop
8092 :
8094     REMark ''Now check that directory is empty
8096     IF isDirEmpty(source$ & name$) = 1
8098         DELETE source$ & name$
8100         RETurn 1
8102     ELSE
8104         RETurn 0
8106     END IF
8108 END DEFine
8110 :
8112 :
8114 REMark ''----------------------------------------------------------
8116 DEFine FuNction isDirEmpty(DirName$)
8118     LOCal ch, fp, d$, loop, res
8120 :
8122     ch = FOP_DIR(DirName$) : REMark ''open channel to directory
8124     IF ch < 0 THEN RETurn 0: REMark ''unable to open directory
8126     res = 1
8128     fp = 14 : REMark ''file position in directory for filename
8130     REPeat loop
8132         BGET# ch\fp : REMark ''FIXME mixworx \ ???
8134         REMark ''FIXME mixworx weird if sequences
8136         REMark ''use _+ as #, __+ as \ ???
8138         IF EOF(#ch) THEN : EXIT loop
8140         GET# ch, d$ : REMark ''get a directory entry name
8142         IF LEN(d$) > 0 THEN res = 0: EXIT loop
8144         REMark ''if file name >0 then we found a file
8146         REMark ''and we set result to 1
8148         fp = fp + 64
8150     END REPeat loop
8152     CLOSE# ch
8154     RETurn res
8156 END DEFine
8158 :
8160 :
8162 REMark ''----------------------------------------------------------
8164 DEFine PROCedure CompareDirs
8166     LOCal i, res
8168 :
8170     REMark ''Unselect all left files
8172     FOR i = 1 TO LSizedir + LSizeFile
8174         IF GetFFlg(LeftFiles$, i) > 1
8176             REMark ''LONGLINE
8178             PutFFlg LeftFiles$, i, GetFFlg(LeftFiles$, i) ^^ 2
8180         END IF
8182     END FOR i
8184 :
8186     REMark ''Select all right files
8188     FOR i = 1 TO RSizedir + RSizeFile
8190         IF GetFFlg(RightFiles$, i) < 2
8192             REMark ''LONGLINE
8194             PutFFlg RightFiles$, i, GetFFlg(RightFiles$, i) ^^ 2
8196         END IF
8198     END FOR i
8200 :
8202     REMark ''Parse left directory list and compare it to right
8204     FOR i = 1 TO LSizedir
8206         REMark ''LONGLINE
8208         res = FIND(GetFNam$(LeftFiles$, i), id, RightFiles$, 1, RSizedir)
8210         IF res = 0
8212             REMark ''LONGLINE
8214             PutFFlg LeftFiles$, i, GetFFlg(LeftFiles$, i) ^^ 2
8216         ELSE
8218             REMark ''LONGLINE
8220             PutFFlg RightFiles$, id, GetFFlg(RightFiles$, id) ^^ 2
8222         END IF
8224         NEXT i
8226     END FOR i
8228 :
8230     REMark ''Parse left file list and compare it to right
8232     FOR i = LSizedir + 1 TO LSizedir + LSizeFile
8234         REMark ''LONGLINE
8236         res = FIND(GetFNam$(LeftFiles$, i), id, RightFiles$, RSizedir + 1, RSizedir + RSizeFile)
8238         IF res = 0
8240             PutFFlg LeftFiles$,i, GetFFlg(LeftFiles$,i) ^^2
8242         ELSE
8244             REMark ''LONGLINE
8246             IF GetFLen(LeftFiles$, i) = GetFLen(RightFiles$, id)
8248                 REMark ''LONGLINE
8250                 PutFFlg RightFiles$, id, GetFFlg(RightFiles$, id) ^^ 2
8252             ELSE
8254                 REMark ''LONGLINE
8256                 PutFFlg LeftFiles$, i, GetFFlg(LeftFiles$, i) ^^ 2
8258             END IF
8260         END IF
8262         NEXT i
8264     END FOR i
8266 :
8268     REMark ''refresh screen
8270     ListFiles LeftFiles$, LStartPos, LIndex, 7
8272     ListFiles RightFiles$, RStartPos, RIndex, 8
8274 END DEFine
8276 :
8278 :
8280 REMark ''----------------------------------------------------------
8282 DEFine PROCedure InvertSelection
8284     LOCal i
8286 :
8288     IF crtPanel = 7
8290         FOR i = 1 TO LSizedir + LSizeFile
8292             REMark ''LONGLINE
8294             PutFFlg LeftFiles$, i, GetFFlg(LeftFiles$, i) ^^ 2
8296         END FOR i
8298         ListFiles LeftFiles$, LStartPos, LIndex, 7
8300     ELSE
8302         FOR i = 1 TO RSizedir + RSizeFile
8304             REMark ''LONGLINE
8306             PutFFlg RightFiles$, i, GetFFlg(RightFiles$, i) ^^ 2
8308         END FOR i
8310         ListFiles RightFiles$, RStartPos, RIndex, 8
8312     END IF
8314 END DEFine
8316 :
8318 :
8320 :
8322 :
32600 REMark &&QLCGEN ShellCommands
32602 DEFine PROCedure QLC_INIT
32604     QLC_GlobalFilename$ = 'dos1_QLC_qlc20x_bas'
32616     XX = RESPR(1024) : LBYTES "dos1_tk_MORE_CODE", XX : CALL XX
32618     XX = RESPR(1538) : LBYTES "dos1_qlc_QLC_CODE", XX : CALL XX
32620     LRESPR "dos1_tk_TURBO_SMS_CODE"
32622 END DEFine
32624 :
32626 DEFine PROCedure r
32628     RUN
32630 END DEFine
32632 DEFine PROCedure e
32634     WTV
32636     PAPER# 2, 0 : INK# 2, 4 : TYPE_IN "ED" & CHR$(10)
32638 END DEFine
32640 DEFine PROCedure x
32642     s : QUIT
32644 END DEFine
32646 DEFine PROCedure q
32648     QUIT
32650 END DEFine
32652 DEFine PROCedure s
32653     TYPE_IN "1 REMark &&SSBGEN &&SAVE" & CHR$(10)
32654     SAVE_O QLC_GlobalFilename$
32656     PRINT# 2, QLC_GlobalFilename$ & " SAVED"
32658 END DEFine
32660 DEFine PROCedure l
32662     LOAD QLC_GlobalFilename$
32664     PRINT# 2, QLC_GlobalFilename$ & " LOADED"
32666 END DEFine
32668 DEFine PROCedure w
32670     WMOV
32672 END DEFine
32674 DEFine PROCedure u
32676     REMark DLINE 32600 TO
32678     TYPE_IN "MERGE dos1_qlc_cmd_bas" & CHR$(10)
32680 END DEFine
32682 DEFine PROCedure h
32684     PRINT# 0, "CMD: h/W/n/r/e/x/q/s/l/u"
32686 END DEFine
32688 DEFine PROCedure n(i)
32690     IF i = 0 THEN i = 1
32692     TYPE_IN "RENUM 10 TO 32599; 1000, " & i & CHR$(10)
32694 END DEFine
32696 DEFine PROCedure dbginit
32698     OPEN# 99, "scr_"
32700     WINDOW# 99, 120, 16, 0, 0 : PAPER# 99, 0 : INK# 99, 7
32702 END DEFine
32704 DEFine PROCedure dbg(s$)
32706     PAPER# 99, 7 : INK# 99, 2 : PRINT# 99, s$
32708 END DEFine
32710 DEFine PROCedure dbgstop
32712     STOP
32714 END DEFine
