1 REMark &&SSBGEN
10 :
12 REMark '' VER 231124_1913
14 :
16 QLC_INIT
18 :
20 KCtrlA = 1
22 KDown = 216
24 KUp = 208
26 KShiftDown = 220
28 KTab = 9
30 KShiftF5 = 250
32 KSpace = 32
34 KShiftUp = 212
36 KEnter = 10
38 KShiftEnter = 254
40 KBackSpace = 194
42 KCtrlUp = 210
44 KCtrlDown = 218
46 KCtrlD = 4
48 KCtrlR = 18
50 KF1 = 232
52 KF2 = 236
54 KF3 = 240
56 KF4 = 244
58 KF5 = 248
60 KF6ShiftF1 = 234
62 KF7ShiftF2 = 238
64 KF8ShiftF3 = 242
66 KF9ShiftF4 = 246
68 KF10ShiftF5 = 250
70 KPlus = 43
72 KMinus = 45
74 KEqual = 61
76 KUnderscore = 95
78 KCtrlI = 92
80 KCtrlW = 23
82 KCtrlX = 24
84 KCtrl1 = 145
86 KCtrl2 = 146
88 KHome = 193
90 KEnd = 201
92 KPageUp = 212
94 KPageDown = 220
96 :
98 :
100 :
102 :
104 REMark ''******************************************
106 REMark ''*        QLX   C O M M A N D E R         *
108 REMark ''*                                        *
110 REMark ''*              version 2.1               *
112 REMark ''*          code date 2023.11.13          *
114 REMark ''*                                        *
116 REMark ''*              Andrei Tenu               *
118 REMark ''*              Martyn Hill               *
120 REMark ''*                7alken                  *
122 REMark ''******************************************
124 :
126 :
128 REMark ''*** QLiberator Directives...
130 REMark ''$$stak=5120
132 :
134 :
136 REMark ''*** TURBO Directives...
138 REMark '' - also comment line 1370! And modify line 3010
140 REMark ''TURBO_locstr "R"
142 REMark ''TURBO_ref
144 REMark ''TURBO_windo 2
146 REMark ''TURBO_optim "B"
148 REMark ''TURBO_model 1
150 REMark ''TURBO_struct "S"
152 REMark ''TURBO_diags "I"
154 REMark ''TURBO_list "YES"
156 REMark ''TURBO_sound "YES"
158 REMark ''TURBO_objdat 64
160 REMark ''TURBO_buffersz 16
162 REMark ''TURBO_objstk 512
164 REMark ''TURBO_taskn "QLC v2.0"
166 REMark ''TURBO_objfil "win1_QLCommander_QLC_exe"
168 REMark ''TURBO_repfil "win1_QLCommander_QLCv20_rpt"
170 :
172 :
174 WHEN ERRor
176     REMark ''CloseProgram
178     PAPER# 1, 7
180     INK# 1, 2
182     PAPER# 0, 0
184     INK# 0, 4
186     CLS# 0
188     PRINT# 1, "Error at line: "; ERLIN
190     REPORT
192     STOP
194 END WHEN
196 :
198 REMark ''mode 4: paper#0,0:paper#1,0:paper#2,0:border#1,0:cls#1
200 REMark ''window#1,488,220,12,0
202 :
204 REMark ''----------------------------------------------------------
206 REMark ''recompilation QLXC from ssb source
208 DEFine PROCedure c
210     LOCal ssb_fn$, test_fn$
212 :
214     ssb_fn$ = "dos1_QLC_qlxc_ssb"
216     bas_fn$ = ssb_fn$(1 TO LEN(ssb_fn$) - 4) & "_bas"
218 :
220     PRINT #0, "Compiling SSB to BAS ..."
222     CompileSsb2Bas ssb_fn$, bas_fn$
224 :
226 :
228     TYPE_IN "l" & CHR$(10) : REMark ''reload bas
230     AttachBasFileShell bas_fn$
232     REMark ''print #0, "Attaching QLXC Shell ..."
234     TYPE_IN "r" & CHR$(10) : REMark ''run
236     REMark ''print #0, "Test ..."
238 END DEFine
240 :
242 xc
244 :
246 REMark ''----------------------------------------------------------
248 DEFine PROCedure xc
250 :
252     qlcVer$ = "2.1"
254     REMark ''Make sure that guardian window covers all screen,
256     REMark ''in all resolutions
258     IF VER$="HBA_xx" THEN  : REMark ''FIXME mixworx
260         maxWinWid% = SCR_XLIM
262         maxWinHgt% = SCR_YLIM
264     ELSE
266         maxWinWid% = 512
268         maxWinHgt% = 256
270         REMark ''make sure we are in monitor mode 4,
272         REMark ''otherwise it will crash
274         WMON
276         MODE 4
278         PAPER# 0, 0
280         PAPER# 1, 0
282         BORDER# 1, 0
284         CLS# 1
286         CLS# 0
288     END IF
290     REMark ''comment next line if compiled with Turbo !
292     PAPER# 0, 0
294     BORDER# 0, 0
296     PAPER# 1, 0
298     BORDER# 1, 0
300     PAPER# 2, 0
302     BORDER# 2, 0
304     CLS# 0
306     CLS# 1
308     CLS# 2
310     WINDOW# 0, maxWinWid%, maxWinHgt%, 0, 0
312     OUTLN# 0, maxWinWid%, maxWinHgt%, 0, 0, 0, 0, 0
314 :
316 :
318     dbginit
320     readConfig
322     InitialiseVars
324     OpenWindows
326     DrawWindows 1
328     MainLoop
330     CloseProgram
332 :
334     STOP
336 END DEFine
338 :
340 REMark ''----------------------------------------------------------
342 DEFine PROCedure StopWithError(errorMessage$)
344 :
346     BEEP 1390 * 2, 20
348     REMark ''cls #0
350     PRINT #0, errorMessage$
352     PAUSE 50 * 2
354     CloseProgram
356     STOP
358 END DEFine
360 :
362 :
364 REMark ''-----------------------------------------------------------
366 DEFine PROCedure CloseProgram
368     LOCal ch%
370 :
372     FOR ch% = 3 TO 9 : CLOSE# ch% : END FOR ch%
374 :
376     IF headBuff > 0 THEN RECHP(headBuff)
378     IF titleFountBase > 0 THEN RECHP titleFountBase
380     IF mainFountBase > 0 THEN RECHP mainFountBase
382     IF comFountBase > 0 THEN RECHP comFountBase
384 :
386     DATA_USE initialDATAD$
388 :
390     WINDOW# 0, maxWinWid%, maxWinHgt%, 0, 0
392     PAPER# 0, 0
394     INK# 0, White%
396     CLS# 0
398 :
400     WINDOW# 0, 512, 50, 0, 206
402     BORDER# 0, 1, 1, 7, 0
404     CLS# 0
406 :
408     WINDOW# 1, 256, 202, 256, 0
410     BORDER# 1, 1, 1, 7, 0
412     PAPER# 1, 7
414     INK# 1, 0
416     CLS# 1
418 :
420     WINDOW# 2, 256, 202, 0, 0
422     BORDER# 2, 1, 1, 7, 0
424     PAPER# 2, 2
426     INK# 2, 7
428     CLS# 2
430 :
432 END DEFine
434 :
436 :
438 REMark ''-----------------------------------------------------------
440 DEFine PROCedure OpenWindows
442     LOCal ch%, titleFountFN$(36), titleFountLen%
444     LOCal mainFountFN$(36), mainFountLen%
446     LOCal comFountFN$(36), comFountLen%
448 :
450     stdFountWid%=6
452 :
454     FOR ch% = 3 TO 9 : OPEN# ch%, con : END FOR ch%
456 :
458     titleFountWid% = stdFountWid%
460     titleFountBase = 0
462     titleFountFN$ = ConfigDrv$ & "bold8_fnt"
464 :
466     IF FTEST(titleFountFN$) = 0
468         titleFountLen% = FLEN(\titleFountFN$)
470         IF titleFountLen% > 0
472             titleFountBase = ALCHP(titleFountLen%)
474             LBYTES titleFountFN$, titleFountBase
476             titleFountWid% = 8
478             CHAR_USE# titleWin%, titleFountBase, 0
480             CSIZE# titleWin%,1,0
482             CHAR_INC# titleWin%, titleFountWid%, 10
484         END IF
486     END IF
488 :
490     mainFountWid% = stdFountWid%
492     mainFountBase = 0
494     mainFountFN$ = ConfigDrv$ & "5Pixel_fnt"
496     IF FTEST(mainFountFN$) = 0
498         mainFountLen% = FLEN(\mainFountFN$)
500         IF mainFountLen% > 0
502             mainFountBase = ALCHP(mainFountLen%)
504             LBYTES mainFountFN$, mainFountBase
506         END IF
508     END IF
510 :
512     SELect ON ClassicFont%
514       = 0:
516           IF mainFountBase > 0
518               mainFountWid% = 5 : mainFountHeight% = 10
520               CHAR_USE# leftPanelWin%, mainFountBase, 0
522               CHAR_INC# leftPanelWin%, mainFountWid%, 10
524               CHAR_USE# rightPanelWin%, mainFountBase, 0
526               CHAR_INC# rightPanelWin%, mainFountWid%, 10
528           ELSE
530               mainFountWid% = 6
532               mainFountHeight% = 10
534               comFountWid% = stdFountWid%
536           END IF
538 :
540       = 1:
542           CSIZE# leftPanelWin%, 0, 0
544           CSIZE# rightPanelWin%, 0, 0
546           mainFountWid% = 6
548           mainFountHeight% = 10
550           comFountWid% = stdFountWid%
552 :
554       = 2:
556           mainFountWid% = 8
558           mainFountHeight% = 20
560           comFountWid% = 8
562           titleFountWid% = 16
564           CSIZE# leftPanelWin%, 1, 1
566           CSIZE# rightPanelWin%, 1, 1
568           CSIZE# titleWin%, 3, 1
570           CSIZE# 4, 1, 1 : CSIZE# 5, 1, 1
572           CSIZE# 6, 1, 1 : CSIZE# 9, 1, 1
574 :
576       = 3:
578           mainFountWid% = 12
580           mainFountHeight% = 20
582           titleFountWid% = 16
584           comFountWid% = 8
586           CSIZE# leftPanelWin%, 2, 1
588           CSIZE# rightPanelWin%, 2, 1
590           CSIZE# titleWin%, 3, 1
592           CSIZE# 4, 2, 1 : CSIZE# 5, 2, 1
594           CSIZE# 6, 2, 1 : CSIZE# 9, 1, 1
596     END SELect
598 :
600     REMark ''comFountWid%=stdFountWid%
602     comFountBase = 0
604     comFountFN$=ConfigDrv$ & "qlc_fnt"
606 :
608     IF FTEST(comFountFN$) = 0
610         comFountLen% = FLEN(\comFountFN$)
612         IF comFountLen% > 0
614             comFountBase = ALCHP(comFountLen%)
616             LBYTES comFountFN$, comFountBase
618             CHAR_USE# comWin%, comFountBase, 0
620         END IF
622     END IF
624 :
626 END DEFine
628 :
630 :
632 REMark ''-----------------------------------------------------------
634 REMark ''reload% = 1 we reload the file lists and draw the windows;
636 REMark ''reload%==0 we do not reload the file lists,
638 REMark ''just redraw the windows
640 DEFine PROCedure DrawWindows(reload%)
642     LOCal left%
644     LOCal ch%, w%, h%, x%, y%, c%, px%, py%
646 :
648     IF (linelen% * mainFountWid% + 2) > (maxWinWid% DIV 2)
650         linelen%=((maxWinWid% DIV 2) - 4) DIV mainFountWid%
652     END IF
654     panelWinWid% = linelen% * mainFountWid% + 2
656     comWinWid% = 2 * panelWinWid%
658     left% = (maxWinWid% - 2 * panelWinWid%) DIV 2
660 :
662     REMark ''title line
664     ch% = 3
666     x% = 2 * panelWinWid%
668     y% = mainFountHeight% + 2
670     px% = left%
672     py% = 5
674     WINDOW# ch%, x%, y%, px%, py%
676     BORDER# ch%, 1, TitleBorder%
678     PAPER# ch%, TitleBorder%, TitleBk%, 1
680     CLS# ch%
682 :
684     PAPER# ch%, 0
686     INK# ch%, 2
688     IF ClassicFont% >= 2
690         CSIZE# titleWin%, 3, 1
692     ELSE
694         CSIZE# titleWin%, 1, 0
696     END IF
698     CHAR_INC# titleWin%, titleFountWid%, 10
700 :
702 :
704     REMark ''FIXME long lines, use vars here !!!!!!
706     REMark ''LONGLINE
708     ch% = 3
710     w% = titleFountWid% * 14
712     h% = mainFountHeight%
714     x% = (2 * panelWinWid% - 4 - 14 * titleFountWid%) DIV 2
716     y% = 0
718     c% = 0
720     BLOCK# ch%, w%, h%, x%, y%, c%
722     x% = (2 * panelWinWid% - 4 - 14 * titleFountWid%) DIV 2
724     y% = 0
726     CURSOR# ch%, x%, y%
728     PRINT# ch%, " QLX COMMANDER "
730 :
732     REMark ''Drive line
734     REMark ''LONGLINE
736     ch% = 4
738     x% = 2 * panelWinWid%
740     y% = mainFountHeight% + 2
742     px% = left%
744     py% = mainFountHeight% + 7
746     WINDOW# ch%, x%, y%, px%, py%
748     PAPER# ch%, brd%
750     INK# ch%, 0
752     BORDER# ch%, 1, brd%
754     CLS# ch%
756 :
758     AT# ch%, 0, 0
760     INK# ch%, 2
762     PRINT# ch%, "D"
764     AT# ch%, 0, 1
766     INK# ch%, 0
768     PRINT# ch%, "ir"
770     CURSOR# ch%, panelWinWid%, 0
772     PRINT# ch%, "Di"
774     INK# ch%, 2
776     CURSOR# ch%, panelWinWid% + mainFountWid% * 2, 0
778     PRINT# ch%, "r"
780 :
782     REMark ''left dir
784     REMark ''LONGLINE
786     ch% = 5
788     x% = panelWinWid% - 4 * mainFountWid%
790     y% = mainFountHeight%
792     px% = left% + 4 * mainFountWid% - 2
794     py% = mainFountHeight% + 8
796     WINDOW# ch%, x%, y%, px%, py%
798     PAPER# ch%, White%
800     INK# ch%, 0
802     BORDER# ch%, 0
804     CLS# ch%
806     PRINT# ch%, leftDir$
808 :
810     REMark ''right dir
812     REMark ''LONGLINE
814     ch% = 6
816     x% = panelWinWid% - 4 * mainFountWid%
818     y% = mainFountHeight%
820     px% = left% + panelWinWid% + 4 * mainFountWid% - 2
822     py% = mainFountHeight% + 8
824     WINDOW# ch%, x%, y%, px%, py%
826     PAPER# ch%, White%
828     INK# ch%, 0
830     BORDER# ch%, 0
832     CLS# ch%
834     PRINT# ch%, rightDir$
836 :
838     panelWinHeight% = rowno% * mainFountHeight% + 3
840     IF panelWinHeight% + 3 * mainFountHeight% + 19 > maxWinHgt%
842         REMark ''LONGLINE
844         rowno% = (maxWinHgt% - 3 * mainFountHeight% - 22) DIV mainFountHeight%
846         panelWinHeight% = rowno% * mainFountHeight% + 3
848     END IF
850 :
852     REMark ''left file panel
854     REMark ''LONGLINE
856     ch% = 7
858     x% = panelWinWid%
860     y% = panelWinHeight%
862     px% = left%
864     py% = 2 * mainFountHeight% + 9
866     WINDOW# ch%, x%, y%, px%, py%
868     PAPER# ch%, ppr%
870     INK# ch%, ik%
872     BORDER# ch%, 1, brd%
874     CLS# ch%
876 :
878     REMark ''Right file panel
880     REMark ''LONGLINE
882     ch% = 8
884     x% = panelWinWid%
886     y% = panelWinHeight%
888     px% = panelWinWid% + left%
890     py% = 2 * mainFountHeight% + 9
892     WINDOW# ch%, x%, y%, px%, py%
894     PAPER# ch%, ppr%
896     INK# ch%, ik%
898     BORDER# ch%, 1, brd%
900     CLS# ch%
902 :
904     REMark ''Commands line
906     REMark ''LONGLINE
908     ch% = 9
910     x% = 2 * panelWinWid%
912     y% = mainFountHeight% + 2
914     px% = left%
916     py% = panelWinHeight% + 3 * mainFountHeight% + 7
918     WINDOW# ch%, x%, y%, px%, py%
920     PAPER# ch%, brd%
922     INK# ch%, White%
924     BORDER# ch%, 1, brd%
926     CLS# ch%
928 :
930     WriteCommands comWin%
932 :
934     crtPanel% = leftPanelWin%
936     IF reload% = 1
938         LShowLeftDir
940         LShowRightDir
942     ELSE
944         ListFiles LeftFiles$, LStartPos%, LIndex%, 7
946         ListFiles RightFiles$, RStartPos%, RIndex%, 8
948     END IF
950 END DEFine
952 :
954 :
956 REMark ''-----------------------------------------------------------
958 DEFine PROCedure readConfig
960     LOCal a$(42), Chan%
962 :
964     ConfigDrv$ = OPTION_CMD$ : REMark ''CMD$
966 :
968     IF ConfigDrv$ = "" THEN ConfigDrv$ = "dos1_qlc_"
970 :
972     a$ = ConfigDrv$ & "qlc20_cfg"
974 :
976     Chan% = FOP_IN(a$)
978 :
980     IF Chan% > 0
982         INPUT# Chan%, MaxFiles%
984         INPUT# Chan%, TempDir$
986         INPUT# Chan%, leftDir$
988         INPUT# Chan%, rightDir$
990         INPUT# Chan%, Qubide%
992         INPUT# Chan%, ClassicFont%
994         INPUT# Chan%, linelen%
996         INPUT# Chan%, rowno%
998         INPUT# Chan%, Xchangepath$
1000         INPUT# Chan%, Xchangeprog$
1002         INPUT# Chan%, EditPath$
1004         INPUT# Chan%, Editprog$
1006         INPUT# Chan%, QLColors%
1008         CLOSE# Chan%
1010     ELSE
1012         CLS
1014         PRINT "Config file not found - using default values ! "
1016         MaxFiles% = 256
1018         TempDir$ = "win1_temp_"
1020         leftDir$ = "win1_"
1022         rightDir$ = "win1_"
1024         Qubide% = 0
1026         ClassicFont% = 1
1028         linelen% = 40
1030         rowno% = 20
1032         Xchangepath$ = ""
1034         Xchangeprog$ = ""
1036         EditPath$ = ""
1038         Editprog$ = ""
1040         QLColors = 1
1042         PAUSE 100
1044         CLS
1046     END IF
1048 :
1050     IF RMODE <= 8 OR QLColors% = 1
1052         IF VER$ = "HBA" AND RMODE > 4
1054             COLOUR_QL
1056             SetPalletteQL
1058         END IF
1060         ppr% = 0
1062         brd% = 4
1064         ik% = 7
1066         strp% = 7
1068         White% = 7
1070         Green% = 4
1072         PPR9a% = 2
1074         ppr9b% = 0
1076         TitleBorder% = 4
1078         TitleBk% = 0
1080     ELSE
1082         COLOUR_PAL
1084         ppr% = 4
1086         brd% = 13
1088         ik% = 1
1090         strp% = 13
1092         White% = 1
1094         Green% = 3
1096         PPR9a% = 72
1098         ppr9b% = 76
1100         TitleBorder% = 13
1102         TitleBk% = 4
1104     END IF
1106 :
1108     IF maxWinHgt% = 256 AND ClassicFont% > 1
1110         ClassicFont% = 1
1112     END IF
1114 END DEFine
1116 :
1118 :
1120 REMark ''------------------------------------------------------------
1122 DEFine PROCedure InitialiseVars
1124     titleWin% = 3
1126     leftPanelWin% = 7
1128     rightPanelWin% = 8
1130     comWin% = 9
1132     LSizedir% = 0
1134     LSizeFile% = 0
1136     crtPanel% = leftPanelWin%
1138     RSizedir% = 0
1140     RSizeFile% = 0
1142 :
1144     maxFNLen% = 36
1146 :
1148     _fLen% = maxFNLen% + 3
1150     _fTyp% = maxFNLen% + 7
1152     _fDat% = maxFNLen% + 9
1154     _fPar% = maxFNLen% + 13
1156     _fFlg% = maxFNLen% + 15
1158     _fMax% = maxFNLen% + 16
1160 :
1162     _dPar% = maxFNLen% + 3
1164     _dNxt% = maxFNLen% + 5
1166     _dChd% = maxFNLen% + 7
1168     _dFlg% = maxFNLen% + 9
1170     _dMax% = maxFNLen% + 10
1172 :
1174     DIM cmdText$(9,9) : REMark ''Used by WriteCommands
1176     cmdText$(1) = CHR$(1) & " Info"
1178     cmdText$(2) = CHR$(2) & " Comp"
1180     cmdText$(3) = CHR$(3) & " View"
1182     cmdText$(4) = CHR$(4) & " Edit"
1184     cmdText$(5) = CHR$(5) & " Copy"
1186     cmdText$(6) = CHR$(6) & " Rename"
1188     cmdText$(7) = CHR$(7) & " MkDir"
1190     cmdText$(8) = CHR$(8) & " Delete"
1192     cmdText$(9) = CHR$(9) & " Exit"
1194 :
1196     initialDATAD$ = DATAD$
1198 :
1200     headSz% = 64
1202     headBuff = ALCHP(headSz%)
1204     IF headBuff < 0
1206         REMark ''LONGLINE
1208         StopWithError("Cannot allocate memory for File-header Buffer.")
1210     END IF
1212 :
1214 END DEFine
1216 :
1218 :
1220 REMark ''-----------------------------------------------------------
1222 DEFine PROCedure LShowLeftDir
1224     LOCal i%
1226 :
1228     REMark ''dim LeftFiles$(MaxFiles%,2,36)
1230     DIM LeftFiles$(MaxFiles%, _fMax%)
1232 :
1234     LoadDir leftDir$, LeftFiles$, 7, LSizedir%, LSizeFile%
1236 :
1238     IF LEN(leftDir$) = 5
1240         LStartPos% = 1
1242     ELSE
1244         LStartPos% = 0
1246     END IF
1248     LIndex% = LStartPos%
1250     LMinPos% = LStartPos%
1252     ListFiles LeftFiles$, LStartPos%, LIndex%, 7
1254 END DEFine
1256 :
1258 :
1260 REMark ''-----------------------------------------------------------
1262 DEFine PROCedure LShowRightDir
1264     LOCal i%
1266 :
1268     DIM RightFiles$(MaxFiles%, _fMax%)
1270 :
1272     RSizedir% = 0
1274     RSizeFile% = 0
1276     LoadDir rightDir$, RightFiles$, 8, RSizedir%, RSizeFile%
1278     IF LEN(rightDir$) = 5
1280         RStartPos% = 1
1282     ELSE
1284         RStartPos% = 0
1286     END IF
1288     RIndex% = RStartPos%
1290     RMinPos% = RStartPos%
1292     ListFiles RightFiles$, RStartPos%, RIndex%, 8
1294 END DEFine
1296 :
1298 :
1300 REMark ''-----------------------------------------------------------
1302 REMark ''reference FileList$(0,0,0)
1304 REFERENCE FileList$(0,0)
1306 DEFine PROCedure ListFiles(FileList$, StartPos%, Index%, ch%)
1308     LOCal a$(linelen%), i%, size%, EndPos%
1310     LOCal nochars%, x%, DFlen1%, DFLen2%
1312 :
1314     IF ch% = 7
1316         size% = LSizedir% + LSizeFile%
1318     ELSE
1320         size% = RSizedir% + RSizeFile%
1322     END IF
1324     EndPos% = StartPos% + rowno% - 1
1326     IF EndPos% > size% THEN EndPos% = size%
1328 :
1330     CLS# ch%
1332     FOR i% = StartPos% TO EndPos%
1334         a$ = GetFNam$(FileList$, i%)
1336         DFlen1% = LEN(a$)
1338         DFLen2% = LEN(GetFLen(FileList$, i%))
1340         IF GetFFlg%(FileList$,i%) MOD 2 = 1
1342             x% = 3
1344             IF DFlen1% > linelen% - x%
1346                 a$ = a$(TO linelen% - x% - 2)
1348                 a$ = a$ & ".."
1350             END IF
1352             a$ = a$ & " ->"
1354             a$ = a$ & FILL$(" ", linelen% - LEN(a$) - 1)
1356         ELSE
1358             x% = 9
1360             IF DFlen1% > linelen% - x%
1362                 a$ = a$(TO linelen% - x% - 2)
1364                 a$ = a$ & ".."
1366             END IF
1368             REMark ''LONGLINE
1370             a$ = a$ & FILL$(" ", linelen% - LEN(a$) - DFLen2% - 1)
1372             a$ = a$ & GetFLen(FileList$,i%)
1374         END IF
1376 :
1378         INK# ch%, ik%
1380         IF i% = Index%
1382             IF crtPanel% = ch%
1384                 STRIP# ch%, strp%
1386                 IF GetFFlg%(FileList$, i%) > 1
1388                     INK# ch%, 2
1390                 ELSE
1392                     INK# ch%, ppr%
1394                 END IF
1396                 PRINT# ch%, a$
1398                 STRIP# ch%, ppr%
1400             ELSE
1402                 PRINT# ch%, a$
1404             END IF
1406         ELSE
1408             IF GetFFlg%(FileList$, i%) > 1
1410                 INK# ch%, 2
1412             ELSE
1414                 INK# ch%, ik%
1416             END IF
1418             PRINT# ch%, a$
1420         END IF
1422     END FOR i%
1424 END DEFine
1426 :
1428 :
1430 REMark ''-----------------------------------------------------------
1432 DEFine PROCedure MainLoop
1434     LOCal a$, x%, y$
1436 :
1438     REPeat loop
1440         a$ = INKEY$(-1)
1442         x% = CODE(a$)
1444         dbg(x%)
1446 :
1448         SELect ON x%
1450 :
1452           = KCtrlW:
1454               WMOV
1456 :
1458           = KCtrlA:
1460                 REMark ''LONGLINE
1462               MessageWnd 216, 60, 3, "        QL COMMANDER v" & qlcVer$ & CHR$(10) & " Andrei Tenu & Martyn Hill - 2019" & CHR$(10) & "    GNU General Public License"
1464 :
1466           = KDown:
1468               IF crtPanel% = 7
1470                 REMark ''LONGLINE
1472                 MoveDown LeftFiles$, LMinPos%, LIndex%, LStartPos%, LSizeFile%, LSizedir%
1474               ELSE
1476                 REMark ''LONGLINE
1478                 MoveDown RightFiles$, RMinPos%, RIndex%, RStartPos%, RSizeFile%, RSizedir%
1480               END IF
1482 :
1484           = KUp:
1486               IF crtPanel% = 7
1488                 REMark ''LONGLINE
1490                 MoveUp LeftFiles$, LMinPos%, LIndex%, LStartPos%, LSizeFile%, LSizedir%
1492               ELSE
1494                 REMark ''LONGLINE
1496                 MoveUp RightFiles$, RMinPos%, RIndex%, RStartPos%, RSizeFile%, RSizedir%
1498               END IF
1500 :
1502           = KPageDown, KShiftDown:
1504               IF crtPanel% = 7
1506                 MovePageDown LeftFiles$, LStartPos%, LIndex%, 7
1508               ELSE
1510                 MovePageDown RightFiles$, RStartPos%, RIndex%, 8
1512               END IF
1514 :
1516           = KTab:
1518               ChangePanel
1520 :
1522           = KCtrlX, KF10ShiftF5:
1524               RETurn
1526 :
1528           = KSpace:
1530               SelectFile
1532 :
1534           = KPageUp, KShiftUp:
1536               IF crtPanel% = 7
1538                 MovePageUp LeftFiles$, LStartPos%, LIndex%, 7
1540               ELSE
1542                 MovePageUp RightFiles$, RStartPos%, RIndex%, 8
1544               END IF
1546 :
1548           = KEnter:
1550               OnEnter
1552 :
1554           = KShiftEnter:
1556               LRUNBasic
1558 :
1560           = KBackSpace
1562               IF crtPanel% = 7
1564                   MoveTop LeftFiles$, LStartPos%, LIndex%, 7
1566                   IF GetFNam$(LeftFiles$, LIndex%) = ".."
1568                       OnEnter
1570                   ELSE
1572                       BEEP 1390, 20
1574                   END IF
1576               ELSE
1578                   MoveTop RightFiles$, RStartPos%, RIndex%, 8
1580                   IF GetFNam$(RightFiles$,RIndex%) = ".."
1582                       OnEnter
1584                   ELSE
1586                       BEEP 1390, 20
1588                   END IF
1590               END IF
1592 :
1594           = KHome, KCtrlUp:
1596               IF crtPanel% = 7
1598                   MoveTop LeftFiles$, LStartPos%, LIndex%, 7
1600               ELSE
1602                   MoveTop RightFiles$, RStartPos%, RIndex%, 8
1604               END IF
1606 :
1608           = KEnd, KCtrlDown:
1610               IF crtPanel% = 7
1612                   MoveLast LeftFiles$, LStartPos%, LIndex%, 7
1614               ELSE
1616                   MoveLast RightFiles$, RStartPos%, RIndex%, 8
1618               END IF
1620 :
1622           = KCtrl1, KCtrlD:
1624               InputDir 5
1626 :
1628           = KCtrl2, KCtrlR:
1630               InputDir 6
1632 :
1634           = KF3:
1636               ViewFile
1638 :
1640           = KF5:
1642               CopyFiles
1644 :
1646           = KF4:
1648               DoEdit
1650 :
1652           = KF6ShiftF1:
1654               RenameFile
1656 :
1658           = KF8ShiftF3:
1660               DeleteFiles
1662 :
1664           = KF1:
1666               ShowInfo
1668 :
1670           = KF7ShiftF2:
1672               CreateDir
1674 :
1676           REMark ''Find next matching File/Dir starting with a$
1678           =65  TO  90: JumpTo x%, 1
1680           =160 TO 171: JumpTo x%, 1
1682           =97  TO 122: JumpTo x%, 2
1684           =128 TO 139: JumpTo x%, 2
1686           =48  TO  57: JumpTo x%, 0
1688 :
1690           = KPlus, KEqual:
1692               SelectAll
1694 :
1696           = KMinus, KUnderscore:
1698               UnSelectAll
1700 :
1702           = KF9ShiftF4:
1704               DrawWindows 0
1706 :
1708           = KF8ShiftF3:
1710               CompareDirs
1712 :
1714           = KCtrlI:
1716               InvertSelection
1718         END SELect
1720     END REPeat loop
1722 END DEFine
1724 :
1726 :
1728 REMark ''-----------------------------------------------------------
1730 REMark ''a% = code of char to find
1732 REMark ''what%=2 looking for file; =1 looking for dir; =0 looking for dir or file
1734 REMark ''search returns index of item that starts with a$, or first next item if a$ is not found, or last item in list if all existing items start with chars<a$
1736 DEFine FuNction FindFirst%(a%, what%)
1738     LOCal i%, istart%, iend%, found%
1740 :
1742     found% = 0
1744 :
1746     IF crtPanel% = 7
1748 :
1750         IF what% < 2
1752             istart% = 1
1754         ELSE
1756             istart% = LSizedir% + 1
1758         END IF
1760 :
1762         IF what% = 1
1764             iend% = LSizedir%
1766         ELSE
1768             iend% = LSizedir% + LSizeFile%
1770         END IF
1772 :
1774         IF istart% > iend% THEN RETurn LIndex%
1776 :
1778         IF what% > 0
1780             FOR i% = istart% TO iend%
1782               IF CODE(GetFNam$(LeftFiles$, i%)) >= a%
1784                   found% = 1 : EXIT i%
1786               END IF
1788               NEXT i%
1790             END FOR i%
1792         ELSE
1794             FOR i% = LIndex% + 1 TO iend%
1796                 IF CODE(GetFNam$(LeftFiles$, i%)) = a%
1798                     found% = 1
1800                     EXIT i%
1802                 END IF
1804                 NEXT i%
1806             END FOR i%
1808             IF found% = 0
1810                 FOR i% = istart% TO LIndex%
1812                     IF CODE(GetFNam$(LeftFiles$, i%)) = a%
1814                         found% = 1
1816                         EXIT i%
1818                     END IF
1820                     NEXT i%
1822                 END FOR i%
1824             END IF
1826             IF found% = 0 THEN i% = istart%
1828         END IF
1830 :
1832         REMark ''LONGLINE
1834         IF i% <= iend% THEN RETurn i% : ELSE RETurn iend%
1836 :
1838     ELSE
1840 :
1842         IF what% < 2
1844             istart% = 1
1846         ELSE
1848             istart% = RSizedir% + 1
1850         END IF
1852 :
1854         IF what% = 1
1856             iend% = RSizedir%
1858         ELSE
1860             iend% = RSizedir% + RSizeFile%
1862         END IF
1864 :
1866         IF istart% > iend% THEN RETurn RIndex%
1868 :
1870         IF what% > 0
1872             FOR i% = istart% TO iend%
1874                 IF CODE(GetFNam$(RightFiles$, i%)) >= a%
1876                     EXIT i%
1878                 END IF
1880                 NEXT i%
1882             END FOR i%
1884         ELSE
1886             FOR i% = RIndex% + 1 TO iend%
1888                 IF CODE(GetFNam$(RightFiles$, i%)) = a%
1890                     found%=1
1892                     EXIT i%
1894                 END IF
1896                 NEXT i%
1898             END FOR i%
1900             IF found% = 0
1902                 FOR i% = istart% TO RIndex%
1904                     IF CODE(GetFNam$(RightFiles$, i%)) = a%
1906                         found% = 1
1908                         EXIT i%
1910                     END IF
1912                     NEXT i%
1914                 END FOR i%
1916             END IF
1918             IF found% = 0 THEN i% = istart%
1920         END IF
1922 :
1924         REMark ''LONGLINE
1926         IF i% <= iend% THEN RETurn i% : ELSE RETurn iend%
1928 :
1930     END IF
1932 :
1934 END DEFine
1936 :
1938 :
1940 REMark ''-----------------------------------------------------------
1942 DEFine PROCedure JumpTo(a%,what%)
1944     LOCal x%, start%
1946 :
1948     IF crtPanel% = 7 THEN
1950         IF LSizedir% + LSizeFile% = 0 THEN RETurn
1952     ELSE
1954         IF RSizedir% + RSizeFile% = 0 THEN RETurn
1956     END IF
1958 :
1960     x% = FindFirst%(a%, what%)
1962 :
1964     IF crtPanel% = 7
1966         IF x% = LIndex% THEN RETurn
1968         IF (x% >= LStartPos%) AND (x% < LStartPos% + 20)
1970             REMark ''LONGLINE
1972             ShowHideCursor LIndex%-LStartPos%, LIndex%, LeftFiles$, 0
1974             LIndex% = x%
1976             REMark ''LONGLINE
1978             ShowHideCursor LIndex%-LStartPos%, LIndex%, LeftFiles$, 1
1980         ELSE
1982             LIndex% = x%
1984             x% = x% + (LMinPos% = 0)
1986             page% = x% DIV rowno%
1988             IF x% MOD rowno% > 0 THEN page% = page% + 1
1990             LStartPos% = (page% - 1) * rowno% + LMinPos%
1992             ListFiles LeftFiles$, LStartPos%, LIndex%, 7
1994         END IF
1996     ELSE
1998         IF x% = RIndex% THEN RETurn
2000         IF x% >= RStartPos% AND x% < RStartPos% + rowno%
2002             REMark ''LONGLINE
2004             ShowHideCursor RIndex% - RStartPos%, RIndex%, RightFiles$, 0
2006             RIndex% = x%
2008             REMark ''LONGLINE
2010             ShowHideCursor RIndex% - RStartPos%, RIndex%, RightFiles$, 1
2012         ELSE
2014             RIndex% = x%
2016             x% = x% + (RMinPos% = 0)
2018             page% = x% DIV rowno%
2020             IF x% MOD rowno% > 0 THEN page% = page% + 1
2022             RStartPos% = (page% - 1) * rowno% + RMinPos%
2024             ListFiles RightFiles$, RStartPos%, RIndex%, 8
2026         END IF
2028     END IF
2030 END DEFine
2032 :
2034 :
2036 REMark ''-----------------------------------------------------------
2038 REMark ''String Quick Search & Insert
2040 REMark ''(c)tcat, 2017 Tomas Kral
2042 REMark ''modified by Andrei Tenu 2018
2044 :
2046  REMark ''FileLis$ = name of array to load into
2048  REMark ''no% = start index
2050  REMark ''    = 0 if we add a dir to root; 1 if add a dir in a directory; SizeDir%+1 if we add a file
2052  REMark ''Quick search returns:
2054  REMark ''0=not found, 1=found, id%=position
2056 :
2058 REMark ''reference FileList$(0,0,0),id%
2060 REFERENCE FileList$(0, 0), id%
2062 DEFine FuNction Find%(str$, id%, FileList$, no%, size%)
2064     LOCal top%, bot%, mid%, nextFNam$(maxFNLen%)
2066 :
2068     top% = no%
2070     bot% = size%
2072 :
2074     REPeat find_loop
2076         mid% = (bot% + top%) DIV 2
2078         nextFNam$ = GetFNam$(FileList$, mid%)
2080 :
2082         IF top% > bot% THEN
2084          id% = mid% + 1 : RETurn 0
2086         ELSE IF str$ = nextFNam$ THEN
2088          id% = mid% : RETurn 1
2090         ELSE IF str$ > nextFNam$ THEN
2092          top% = mid% + 1
2094         ELSE IF str$ < nextFNam$ THEN
2096          bot% = mid% - 1
2098         END IF : END IF : END IF : END IF
2100     END REPeat find_loop
2102 END DEFine
2104 :
2106 :
2108 REMark ''-----------------------------------------------------------
2110  REMark ''Inserts String at position id%
2112  REMark ''Returns 2=ok, -1=array full
2114 :
2116 REMark ''reference FileList$(0,0,0),r_SizeDir%, r_SizeFile%
2118 REFERENCE FileList$(0,0), r_SizeDir%, r_SizeFile%
2120 DEFine FuNction Insert% (str$, id%, FileList$, DoF%, r_SizeDir%, r_SizeFile%, fLength$)
2122     LOCal i%, size%
2124 :
2126     size% = r_SizeDir% + r_SizeFile%
2128     IF size% >= MaxFiles% THEN RETurn -1
2130     FOR i% = size% TO id% STEP -1
2132         CopyRec FileList$, i% TO FileList$, i%+1
2134     END FOR i%
2136 :
2138     PutFNam FileList$, id%, str$
2140     PutFLen FileList$, id%, fLength$
2142     PutFFlg FileList$, id%, DoF%
2144 :
2146     IF DoF% = 1
2148         r_SizeDir% = r_SizeDir% + 1
2150     ELSE
2152         r_SizeFile% = r_SizeFile% + 1
2154     END IF
2156 :
2158     RETurn 2
2160 END DEFine
2162 :
2164 :
2166 REMark ''End of String Quick Search & Insert -----------------------
2168 :
2170 :
2172 REMark ''-----------------------------------------------------------
2174 REMark ''reference dev$(0),FileList$(0,0,0),r_SizeDir%,r_SizeFile%
2176 REFERENCE dev$(0), FileList$(0,0), r_SizeDir%, r_SizeFile%
2178 DEFine PROCedure LoadDir (dev$, FileList$, Chan%, r_SizeDir%, r_SizeFile%)
2180     LOCal ch%, i, head_start, totrim, flength, file$, ftype
2182     LOCal size2%, res, DirOrFile%, id%, filelen$,k$, no_files
2184 :
2186     CLS# Chan% : INK# Chan%, 7
2188     PRINT# Chan%, "...Loading File List ..."
2190 :
2192     IF dev$(LEN(dev$)) <> "_" THEN dev$ = dev$ & "_"
2194 :
2196     REMark ''LONGLINE
2198     IF Chan% = 7 THEN PRINT# 5, dev$ : ELSE PRINT# 6, dev$
2200 :
2202     IF DirExists%(dev$) = 0
2204         BEEP 1390, 100
2206         PRINT# Chan%, "Cannot open directory " & dev$
2208         RETurn
2210     END IF
2212 :
2214     r_SizeDir% = 0 : r_SizeFile% = 0
2216     totrim = LEN(dev$) - 4
2218     IF totrim <= 0 THEN totrim = 1
2220 :
2222     PutFNam FileList$, 0, ".."
2224     PutFLen FileList$, 0, 0
2226     PutFFlg FileList$, 0, 1
2228 :
2230     head_start = 0
2232     i = 1
2234     ch% = FOP_DIR(dev$)
2236     no_files = FLEN(#ch%) / 64
2238 :
2240     FOR listing = 1 TO no_files
2242         SET_POSITION #ch%, head_start + 0
2244         flength = LONGINTEGER(INPUT$(#ch%, 4)) - 64
2246         REMark ''LONGLINE
2248         faccess = CODE(INKEY$(#ch%))
2250         ftype = CODE(INKEY$(#ch%))
2252         IF flength >= 0
2254             SET_POSITION #ch%, head_start + 14
2256             file$ = GET$(#ch%)
2258             IF LEN(file$) > 0
2260                 file$ = file$(totrim TO)
2262                 filelen$ = flength
2264                 SET_POSITION #ch%, head_start + 52
2266                 fdate = LONGINTEGER(INPUT$(#ch%, 4))
2268                 IF ftype < 255
2270                     size2% = r_SizeDir% + r_SizeFile%
2272                     file$ = LOWER$(file$)
2274                     REMark ''LONGLINE
2276                     res = Find%(file$,id%, FileList$, r_SizeDir% + 1, size2%)
2278                     DirOrFile% = 0
2280                 ELSE
2282                     file$ = UPPER$(file$)
2284                     REMark ''LONGLINE
2286                     res = Find%(file$, id%, FileList$, 1, r_SizeDir%)
2288                     DirOrFile% = 1
2290                 END IF
2292                 i = i + 1
2294 :
2296                 REMark ''k$="":
2298                 REMark ''if flength>1023 then
2300                 REMark '' flength=INT(flength/1024+.5):k$="K"
2302                 REMark '' if flength>1023 then
2304                 REMark ''   flength=INT(flength/1024+.5):k$="M"
2306                 REMark '' endif
2308                 REMark ''endif
2310                 REMark ''filelen$=flength&k$
2312                 IF res = 0
2314                     REMark ''LONGLINE
2316                    res = Insert%(file$, id%, FileList$, DirOrFile%, r_SizeDir%, r_SizeFile%, filelen$)
2318                 END IF
2320                 IF res = -1 : EXIT listing
2322             END IF
2324         END IF
2326         head_start = head_start + 64
2328     END FOR listing
2330     CLOSE# ch%
2332 END DEFine
2334 :
2336 :
2338 REMark ''-----------------------------------------------------------
2340 REMark ''reference FileList$(0,0,0),r_Index%,r_StartPos%
2342 REFERENCE FileList$(0, 0), r_Index%, r_StartPos%
2344 DEFine PROCedure MoveDown(FileList$, MinPos%, r_Index%, r_StartPos%, SizeFile%, SizeDir%)
2346     LOCal size%, idx%
2348 :
2350     size% = SizeFile% + SizeDir%
2352     IF r_Index% > size% THEN RETurn
2354     REMark ''LONGLINE
2356     ShowHideCursor r_Index% - r_StartPos%, r_Index%, FileList$, 0
2358     r_Index% = r_Index% + 1
2360     IF r_Index%>size% THEN r_Index% = size%
2362     IF r_Index% > r_StartPos% + rowno% - 1
2364         SCROLL# crtPanel%, - mainFountHeight%
2366         r_StartPos% = r_StartPos% + 1
2368     END IF
2370     ShowHideCursor r_Index%-r_StartPos%, r_Index%,  FileList$, 1
2372 END DEFine
2374 :
2376 :
2378 REMark ''-----------------------------------------------------------
2380 REMark ''reference FileList$(0,0,0),r_Index%,r_StartPos%
2382 REFERENCE FileList$(0, 0), r_Index%, r_StartPos%
2384 DEFine PROCedure MoveUp(FileList$, MinPos%, r_Index%, r_StartPos%, SizeFile%, SizeDir%)
2386     LOCal size%, idx%
2388 :
2390     size% = SizeFile% + SizeDir%
2392     IF r_Index% > size%  THEN RETurn
2394     REMark ''LONGLINE
2396     ShowHideCursor r_Index% - r_StartPos%, r_Index%, FileList$, 0
2398     r_Index% = r_Index% - 1
2400     IF r_Index%<MinPos% THEN : r_Index% = MinPos%
2402     IF r_Index% < r_StartPos%
2404         SCROLL# crtPanel%, mainFountHeight%
2406         r_StartPos% = r_StartPos% - 1
2408     END IF
2410     REMark ''LONGLINE
2412     ShowHideCursor r_Index% - r_StartPos%, r_Index%, FileList$, 1
2414 END DEFine
2416 :
2418 :
2420 REMark ''-----------------------------------------------------------
2422 REMark ''reference FileList$(0,0,0)
2424 REFERENCE FileList$(0, 0)
2426 DEFine PROCedure ShowHideCursor(Linepos%, Index%, FileList$, SoH%)
2428     LOCal a$, x%, DFlen1%, DFLen2%
2430 :
2432     a$ = GetFNam$(FileList$, Index%)
2434     DFlen1% = LEN(a$)
2436     DFLen2% = LEN(GetFLen(FileList$, Index%))
2438 :
2440     IF GetFFlg%(FileList$,Index%) MOD 2 = 1
2442         x% = 3
2444         IF DFlen1%>linelen% - x%
2446             a$ = a$(TO linelen% - x% - 2)
2448             a$ = a$ & ".."
2450         END IF
2452         a$ = a$ & " ->"
2454         a$ = a$ & FILL$(" ", linelen% - LEN(a$) - 1)
2456     ELSE
2458         x% = 9
2460         IF DFlen1% > linelen% - x%
2462             a$ = a$(TO linelen% - x% - 2)
2464             a$ = a$ & ".."
2466         END IF
2468         a$ = a$ & FILL$(" ", linelen% - LEN(a$) - DFLen2% - 1)
2470         a$ = a$ & GetFLen(FileList$, Index%)
2472     END IF
2474     IF SoH% = 1
2476         STRIP# crtPanel%, strp%
2478         INK# crtPanel%, 0
2480         IF GetFFlg%(FileList$, Index%) > 1
2482             INK# crtPanel%, 2
2484         ELSE
2486             INK# crtPanel%, 0
2488         END IF
2490         AT# crtPanel%, Linepos%, 0
2492         PRINT# crtPanel%, a$;
2494         STRIP# crtPanel%, ppr%
2496         INK# crtPanel%, ik%
2498     ELSE
2500         IF GetFFlg%(FileList$, Index%) > 1
2502             INK# crtPanel%, 2
2504         ELSE
2506             INK# crtPanel%, ik%
2508         END IF
2510         AT# crtPanel%, Linepos%, 0
2512         PRINT# crtPanel%, a$;
2514     END IF
2516 END DEFine
2518 :
2520 :
2522 REMark ''-----------------------------------------------------------
2524 DEFine PROCedure ChangePanel
2526     IF crtPanel% = 7
2528         IF LIndex% <= LSizedir% + LSizeFile%
2530             REMark ''LONGLINE
2532             ShowHideCursor LIndex% - LStartPos%, LIndex%, LeftFiles$, 0
2534         END IF
2536         crtPanel% = 8
2538         IF RIndex% <= RSizedir% + RSizeFile%
2540             REMark ''LONGLINE
2542             ShowHideCursor RIndex% - RStartPos%, RIndex%, RightFiles$, 1
2544         END IF
2546         BORDER# 8, 1, brd%
2548         BORDER# 7, 1, brd%, 1 ,3
2550     ELSE
2552         IF RIndex% <= RSizedir% + RSizeFile%
2554             REMark ''LONGLINE
2556             ShowHideCursor RIndex% - RStartPos%, RIndex%, RightFiles$, 0
2558         END IF
2560         crtPanel% = 7
2562         IF LIndex% <= LSizedir% + LSizeFile%
2564             REMark ''LONGLINE
2566             ShowHideCursor LIndex% - LStartPos%, LIndex%, LeftFiles$, 1
2568         END IF
2570         BORDER# 7, 1, brd%
2572         BORDER# 8, 1, brd%, 1, 3
2574     END IF
2576 END DEFine
2578 :
2580 :
2582 REMark ''-----------------------------------------------------------
2584 DEFine PROCedure SelectFile
2586     IF crtPanel% = 7
2588         REMark ''LONGLINE
2590         PutFFlg LeftFiles$, LIndex%, GetFFlg%(LeftFiles$, LIndex%) ^^ 2
2592         REMark ''LONGLINE
2594         ShowHideCursor LIndex%-LStartPos%, LIndex%, LeftFiles$, 1
2596     ELSE
2598         REMark ''LONGLINE
2600         PutFFlg RightFiles$, RIndex%, GetFFlg%(RightFiles$, RIndex%) ^^ 2
2602         REMark ''LONGLINE
2604         ShowHideCursor RIndex% - RStartPos%, RIndex%, RightFiles$, 1
2606     END IF
2608 END DEFine
2610 :
2612 :
2614 REMark ''-----------------------------------------------------------
2616 REMark ''reference FileList$(0,0,0),r_StartPos%,r_Index%
2618 REFERENCE FileList$(0, 0), r_StartPos%, r_Index%
2620 DEFine PROCedure MovePageDown(FileList$, r_StartPos%, r_Index%, ch%)
2622     LOCal size%, x%
2624 :
2626     IF ch% = 7
2628         size% = LSizedir% + LSizeFile%
2630     ELSE
2632         size% = RSizedir% + RSizeFile%
2634     END IF
2636     IF r_Index%>size% THEN RETurn
2638     x% = r_StartPos% + 20
2640     IF x% > size% THEN RETurn
2642     r_StartPos% = x%
2644     r_Index% = r_StartPos%
2646     ListFiles FileList$, r_StartPos%, r_Index%, ch%
2648 END DEFine
2650 :
2652 :
2654 REMark ''-----------------------------------------------------------
2656 REMark ''reference FileList$(0,0,0),r_StartPos%,r_Index%
2658 REFERENCE FileList$(0, 0), r_StartPos%, r_Index%
2660 DEFine PROCedure MovePageUp(FileList$, r_StartPos%, r_Index%, ch%)
2662     LOCal top%, x%, size%
2664 :
2666     IF ch% = 7
2668         top% = LMinPos%
2670         size% = LSizeFile% + LSizedir%
2672     ELSE
2674         top% = RMinPos%
2676         size% = RSizeFile% + RSizedir%
2678     END IF
2680     IF r_Index%>size% THEN RETurn
2682     x% = r_StartPos% - 20
2684     IF x% < top% THEN x% = top%
2686     r_StartPos% = x%
2688     r_Index% = r_StartPos%
2690     ListFiles FileList$, r_StartPos%, r_Index%, ch%
2692 END DEFine
2694 :
2696 :
2698 REMark ''-----------------------------------------------------------
2700 REMark ''reference FileList$(0,0,0)
2702 REFERENCE FileList$(0, 0)
2704 DEFine PROCedure OpenSubDir(FileList$, Index%, ch%)
2706     LOCal a$, size%, d$, x%, page%
2708 :
2710     IF ch% = 7
2712         size% = LSizeFile% + LSizedir%
2714         d$ = leftDir$
2716     ELSE
2718         size% = RSizeFile% + RSizedir%
2720         d$ = rightDir$
2722     END IF
2724     IF Index% > size% THEN RETurn
2726     IF GetFFlg%(FileList$, Index%) MOD 2 <> 1 THEN RETurn
2728 :
2730     IF GetFNam$(FileList$, Index%) = ".."
2732         a$ = GetParentDir$(ch%)
2734         IF LEN(d$) > LEN(a$)
2736             d$ = d$(LEN(a$) + 1 TO)
2738             IF d$(LEN(d$)) = "_" THEN d$ = d$(1 TO LEN(d$) - 1)
2740             IF crtPanel% = 7
2742                 DIM LeftFiles$(MaxFiles%, _fMax%)
2744                 leftDir$ = a$
2746                 LoadDir leftDir$, LeftFiles$, 7, LSizedir%, LSizeFile%
2748                 IF LEN(leftDir$) = 5
2750                     LMinPos% = 1
2752                 ELSE
2754                     LMinPos% = 0
2756                 END IF
2758                 IF Find%(d$, id%, LeftFiles$, 1, LSizedir%) = 1
2760                     LIndex% = id%
2762                     x% = id% + (LMinPos% = 0)
2764                     page% = x% DIV rowno%
2766                     IF x% MOD rowno% > 0 THEN page% = page% + 1
2768                     LStartPos% = (page% - 1) * rowno% + LMinPos%
2770                     ListFiles LeftFiles$, LStartPos%, LIndex%, 7
2772                 ELSE
2774                     d$ = ""
2776                 END IF
2778             ELSE
2780                 DIM RightFiles$(MaxFiles%, _fMax%)
2782                 rightDir$ = a$
2784                 LoadDir rightDir$, RightFiles$, 8, RSizedir%, RSizeFile%
2786                 IF LEN(rightDir$) = 5
2788                     RMinPos% = 1
2790                 ELSE
2792                     RMinPos% = 0
2794                 END IF
2796                 IF Find%(d$, id%, RightFiles$, 1, RSizedir%) = 1
2798                     RIndex% = id%
2800                     x% = id% + (RMinPos% = 0)
2802                     page% = x% DIV rowno%
2804                     IF x% MOD rowno% > 0 THEN page% = page% + 1
2806                     RStartPos% = (page% - 1) * rowno% + RMinPos%
2808                     ListFiles RightFiles$, RStartPos%, RIndex%, 8
2810                 ELSE
2812                    d$ = ""
2814                 END IF
2816             END IF
2818         ELSE
2820             d$ = ""
2822         END IF
2824     ELSE
2826         d$ = ""
2828         IF ch% = 7
2830             a$ = leftDir$ & GetFNam$(FileList$, Index%)
2832         ELSE
2834             a$ = rightDir$ & GetFNam$(FileList$, Index%)
2836         END IF
2838     END IF
2840     IF LEN(d$) = 0
2842         IF ch% = 7
2844             leftDir$ = a$
2846             LShowLeftDir
2848         ELSE
2850             rightDir$ = a$
2852             LShowRightDir
2854         END IF
2856     END IF
2858 END DEFine
2860 :
2862 :
2864 REMark ''-----------------------------------------------------------
2866 DEFine FuNction GetParentDir$(ch%)
2868     LOCal i%, dir$
2870 :
2872     IF ch% = 7
2874         dir$ = leftDir$
2876     ELSE
2878         dir$ = rightDir$
2880     END IF
2882     FOR i% = LEN(dir$) - 1 TO 5 STEP -1
2884         IF dir$(i%) = "_"
2886             IF FTEST(dir$(1 TO i%)) = 0
2888                 IF FTYP(\dir$(1 TO i%)) = 255 THEN EXIT i%
2890             END IF
2892         END IF
2894     END FOR i%
2896     dir$ = dir$(1 TO i%)
2898     RETurn dir$
2900 END DEFine
2902 :
2904 :
2906 REMark ''------------------------------------------------------------
2908 DEFine PROCedure InputDir(ch%)
2910     LOCal a$, olddir$
2912 :
2914     PAPER# ch%, 0
2916     INK# ch%, 7
2918     CLS# ch%
2920 :
2922     IF ch% = 5
2924         olddir$ = leftDir$
2926     ELSE
2928         olddir$ = rightDir$
2930     END IF
2932 :
2934     a$ = EDIT$(#ch%, olddir$, 36)
2936     CLS# ch%
2938     PAPER# ch%, White%
2940     INK# ch%, 0
2942     CLS# ch%
2944 :
2946     IF a$ = "" THEN a$ = olddir$
2948     IF a$(LEN(a$)) <> "_" THEN a$ = a$ & "_"
2950     IF DirExists%(a$) = 0
2952         BEEP 1390, 20
2954         PRINT# ch%, olddir$
2956         RETurn
2958     END IF
2960 :
2962     IF ch% = 5
2964         IF crtPanel% = 8
2966             REMark ''LONGLINE
2968             ShowHideCursor RIndex% - RStartPos%, RIndex%, RightFiles$, 0
2970         END IF
2972         leftDir$ = a$
2974         crtPanel% = 7
2976         LShowLeftDir
2978         BORDER# 7, 1, brd%
2980         BORDER# 8, 1, brd%, 1, 3
2982     ELSE
2984         IF crtPanel% = 7
2986             REMark ''LONGLINE
2988             ShowHideCursor LIndex% - LStartPos%, LIndex%, LeftFiles$, 0
2990         END IF
2992         rightDir$ = a$
2994         crtPanel% = 8
2996         LShowRightDir
2998         BORDER# 8, 1, brd%
3000         BORDER# 7, 1, brd%, 1, 3
3002     END IF
3004 :
3006 END DEFine
3008 :
3010 :
3012 REMark ''----------------------------------------------------------
3014 DEFine PROCedure ViewFile
3016     LOCal ext$(10), a$, x%, i%, ch%, ch1%, ch2%, ch3%
3018     LOCal left%, windef$, wid%,hgt%,top%
3020 :
3022     IF crtPanel% = 7
3024         IF LIndex% > LSizedir% + LSizeFile% THEN RETurn
3026         a$ = GetFNam$(LeftFiles$, LIndex%)
3028     ELSE
3030         IF RIndex%>RSizedir% + RSizeFile% THEN RETurn
3032         a$ = GetFNam$(RightFiles$, RIndex%)
3034     END IF
3036     IF a$ == ".." OR a$ == "<un-named>" OR IsDir% = 1
3038         RETurn
3040     END IF
3042     REMark ''now get file extension
3044     x% = LEN(a$)
3046     FOR i% = 0 TO x% - 1
3048         IF a$(x% - i%) == "_" OR a$(x% - i%) == "."
3050             EXIT i%
3052         END IF
3054     END FOR i%
3056     IF i% > 0
3058         ext$ = a$(x% - i% + 1 TO x%)
3060     ELSE
3062         ext$ = ""
3064     END IF
3066     IF crtPanel% = 7
3068         a$ = leftDir$ & a$
3070     ELSE
3072         a$=rightDir$ & a$
3074     END IF
3076     ext$ = LOWER$(ext$)
3078     x% = 0
3080     IF ext$ = "fnt" THEN x% = 1
3082     IF ext$ = "fat" THEN x% = 2
3084     IF ext$ = "scr" THEN x% = 3
3086     IF ext$ = "doc" THEN x% = 4
3088     IF ext$ = "zip" THEN x% = 5
3090     IF x% <> 3
3092         IF x% = 1 OR x% = 2
3094             left% = (maxWinWid% - 448) DIV 2 - 2
3096             wid% = 452
3098             hgt% = 230
3100             REMark ''LONGLINE
3102             top% = (panelWinHeight% + 2 * mainFountHeight% + 7 - hgt%) DIV 2 + 14
3104             windef$ = "scr_452x230a" & left% & "x" & top%
3106             ch% = FOPEN(windef$)
3108             PAPER# ch%, 0
3110             INK #ch%, White%
3112             OUTLN# ch%, 452, 230, left%, top%
3114             BORDER# ch%, 1, 2
3116             CLS# ch%
3118             windef$ = "scr_452x12a" & left% & "x" & top%
3120             ch1% = FOPEN(windef$)
3122             BORDER# ch1%, 1, 2
3124             PAPER# ch1%, 0, 2, 1
3126             CLS# ch1%
3128             PAPER# ch1%,0
3130             INK# ch1%, White%
3132             AT# ch1%, 0, 37 - (LEN(a$) + 5) / 2
3134             PRINT# ch1%, "View " & a$
3136             left% = left% + 2
3138             windef$ = "scr_448x204a" & left% & "x" & (top% + 12)
3140             ch2% = FOPEN(windef$)
3142             PAPER# ch2%, 0
3144             INK# ch2%, Green%
3146         ELSE
3148             REMark ''LONGLINE
3150             IF maxWinWid% > 600 THEN wid% = 600 : ELSE wid% = 452
3152             hgt% = panelWinHeight% + 27
3154             left% = (maxWinWid% - wid%) DIV 2 - 2
3156             top% = mainFountHeight% + 4
3158             REMark ''LONGLINE
3160             windef$ = "scr_" & wid% & "x" & hgt% & "a" & left% & "x" & top%
3162             ch% = FOPEN(windef$)
3164             PAPER# ch%, 0
3166             INK# ch%, White%
3168             OUTLN# ch%, wid%, hgt%, left%, top%
3170             BORDER# ch%, 1, 2
3172             CLS# ch%
3174             REMark ''LONGLINE
3176             windef$ = "scr_" & wid% & "x12a" & left% & "x" & top%
3178             ch1% = FOPEN(windef$)
3180             BORDER# ch1%, 1, 2
3182             PAPER# ch1%, 0, 2, 1
3184             CLS# ch1%
3186             PAPER# ch1%, 0
3188             INK# ch1%, White%
3190             CURSOR# ch1%,(wid% - (LEN(a$) + 5) * 6) DIV 2, 0
3192             PRINT# ch1%, "View " & a$
3194             left% = left% + 2
3196             REMark ''LONGLINE
3198             windef$ = "scr_" & (wid% - 4) & "x" & (hgt% - 26) & "a" & left% & "x" & (top% + 12)
3200             ch2% = FOPEN(windef$)
3202             PAPER# ch2%, 0
3204             INK# ch2%, Green%
3206         END IF
3208 :
3210     END IF
3212     SELect ON x%
3214         = 1:
3216             ViewFont a$, 1, ch2%
3218 :
3220         = 2:
3222             ViewFont a$, 2, ch2%
3224 :
3226         = 3:
3228             ViewImage a$, 4 : Set78CharSet
3230 :
3232         = 4:
3234             WINDOW# 0, wid% - 4, 12, left%, hgt% + top% - 14
3236             PAPER# 0, Green%
3238             INK# 0, 0
3240             CLS# 0
3242 :
3244             IF IsQuillDoc%(a$) = 1
3246                 IF FTEST(ConfigDrv$ & "quill_view") = 0
3248                     REMark ''LONGLINE
3250                     EW ConfigDrv$ & "quill_view", #ch2%; "-t " & a$ & " " & TempDir$ & "quill_tmp"
3252                     IF FTEST(TempDir$ & "quill_tmp") = 0
3254                         IF mainFountBase > 0 AND wid% < 600
3256                             CHAR_USE# ch2%, mainFountBase, 0
3258                             CHAR_INC# ch2%, 5, 10
3260                         END IF
3262                         MORE# ch2%, TempDir$ & "quill_tmp"
3264                         DELETE TempDir$ & "quill_tmp"
3266                     END IF
3268                 ELSE
3270                     PRINT# ch2%, "Cannot find quill_view"
3272                 END IF
3274             ELSE
3276                 MORE# ch2%, a$
3278             END IF
3280 :
3282         =5:
3284             REMark ''LONGLINE
3286             WINDOW# 0, wid% - 4, 12, left%, hgt% + top% - 14
3288             PAPER# 0, Green%
3290             INK# 0, 0
3292             CLS# 0
3294             IF IsZipFile%(a$) = 1
3296                 IF FTEST(ConfigDrv$ & "unzip") = 0
3298                     ch3% = FOP_OVER(TempDir$ & "zip_tmp")
3300                     IF ch3% > 0
3302                         REMark ''LONGLINE
3304                         EW ConfigDrv$&"unzip", #ch3%, #ch3%,#ch3%;"-lqq "&a$
3306                         CLOSE# ch3%
3308                         MORE# ch2%, TempDir$ & "zip_tmp"
3310                         DELETE TempDir$ & "zip_tmp"
3312                     ELSE
3314                         REMark ''LONGLINE
3316                         PRINT# ch2%, "Cannot create temporary file"
3318                     END IF
3320                 ELSE
3322                     PRINT# ch2%, "Cannot find unzip"
3324                 END IF
3326             ELSE
3328                 MORE# ch2%, a$
3330             END IF
3332 :
3334         = REMAINDER :
3336             WINDOW# 0, wid% - 4, 12, left%, hgt% + top% - 14
3338             PAPER# 0, Green%
3340             INK# 0, 0
3342             CLS# 0
3344             MORE# ch2%, a$
3346     END SELect
3348 :
3350     IF x% <> 3
3352         CHAR_USE# ch2%, 0, 0
3354         CLS# ch1%
3356         CLS# ch2%
3358         CLOSE# ch2%
3360         CLOSE# ch1%
3362         WINDOW# 0, 488, 23, 12, 233
3364         PAPER# 0, 0
3366         INK# 0, White%
3368         OUTLN# ch%, wid%, hgt%, left%, top%
3370         CLOSE# ch%
3372     END IF
3374 END DEFine
3376 :
3378 :
3380 REMark ''----------------------------------------------------------
3382 DEFine PROCedure ViewFont(file$, type%, ch%)
3384     LOCal lng, i, base, type$(6)
3386 :
3388     lng = FLEN(\file$)
3390     IF lng > 0
3392         AT# ch%, 0, 0
3394         PRINT# ch%, "Font: " & file$; "      ";
3396         AT# ch%, 0, 44
3398         PRINT# ch%, "Font size = "; lng; " bytes"
3400     ELSE
3402         PRINT# ch%, "Font NOT FOUND"
3404         RETurn
3406     END IF
3408     base = ALCHP(lng)
3410     LBYTES file$, base
3412 :
3414     IF type% = 1 THEN type% = TestFount%(base)
3416     IF type% = 1 THEN type$ = "(5x9)" : ELSE type$ = "(8x9)"
3418     AT# ch%, 0, 7 + LEN(file$)
3420     PRINT #ch%, type$;
3422 :
3424     AT# ch%, 1, 0
3426     REMark ''LONGLINE
3428     PRINT# ch%, "Lowest character code = "; PEEK(base); "        ";
3430     AT# ch%, 1, 44
3432     PRINT# ch%, "Number of characters  = "; PEEK(base+1) + 1
3434     PRINT# ch%,"  "
3436     CHAR_USE# ch%, base, 0
3438     CSIZE# ch%, (type% = 2), 0
3440     CHAR_INC# ch%, 6 + 2 * (type% = 2), 10
3442     FOR i = 0 TO 9
3444         PRINT# ch%, CHR$(i);
3446         NEXT i
3448     END FOR i
3450     PRINT# ch%, " ";
3452     FOR i = 11 TO 255 : PRINT# ch%, CHR$(i); :NEXT i: END FOR i
3454     PRINT# ch%, CHR$(10)
3456     PRINT# ch%, "The quick brown fox jumped over the lazy dog"
3458     CSIZE# ch%, 2 + (type% = 2), 0
3460     CHAR_INC# ch%, 12 + 4 * (type% = 2), 10
3462     PRINT# ch%, "The quick brown fox jumped over the lazy dog"
3464     CSIZE# ch%, 2 + (type% = 2), 1
3466     CHAR_INC# ch%, 12 + 4 * (type% = 2), 20
3468     PRINT# ch%, "The quick brown fox jumped over the lazy dog"
3470     CHAR_USE# ch%, 0, 0
3472     RECHP base
3474     xx$ = INKEY$(-1)
3476 END DEFine
3478 :
3480 :
3482 REMark ''----------------------------------------------------------
3484 DEFine PROCedure MessageWnd(width%, height%, type%, text$)
3486     LOCal ch%, k$, AtX%,AtY%
3488 :
3490     AtX% = (maxWinWid% - width%) / 2
3492     AtY% = (256 - height%) / 2
3494     ch% = FOPEN("con")
3496     OUTLN# ch%; width% - 2, height%, AtX%, AtY%, 4, 3
3498 :
3500     SELect ON type%
3502       = 1:
3504           PAPER# ch%, Green%
3506           INK# ch%, 0
3508           CLS# ch%
3510           BLOCK# ch%, width% - 4, 8, 1, 1, Green%, 1, 1
3512           AT# ch%, 1, 1
3514           PRINT# ch%, text$
3516 :
3518       = 2:
3520           PAPER# ch%, 2
3522           INK# ch%, White%
3524           CLS# ch%
3526           BLOCK# ch%, width% - 4, 8, 1, 1, 2, 1, 1
3528           CURSOR# ch%, (width% - 49) / 2, 1
3530           PRINT# ch%, " ERROR "
3532           AT# ch%, 1, 1
3534           PRINT# ch%, text$
3536 :
3538       = 3:
3540           PAPER# ch%, White%
3542           INK# ch%, 0
3544           BORDER# ch%, 1, 2
3546           CLS# ch%
3548           BLOCK# ch%, width% - 8, 8, 1, 1, 2 ,0 , 1
3550           CURSOR# ch%, (width% - 49) / 2, 1
3552           PRINT# ch%, " ABOUT "
3554           CURSOR#ch%, 2, 15
3556           PRINT# ch%, text$
3558 :
3560     END SELect
3562 :
3564     CURSOR# ch%, (width% - 130) / 2, 48
3566     PRINT# ch%, "... press any key ..."
3568     k$ = INKEY$(-1)
3570     OUTLN# ch%; width%, height%, AtX%, AtY%
3572     CLOSE# ch%
3574 END DEFine
3576 :
3578 :
3580 REMark ''----------------------------------------------------------
3582 DEFine FuNction IsDir%
3584     LOCal k%, lenghth, bufsize
3586 :
3588     IF crtPanel% = 7
3590         k% = GetFFlg%(LeftFiles$, LIndex%) MOD 2
3592     ELSE
3594         k% = GetFFlg%(RightFiles$, RIndex%) MOD 2
3596     END IF
3598     RETurn k%
3600 END DEFine
3602 :
3604 :
3606 REMark ''----------------------------------------------------------
3608 DEFine PROCedure ViewImage(a$, m%)
3610     LOCal ch%, ch1%, scrSz, scrBuf, maxScrSz
3612 :
3614     IF maxWinHgt% > 256 OR maxWinWid% > 512 OR RMODE > 8
3616         REMark ''LONGLINE
3618         MessageWnd 200, 60, 2, CHR$(10) & " _scr images can only be viewed" & CHR$(10) & "  on classic QL configuration"
3620         RETurn
3622     END IF
3624     maxScrSz = 32768
3626     scrSz = FLEN(\a$)
3628     IF scrSz > maxScrSz
3630         scrBuf = ALCHP(scrSz)
3632         IF scrBuf < 0 THEN BEEP 1390,10 : RETurn
3634         LBYTES a$, scrBuf
3636         a$ = TempDir$ & "tmp_scr"
3638         SBYTES_O a$, scrBuf, maxScrSz
3640         RECHP scrBuf
3642     END IF
3644     ch% = FOPEN("con")
3646     OUTLN# ch%; 512, 256, 0, 0
3648     IF m% = 4 THEN MODE 4 : ELSE MODE 8
3650     LBYTES a$, 131072
3652     PAUSE 10
3654     k% = CODE(INKEY$(-1))
3656 :
3658     SELect ON k%
3660       = 52:
3662         OUTLN# ch%; 512, 256, 0, 0
3664         CLOSE# ch%
3666         ViewImage a$, 4
3668 :
3670       = 56:
3672         OUTLN# ch%; 512, 256, 0, 0
3674         CLOSE# ch%
3676         ViewImage a$, 8
3678 :
3680       = REMAINDER :
3682         MODE 4
3684         OUTLN# ch%; 512, 256, 0, 0
3686         CLOSE# ch%
3688         DELETE TempDir$ & "tmp_scr"
3690 :
3692     END SELect
3694 :
3696 END DEFine
3698 :
3700 :
3702 REMark ''----------------------------------------------------------
3704 DEFine FuNction InputWnd$(width%, height%, title$, text$, start$)
3706     LOCal ch%, ch1%, k$, AtX%,AtY%
3708 :
3710     AtX% = (maxWinWid% - width%) / 2
3712     AtY% = (256 - height%) / 2
3714     ch% = FOPEN("con")
3716     OUTLN# ch%; width%, height%, AtX%, AtY%, 4, 3
3718     BORDER# ch%, 1, 4
3720     PAPER# ch%, White%
3722     INK# ch%, 0
3724     CLS# ch%
3726     BLOCK# ch%, width% - 4, 10, 0, 0, Green%, 1, 1
3728     PAPER# ch%, Green%
3730     INK# ch%, 0
3732     CURSOR# ch%,(width% - 6 - LEN(title$) * 6) / 2, 0
3734     PRINT# ch%, title$
3736     PAPER# ch%, White%
3738     INK# ch%, 0
3740     CURSOR# ch%, 6, 16
3742     PRINT# ch%, text$
3744     CURSOR# ch%, (width% - 198) / 2, 48
3746     PRINT# ch%, "... leave it empty to cancel ..."
3748     ch1% = FOPEN("con")
3750     WINDOW# ch1%, width% - 18, 12, AtX% + 8, AtY% + 28
3752     PAPER# ch1%, 0
3754     INK# ch1%, White%
3756     CLS# ch1%
3758     k$ = EDIT$(#ch1%, start$, 36)
3760     CLOSE# ch1%
3762     OUTLN# ch%; width%, height%, AtX%, AtY%
3764     CLOSE# ch%
3766     RETurn k$
3768 END DEFine InputWnd$
3770 :
3772 :
3774 REMark ''----------------------------------------------------------
3776 DEFine FuNction DirExists%(name$)
3778     LOCal er%, ch%, d$, dname$
3780 :
3782     dbg name$
3784     dname$ = name$
3786     IF dname$(LEN(dname$)) <> "_"
3788         dname$ = dname$ & "_"
3790     END IF
3792     IF LEN(dname$) = 5
3794         d$ = DATAD$
3796         DATA_USE CHR$(0)
3798         ch% = FOP_DIR(dname$)
3800         DATA_USE d$
3802         IF ch% < 0
3804             er% = 0
3806         ELSE
3808             CLOSE# ch%
3810             er% = 1
3812         END IF
3814     ELSE
3816         IF FTEST(dname$) = 0
3818             IF FTYP(\dname$) = 255
3820                 er% = 1
3822             ELSE
3824                 er% = 0
3826             END IF
3828         ELSE
3830             er% = 0
3832         END IF
3834     END IF
3836     RETurn er%
3838 END DEFine
3840 :
3842 :
3844 REMark ''----------------------------------------------------------
3846 DEFine PROCedure CreateDir
3848     LOCal x%,DirName$, FullDirName$
3850 :
3852     REMark ''LONGLINE
3854     DirName$ = InputWnd$(240, 60, " Create Directory ", "Directory Name:", "")
3856     DirName$ = UPPER$(DirName$)
3858     IF DirName$ = "" THEN RETurn
3860     IF crtPanel% = 7
3862         FullDirName$ = leftDir$ & DirName$
3864     ELSE
3866         FullDirName$ = rightDir$ & DirName$
3868     END IF
3870     x% = Create1Dir%(DirName$, FullDirName$, crtPanel%, 1, 1, 1)
3872 END DEFine
3874 :
3876 :
3878 REMark ''----------------------------------------------------------
3880 DEFine FuNction Create1Dir%(DirName$, FullDirName$, panel%, UpdateWnd%, CheckNoQ%, UpdateList%)
3882     LOCal res%, fres%, page%, msg$
3884 :
3886     IF LEN(FullDirName$) > 41
3888         IF UpdateWnd% = 1
3890             REMark ''LONGLINE
3892             MessageWnd 200, 60, 2, CHR$(10) & "          Name too long !"
3894             RETurn 0
3896         ELSE
3898           INK# 0, 2
3900           PRINT# 0, "Directory not created  Name too long"
3902           INK# 0, White%
3904           RETurn 0
3906         END IF
3908     END IF
3910     IF (Qubide% = 1) AND (CheckNoQ% = 1)
3912         IF TestQubideRestriction%(DirName$, panel%) = 1
3914             IF UpdateWnd% = 1
3916                 REMark ''LONGLINE
3918                 MessageWnd 200, 60, 2, "   Cannot create Directory !" & CHR$(10) & "  QUBIDE limitation: Files will" & CHR$(10) & "     fall in the directory !"
3920                 RETurn 0
3922             ELSE
3924                 INK# 0, 2
3926                 REMark ''LONGLINE
3928                 PRINT# 0, "Directory not created QUBIDE limitation: Files will fall in the directory"
3930                 INK# 0, White%
3932                 RETurn 0
3934             END IF
3936         END IF
3938     END IF
3940     IF DirName$(LEN(DirName$)) = "_"
3942         DirName$ = DirName$(1 TO LEN(DirName$) - 1)
3944     END IF
3946     IF panel% = 7
3948         REMark ''LONGLINE
3950         IF (CheckNoQ% = 1) AND (LSizedir% + LSizeFile% + 1 >= MaxFiles%)
3952             IF UpdateWnd% = 1
3954                 REMark ''LONGLINE
3956                 MessageWnd 200,60,2, CHR$(10) & "   Cannot create Directory !" & CHR$(10) & CHR$(10) & "     maximum number reached !"
3958                 RETurn 0
3960             ELSE
3962                 INK# 0, 2
3964                 REMark ''LONGLINE
3966                 PRINT# 0,"Directory not created. You have reached the maximum number of files and directories"
3968                 INK# 0, White%
3970                 RETurn -1
3972             END IF
3974         ELSE
3976             fres% = FMAKE_DIR(FullDirName$)
3978             IF (UpdateList% = 1) AND (fres% >= 0)
3980                 REMark ''LONGLINE
3982                 res% = Find%(DirName$, id%, LeftFiles$, 1, LSizedir%)
3984                 IF res% = 0
3986                     REMark ''LONGLINE
3988                     res% = Insert%(DirName$, id%, LeftFiles$, 1, LSizedir%, LSizeFile%, "0")
3990                 END IF
3992                 LIndex% = id%
3994                 IF UpdateWnd% = 1
3996                     id% = id% + (LMinPos% = 0)
3998                     page% = id% DIV rowno%
4000                     REMark ''LONGLINE
4002                     IF id% MOD rowno% > 0 THEN page% = page% + 1
4004                     LStartPos% = (page% - 1) * rowno% + LMinPos%
4006                     ListFiles LeftFiles$, LStartPos%, LIndex%, 7
4008                 END IF
4010                 RETurn 1
4012             ELSE
4014                 IF fres% >= 0 THEN RETurn 1
4016             END IF
4018         END IF
4020     ELSE
4022         REMark ''LONGLINE
4024         IF (CheckNoQ% = 1) AND (RSizedir% + RSizeFile% + 1 >= MaxFiles%)
4026             IF UpdateWnd% = 1
4028                 REMark ''LONGLINE
4030                 MessageWnd 200, 60, 2, CHR$(10) & "   Cannot create Directory !" & CHR$(10) & CHR$(10) & "     maximum number reached !"
4032                 RETurn 0
4034             ELSE
4036                 INK# 0, 2
4038                 REMark ''LONGLINE
4040                 PRINT# 0, "Directory not created. You have reached the maximum number of files and directories"
4042                 INK# 0, White%
4044                 RETurn -1
4046             END IF
4048         ELSE
4050             fres% = FMAKE_DIR(FullDirName$)
4052             IF (UpdateList% = 1) AND (fres% >= 0)
4054                 REMark ''LONGLINE
4056                 res% = Find%(DirName$, id%, RightFiles$, 1, RSizedir%)
4058                 IF res% = 0
4060                     REMark ''LONGLINE
4062                     res% = Insert%(DirName$, id%, RightFiles$, 1, RSizedir%, RSizeFile%, "0")
4064                 END IF
4066                 RIndex% = id%
4068                 IF UpdateWnd% = 1
4070                     id% = id% + (RMinPos% = 0)
4072                     page% = id% DIV rowno%
4074                     REMark ''LONGLINE
4076                     IF id% MOD rowno% > 0 THEN page% = page% + 1
4078                     RStartPos% = (page% - 1) * rowno% + RMinPos%
4080                     ListFiles RightFiles$, RStartPos%, RIndex%, 8
4082                 END IF
4084                 RETurn 1
4086             ELSE
4088                 IF fres% >= 0 THEN RETurn 1
4090             END IF
4092         END IF
4094     END IF
4096 :
4098     SELect ON fres%
4100       = -8, -9:
4102         REMark ''LONGLINE
4104         msg$ = "   Cannot create Directory !" & CHR$(10) & "    A file or a directory with" & CHR$(10) & "    same name already exists !"
4106 :
4108       = -11:
4110         REMark ''LONGLINE
4112         msg$ = CHR$(10) & "    Cannot create Directory" & CHR$(10) & "            Drive full"
4114 :
4116       = -15:
4118         REMark ''LONGLINE
4120         msg$ = CHR$(10) & "    Cannot create Directory" & CHR$(10) & "       Drive is not Level2"
4122 :
4124       = -19:
4126         REMark ''LONGLINE
4128         msg$ = CHR$(10) & "    Cannot create Directory" & CHR$(10) & "       Not implemented yet"
4130 :
4132       = -20:
4134         REMark ''LONGLINE
4136         msg$ = CHR$(10) & "    Cannot create Directory" & CHR$(10) & "        Drive is Read Only "
4138 :
4140       = REMAINDER :
4142         REMark ''LONGLINE
4144         msg$ = CHR$(10) & "    Cannot create Directory" & CHR$(10) & "            Error " & fres%
4146 :
4148     END SELect
4150 :
4152     IF UpdateWnd% = 1
4154         MessageWnd 200, 60, 2, msg$
4156         IF (fres% = -15) OR (fres% = -19)
4158             DELETE FullDirName$
4160         END IF
4162         RETurn 0
4164     ELSE
4166         SELect ON fres%
4168           = -8, -9:
4170             INK# 0,2
4172             REMark ''LONGLINE
4174             PRINT# 0, "Directory not created  A file or a directory with same name already exists"
4176             INK# 0, White%
4178             RETurn 0
4180 :
4182           REMark ''= -9:
4184           REMark ''  ink# 0, 2
4186           REMark ''  print# 0, "Directory not created  A directory with same name already exists"
4188           REMark ''  ink# 0, White%
4190           REMark ''  Return 0
4192 :
4194           = -11:
4196             INK# 0,2
4198             PRINT# 0, "Directory not created Drive full"
4200             INK# 0, White%
4202             RETurn -1
4204 :
4206           = -15:
4208             INK# 0, 2
4210             REMark ''LONGLINE
4212             PRINT# 0, "Directory not created  Drive is not Level2"
4214             INK# 0, White%
4216             RETurn -1
4218 :
4220           = -19:
4222             INK# 0, 2
4224             REMark ''LONGLINE
4226             PRINT# 0, "Directory not created  Operation not implemented yet for this drive type"
4228             INK# 0, White%
4230             RETurn -1
4232 :
4234           = -20:
4236             INK# 0, 2
4238             REMark ''LONGLINE
4240             PRINT# 0, "Directory not created  Drive is Read Only "
4242             INK# 0, White%
4244             RETurn -1
4246 :
4248           = REMAINDER :
4250             INK# 0, 2
4252             PRINT# 0, "Directory not created  Error " & fres%
4254             INK# 0, White%
4256             RETurn 0
4258         END SELect
4260     END IF
4262 :
4264 END DEFine
4266 :
4268 :
4270 REMark ''-----------------------------------------------------------
4272 DEFine FuNction CountSelected%
4274     LOCal i%, counter%
4276 :
4278     counter% = 0
4280 :
4282     IF crtPanel% = 7
4284         FOR i% = 1 TO LSizedir% + LSizeFile%
4286             IF GetFFlg%(LeftFiles$, i%) > 1
4288                 counter% = counter% + 1
4290             END IF
4292         END FOR i%
4294     ELSE
4296         FOR i% = 1 TO RSizedir%+RSizeFile%
4298             IF GetFFlg%(RightFiles$,i%) > 1
4300                 counter% = counter% + 1
4302             END IF
4304         END FOR i%
4306     END IF
4308     RETurn counter%
4310 END DEFine
4312 :
4314 :
4316 REMark ''---------------------------------------------------------
4318 DEFine FuNction DlgWnd%(width%, height%, title$, text$)
4320     LOCal ch%, a$, k%, AtX%, AtY%, loopa
4322 :
4324     AtX% = (maxWinWid% - width%) / 2
4326     AtY% = (256 - height%) / 2
4328     ch% = FOPEN("con")
4330     OUTLN# ch%; width%, height%, AtX%, AtY%, 4, 3
4332     BORDER# ch%, 1, Green%
4334     PAPER# ch%, White%
4336     INK# ch%, 0
4338     CLS# ch%
4340     BLOCK# ch%, width% - 4, 10, 0, 0, Green%, 1, 1
4342     PAPER# ch%, Green%
4344     INK# ch%, 0
4346     CURSOR# ch%, (width% - 6 - LEN(title$) * 6) / 2, 0
4348     PRINT# ch%, title$
4350     PAPER# ch%, White%
4352     INK# ch%, 0
4354     CURSOR# ch%, 6, 16
4356     PRINT# ch%, text$
4358     CURSOR# ch%, (width% - 198) / 2, 48:
4360     INK# ch%, 2
4362     PRINT# ch%, "    C";
4364     INK# ch%, 0
4366     PRINT# ch%, "ancel                ";
4368     INK# ch%, 2
4370     PRINT# ch%, "O";
4372     INK# ch%, 0
4374     PRINT# ch%, "k"
4376     REPeat loopa
4378        a$ = INKEY$(-1)
4380        REMark ''LONGLINE
4382        IF a$ INSTR "oO" & CHR$(10) THEN k% = 1: EXIT loopa
4384        REMark ''LONGLINE
4386        IF a$ INSTR "cC" & CHR$(27) THEN k% = 0: EXIT loopa
4388     END REPeat loopa
4390     OUTLN# ch%; width%, height%, AtX%, AtY%
4392     CLOSE# ch%
4394     RETurn k%
4396 END DEFine
4398 :
4400 :
4402 REMark ''----------------------------------------------------------
4404 DEFine FuNction TestQubideRestriction%(DirName$, panel%)
4406     LOCal i%, name$
4408 :
4410     name$ = DirName$
4412     IF name$(LEN(name$)) <> "_" THEN name$ = name$ & "_"
4414     IF panel% = 7
4416         FOR i% = LSizedir% + 1 TO LSizedir% + LSizeFile%
4418             REMark ''LONGLINE
4420             IF name$ INSTR LeftFiles$(i%) = 1 THEN RETurn 1
4422         END FOR i%
4424     ELSE
4426         FOR i% = RSizedir% + 1 TO RSizedir% + RSizeFile%
4428             REMark ''LONGLINE
4430             IF name$ INSTR RightFiles$(i%) = 1 THEN RETurn 1
4432         END FOR i%
4434     END IF
4436     RETurn 0
4438 END DEFine
4440 :
4442 :
4444 REMark ''----------------------------------------------------------
4446 DEFine FuNction IsQuillDoc%(a$)
4448     LOCal ch%, q$, i%, k%
4450 :
4452     ch% = FOPEN(a$)
4454     IF ch% <= 0 THEN RETurn 0
4456     q$ = ""
4458     BGET #ch%\1, k%
4460     FOR i% = 1 TO 8
4462         BGET# ch%, k%
4464         q$ = q$ & CHR$(k%)
4466         NEXT i%
4468     END FOR i%
4470     CLOSE# ch%
4472     IF q$ = "vrm1qdf0" THEN RETurn 1 : ELSE RETurn 0
4474 END DEFine
4476 :
4478 :
4480 REMark ''-----------------------------------------------------------
4482 DEFine FuNction IsZipFile%(a$)
4484     LOCal ch%, q$, i%, k%
4486 :
4488     ch% = FOPEN(a$)
4490     IF ch% <= 0 THEN RETurn 0
4492     q$ = ""
4494     FOR i% = 1 TO 4
4496         BGET# ch%, k%
4498         q$ = q$ & CHR$(k%)
4500         NEXT i%
4502     END FOR i%
4504     CLOSE# ch%
4506     IF q$ = "PK" & CHR$(3) & CHR$(4)
4508         RETurn 1
4510     ELSE
4512         RETurn 0
4514     END IF
4516 END DEFine
4518 :
4520 :
4522 REMark ''----------------------------------------------------------
4524 DEFine PROCedure RenameFile
4526     LOCal NewFileName$, filename$, sourcepath$
4528     LOCal res%, i%, x%, filelen$, page%
4530 :
4532     IF crtPanel% = 7
4534         IF LIndex% > LSizeFile% + LSizedir% THEN RETurn
4536     ELSE
4538         IF RIndex% > RSizeFile% + RSizedir% THEN RETurn
4540     END IF
4542     IF crtPanel% = 7
4544         filename$ = GetFNam$(LeftFiles$, LIndex%)
4546         sourcepath$ = leftDir$
4548     ELSE
4550        filename$ = GetFNam$(RightFiles$, RIndex%)
4552        sourcepath$ = rightDir$
4554     END IF
4556     IF filename$ = ".." THEN RETurn
4558     IF IsDir% = 1
4560         REMark ''LONGLINE
4562         MessageWnd 200, 60, 2, CHR$(10) & "   Cannot rename a Directory!"
4564         RETurn
4566     END IF
4568     res% = FTEST(sourcepath$ & filename$)
4570     IF res% = -9
4572         REMark ''LONGLINE
4574         MessageWnd 200, 60, 2, CHR$(10) & "   File in Use! Cannot rename!"
4576         RETurn
4578     END IF
4580     IF res% = -20
4582         REMark ''LONGLINE
4584         MessageWnd 200, 60, 2, CHR$(10) & "       File is Read Only! " & CHR$(10) & "          Cannot rename!"
4586         RETurn
4588     END IF
4590     REMark ''LONGLINE
4592     NewFileName$ = InputWnd$(240, 60, " Rename File ", "Rename " & filename$ & " to:", filename$)
4594     IF NewFileName$ = "" THEN RETurn
4596     IF LEN(sourcepath$ & NewFileName$) > 36
4598         REMark ''LONGLINE
4600         MessageWnd 200, 60, 2, CHR$(10) & "   Full file name is too long!"
4602         RETurn
4604     END IF
4606     IF FTEST(sourcepath$ & NewFileName$) <> -7
4608         REMark ''LONGLINE
4610         MessageWnd 200, 60, 2, CHR$(10) & "      A file with this name" & CHR$(10) & "          already exists!"
4612         RETurn
4614     END IF
4616     RENAME sourcepath$ & filename$ TO sourcepath$ & NewFileName$
4618     IF crtPanel% = 7
4620         filelen$ = GetFLen(LeftFiles$, LIndex%)
4622         REMark ''LONGLINE
4624         ShowHideCursor LIndex% - LStartPos%, LIndex%, LeftFiles$, 0
4626         FOR i% = LIndex% + 1 TO LSizedir% + LSizeFile%
4628             CopyRec LeftFiles$, i% TO LeftFiles$, i% - 1
4630         END FOR i%
4632         LSizeFile% = LSizeFile% - 1
4634         REMark ''LONGLINE
4636         x% = Find%(NewFileName$, id%, LeftFiles$, LSizedir% + 1, LSizedir% + LSizeFile%)
4638         REMark ''LONGLINE
4640         x% = Insert%(NewFileName$, id%, LeftFiles$, 0, LSizedir%, LSizeFile%, filelen$)
4642         LIndex% = id%
4644         x% = id% + (LMinPos% = 0)
4646         page% = x% DIV rowno%
4648         IF x% MOD rowno% > 0 THEN page% = page% + 1
4650         LStartPos% = (page% - 1) * rowno% + LMinPos%
4652         ListFiles LeftFiles$, LStartPos%, LIndex%, 7
4654     ELSE
4656         filelen$ = GetFLen(RightFiles$, RIndex%)
4658         REMark ''LONGLINE
4660         ShowHideCursor RIndex% - RStartPos%, RIndex%, RightFiles$, 0
4662         FOR i% = RIndex% + 1 TO RSizedir% + RSizeFile%
4664             CopyRec RightFiles$, i% TO RightFiles$, i% - 1
4666         END FOR i%
4668         RSizeFile% = RSizeFile% - 1
4670         REMark ''LONGLINE
4672         x% = Find%(NewFileName$, id%, RightFiles$, RSizedir% + 1, RSizedir% + RSizeFile%)
4674         REMark ''LONGLINE
4676         x% = Insert%(NewFileName$, id%, RightFiles$, 0, RSizedir%, RSizeFile%, filelen$)
4678         RIndex% = id%
4680         x% = id% + (RMinPos% = 0)
4682         page% = x% DIV rowno%
4684         IF x% MOD rowno% > 0 THEN page% = page% + 1
4686         RStartPos% = (page% - 1) * rowno% + RMinPos%
4688         ListFiles RightFiles$, RStartPos%, RIndex%, 8
4690     END IF
4692 END DEFine
4694 :
4696 :
4698 :
4700 REMark ''-----------------------------------------------------------
4702 DEFine PROCedure ShowInfo
4704    LOCal filename$(36), path$(36), chf%, ch%, ch1%, ch2%
4706    LOCal x%, k$(2), windef$, left%, top%
4708 :
4710     IF crtPanel% = 7
4712         IF LIndex% > LSizeFile% + LSizedir% THEN RETurn
4714     ELSE
4716         IF RIndex% > RSizeFile% + RSizedir% THEN RETurn
4718     END IF
4720 :
4722     IF crtPanel% = 7
4724         filename$ = GetFNam$(LeftFiles$, LIndex%)
4726         path$ = leftDir$
4728     ELSE
4730         filename$ = GetFNam$(RightFiles$, RIndex%)
4732         path$ = rightDir$
4734     END IF
4736 :
4738     IF filename$ = ".." THEN RETurn
4740     left% = (maxWinWid% - 452) DIV 2
4742     IF maxWinHgt% > 256 THEN top% = 51: ELSE top% = 14
4744     windef$ = "scr_452x230a" & left% & "x" & top%
4746     ch% = FOPEN(windef$)
4748     PAPER# ch%, 0
4750     INK# ch%, White%
4752     OUTLN# ch%, 452, 230, left%, top%
4754     BORDER# ch%, 1, 2
4756     CLS #ch%
4758     windef$ = "scr_452x12a" & left% & "x" & top%
4760     ch1% = FOPEN(windef$)
4762     BORDER# ch1%, 1, 2
4764     PAPER# ch1%, 0, 2, 1
4766     CLS# ch1%
4768     PAPER# ch1%, 0
4770     INK# ch1%, White%
4772     AT# ch1%, 0, 34
4774     PRINT# ch1%, " Info "
4776     windef$ = "scr_448x204a" & (left% + 2) & "x" & (top% + 12)
4778     ch2% = FOPEN(windef$)
4780     PAPER# ch2%, 0
4782     INK# ch2%, Green%
4784     PRINT# ch2%, "Full name: "; path$ & filename$; CHR$(10);
4786 :
4788     chf% = FOPEN(path$ & filename$)
4790     IF chf% < 0
4792         INK# ch2%, 2
4794         SELect ON chf%
4796           = -7:
4798             PRINT# ch2%, "File Not Found !"
4800 :
4802           = -9:
4804             PRINT# ch2%, "File in use"
4806 :
4808           = REMAINDER :
4810             PRINT# ch2%, "Error ";chf%
4812 :
4814         END SELect
4816         INK 4
4818     ELSE
4820         GetHEAD# chf%, headBuff
4822         PRINT# ch2%, "File Length:";
4824         REMark ''LONGLINE
4826         PRINT_USING# ch2%, "##,###,###. bytes\", PEEK_L(headBuff)
4828         x% = PEEK(headBuff + 5)
4830         PRINT# ch2%, "File Type:   "; x%; " - ";
4832 :
4834         SELect ON x%
4836           =  0:
4838             REMark ''LONGLINE
4840             PRINT# ch2%, "BASIC, CALLable machine code, extensions or DATA file"
4842 :
4844           =  1:
4846             PRINT# ch2%, "EXECable file"
4848 :
4850           =  2:
4852             REMark ''LONGLINE
4854             PRINT# ch2%, "SROFF file used by linkers etc, a C68 Library file etc"
4856 :
4858           =  3:
4860             REMark ''LONGLINE
4862             PRINT# ch2%, "THOR hard disc directory file. (I think!)"
4864 :
4866           =  4:
4868             PRINT# ch2%, "A font file for The Painter"
4870 :
4872           =  5:
4874             PRINT# ch2%, "A pattern file for The Painter"
4876 :
4878           =  6:
4880             REMark ''LONGLINE
4882             PRINT# ch2%, "A compressed mode 4 screen in The Painter"
4884 :
4886           = 11:
4888             REMark ''LONGLINE
4890             PRINT# ch2%, "A compressed mode 8 screen in The Painter"
4892 :
4894           =255:
4896             REMark ''LONGLINE
4898             PRINT# ch2%, "Level 2 driver directory or sub-directory file"
4900 :
4902           =REMAINDER :
4904             PRINT# ch2%, " "
4906         END SELect
4908 :
4910         PRINT# ch2%, "Data-space: ";
4912         IF x% = 1
4914             REMark ''LONGLINE
4916             PRINT_USING# ch2%, "##,###,###. bytes\", PEEK_L(headBuff + 6)
4918         ELSE
4920             PRINT# ch2%, "   n/a"
4922         END IF
4924         PRINT# ch2%, "File Version:  "; PEEK_W(headBuff + 56)
4926         PRINT# ch2%, "Last modified: ";
4928         d = PEEK_L(headBuff + 52)
4930         IF d
4932             PRINT# ch2%, DATE$(d)
4934         ELSE
4936             PRINT# ch2%, "<not-set>"
4938         END IF
4940         PRINT# ch2%, "Backup date:   ";
4942         d = PEEK_L(headBuff + 60)
4944         IF d
4946             PRINT# ch2%, DATE$(d)
4948         ELSE
4950             PRINT# ch2%, "<not-set>"
4952         END IF
4954         CLOSE# chf%
4956     END IF
4958 :
4960     REMark ''LONGLINE
4962     PRINT# ch2%, CHR$(10); "------------------------------------------------------------------------"; CHR$(10)
4964     PRINT# ch2%, "ROM Version:  "; VER$
4966     PRINT# ch2%, "QDOS Version: "; VER$(1)
4968     PRINT# ch2%, "Current RAMTOP: ";
4970     PRINT_USING# ch2%, "##,###.#", RESPR(0) / 1024 - 128
4972     PRINT# ch2%, " Kb"
4974     PRINT# ch2%, "Free memory:    ";
4976     PRINT_USING# ch2%, "##,###.#", FREE_MEM / 1024
4978     PRINT# ch2%, " Kb"
4980     PRINT# ch2%
4982     PRINT# ch2%, "DataD$: "; DATAD$
4984     PRINT# ch2%, "ProgD$: "; PROGD$
4986     PRINT# ch2%, "DestD$: "; DESTD$
4988 :
4990     k$ = INKEY$(-1)
4992     CLS# ch1%
4994     CLS# ch2%
4996     CLOSE# ch2%
4998     CLOSE# ch1%
5000     OUTLN# ch%, 452, 230, left%, top%
5002     CLOSE# ch%
5004 :
5006 END DEFine
5008 :
5010 :
5012 REMark ''----------------------------------------------------------
5014 DEFine PROCedure WriteCommands(ch%)
5016     LOCal lat, px%, px1%, i%, x%, lat%(9)
5018 :
5020     lat = (comWinWid% - 4) DIV 9
5022     rest = (comWinWid% - 4) MOD 9
5024     FOR i% = 1 TO 9 : lat%(i%) = lat : NEXT i%
5026     IF rest >= 0 THEN lat%(4) = lat + 1
5028     IF rest >= 1 THEN lat%(3) = lat + 1
5030     IF rest >= 2 THEN lat%(5) = lat + 1
5032     IF rest >= 3 THEN lat%(1) = lat + 1
5034     IF rest >= 4 THEN lat%(2) = lat + 1
5036     IF rest >= 5 THEN lat%(6) = lat + 1
5038     IF rest >= 6 THEN lat%(7) = lat + 1
5040     IF rest >= 7 THEN lat%(8) = lat + 1
5042     IF rest >= 8 THEN lat%(9) = lat + 1
5044     px% = 0
5046     PAPER# ch%, PPR9a%, ppr9b%, 3
5048 :
5050     FOR i% = 1 TO 9
5052         REMark ''LONGLINE
5054         BLOCK# ch%, lat%(i%) - 1, mainFountHeight%, px%, 0, PPR9a%, ppr9b%, 3
5056         REMark ''LONGLINE
5058         x% = px% + (lat%(i%) - 1 - LEN(cmdText$(i%)) * comFountWid%) DIV 2
5060         CURSOR# ch%, x%, 0
5062         PRINT# ch%, cmdText$(i%);
5064         px% = px% + lat%(i%)
5066     END FOR i%
5068 :
5070 END DEFine
5072 :
5074 :
5076 REMark ''----------------------------------------------------------
5078 DEFine FuNction IsReadOnly%(a$)
5080   LOCal res%
5082 :
5084   res% = FOPEN(a$ & CHR$(0))
5086   IF res% = -20 THEN RETurn 1
5088   IF res% > 0 THEN DELETE a$ & CHR$(0)
5090   RETurn 0
5092 END DEFine
5094 :
5096 :
5098 REMark ''----------------------------------------------------------
5100 DEFine PROCedure CopyFiles
5102     LOCal k%, x%, name$, source$, dest$, filelen$, panel%
5104 :
5106     x% = CountSelected%
5108     IF crtPanel% = 7
5110         source$ = leftDir$ : dest$ = rightDir$
5112         name$ = GetFNam$(LeftFiles$, LIndex%)
5114         filelen$ = GetFLen(LeftFiles$, LIndex%)
5116         panel% = 8
5118     ELSE
5120         dest$ = leftDir$ : source$ = rightDir$
5122         name$ = GetFNam$(RightFiles$, RIndex%)
5124         filelen$ = GetFLen(RightFiles$, RIndex%)
5126         panel% = 7
5128     END IF
5130 :
5132     IF IsReadOnly%(dest$)
5134         REMark ''LONGLINE
5136         MessageWnd 200, 60, 2, CHR$(10) & "    Destination is Read Only! " & CHR$(10) & "           Cannot copy!"
5138         RETurn
5140     END IF
5142 :
5144     IF x% > 0
5146         REMark ''LONGLINE
5148         k% = DlgWnd%(240, 60, " Copy Files ", "    Are you sure you want to copy" & CHR$(10) & "     " & x% & " files and directories ?")
5150         IF k% = 1 THEN CopyMultipleFiles x%
5152     ELSE
5154         IF IsDir% = 1
5156             CopySingleDir name$, source$, dest$, panel%
5158         ELSE
5160             IF LEN(dest$&name$) > 41
5162                 REMark ''LONGLINE
5164                 MessageWnd 200, 60, 2, CHR$(10)&"        Cannot copy file"&CHR$(10)&"          Name too long !"
5166                 RETurn
5168             END IF
5170             k% = FTEST(dest$ & name$)
5172             IF k% = -7
5174                 IF crtPanel% = 7
5176                     IF RSizedir% + RSizeFile% + 1 >= MaxFiles%
5178                         REMark ''LONGLINE
5180                         MessageWnd 200, 60, 2, CHR$(10) & "        Cannot copy file" & CHR$(10) & "      maximum number reached !"
5182                         RETurn
5184                     END IF
5186                 ELSE
5188                     IF LSizedir% + LSizeFile% + 1 >= MaxFiles%
5190                         REMark ''LONGLINE
5192                         MessageWnd 200, 60, 2, CHR$(10) & "        Cannot copy file" & CHR$(10) & "      maximum number reached !"
5194                         RETurn
5196                     END IF
5198                 END IF
5200                 Copy1File name$, source$, dest$, filelen$, 1
5202                 RETurn
5204             ELSE
5206                 IF k% = 0
5208                     REMark ''LONGLINE
5210                     x% = DlgWnd%(240, 60, " Copy Files ", "   Destination file already exists" & CHR$(10) & "              Overwrite ?")
5212                     IF x% = 1
5214                         Copy1File name$, source$, dest$, filelen$, 1
5216                         RETurn
5218                     END IF
5220                 ELSE
5222                    SELect ON k%
5224                      =  -9:
5226                         REMark ''LONGLINE
5228                        MessageWnd 200, 60, 2, CHR$(10) & "      Destination is in use " & CHR$(10) & "           Cannot copy!" : RETurn
5230 :
5232                      = -11:
5234                         REMark ''LONGLINE
5236                        MessageWnd 200, 60, 2, CHR$(10) & "    Destination drive is full" & CHR$(10) & "           Cannot copy!" : RETurn
5238 :
5240                      = -16:
5242                         REMark ''LONGLINE
5244                        MessageWnd 200, 60, 2, CHR$(10) & "      Bad or Changed Medium" & CHR$(10) & "           Cannot copy!" : RETurn
5246 :
5248                      = -20:
5250                         REMark ''LONGLINE
5252                        MessageWnd 200, 60, 2, CHR$(10) & "    Destination is Read Only! " & CHR$(10) & "           Cannot copy!" : RETurn
5254 :
5256                      = REMAINDER :
5258                         REMark ''LONGLINE
5260                        MessageWnd 200, 60, 2, CHR$(10) & "     Error copying file : " & k% : RETurn
5262                    END SELect
5264                 END IF
5266             END IF
5268         END IF
5270 :
5272         IF crtPanel% = 7
5274             id% = RIndex% + (RMinPos% = 0)
5276             page% = id% DIV rowno%
5278             IF id% MOD rowno% > 0 THEN page% = page% + 1
5280             RStartPos% = (page% - 1) * rowno% + RMinPos%
5282             ListFiles RightFiles$, RStartPos%, RIndex%, 8
5284         ELSE
5286             id% = LIndex% + (LMinPos% = 0)
5288             page% = id% DIV rowno%
5290             IF id% MOD rowno% > 0 THEN page% = page% + 1
5292             LStartPos% = (page% - 1) * rowno% + LMinPos%
5294             ListFiles LeftFiles$, LStartPos%, LIndex%, 7
5296         END IF
5298 :
5300     END IF
5302 END DEFine
5304 :
5306 :
5308 REMark ''-----------------------------------------------------------
5310 DEFine PROCedure Copy1File(name$, source$, dest$, filelen$, UpdateList%)
5312     LOCal x%, page%
5314 :
5316     COPY_O source$ & name$ TO dest$ & name$
5318     IF crtPanel% = 8
5320         REMark ''LONGLINE
5322         x% = Find%(name$, id%, LeftFiles$, LSizedir% + 1, LSizedir% + LSizeFile%)
5324         IF x% = 0
5326             REMark ''LONGLINE
5328             x% = Insert%(name$, id%, LeftFiles$, 0, LSizedir%, LSizeFile%, filelen$)
5330         ELSE
5332             PutFLen LeftFiles$, id%, filelen$
5334         END IF
5336         LIndex% = id%
5338         IF UpdateList% = 1
5340             id% = id% + (LMinPos% = 0)
5342             page% = id% DIV rowno%
5344             IF id% MOD rowno% > 0 THEN page% = page% + 1
5346             LStartPos% = (page% - 1) * rowno% + LMinPos%
5348             ListFiles LeftFiles$, LStartPos%, LIndex%, 7
5350         END IF
5352     ELSE
5354         REMark ''LONGLINE
5356         x% = Find%(name$, id%, RightFiles$, RSizedir% + 1, RSizedir% + RSizeFile%)
5358         IF x% = 0
5360             REMark ''LONGLINE
5362             x% = Insert%(name$, id%, RightFiles$, 0, RSizedir%, RSizeFile%, filelen$) :
5364         ELSE
5366             PutFLen RightFiles$, id%, filelen$
5368         END IF
5370         RIndex% = id%
5372         IF UpdateList% = 1
5374             id% = id% + (RMinPos% = 0)
5376             page% = id% DIV rowno%
5378             IF id% MOD rowno% > 0 THEN page% = page% + 1
5380             RStartPos% = (page% - 1) * rowno% + RMinPos%
5382             ListFiles RightFiles$, RStartPos%, RIndex%, 8
5384         END IF
5386     END IF
5388 END DEFine
5390 :
5392 :
5394 REMark ''----------------------------------------------------------
5396 DEFine PROCedure CopyDirFiles(name$, source$, dest$, CreateWnd%)
5398     LOCal ch%, ch1%
5400 :
5402     IF CreateWnd% = 1
5404         ch% = FOPEN("scr_400x156a56x50")
5406         PAPER# ch%, 0
5408         INK# ch%, 7
5410         OUTLN# ch%, 400, 156, 56, 50
5412         BORDER# ch%, 1, 2
5414         CLS# ch%
5416         ch1% = FOPEN("scr_398x12a57x51")
5418         BORDER# ch1%, 1, 2
5420         PAPER# ch1%, 0, 2, 1
5422         CLS# ch1%
5424         PAPER# ch1%, 0
5426         INK# ch1%, 7
5428         AT# ch1%, 0, 25
5430         PRINT# ch1%, " Copy Directory "
5432         WINDOW# 0, 396, 140, 58, 63
5434         PAPER# 0, 0
5436         INK# 0, White%
5438         CLS# 0
5440     END IF
5442 :
5444     PRINT# 0, "Copy " & source$ & name$ & " to " & dest$ & name$
5446     WCOPY source$ & name$ TO dest$ & name$
5448     IF CreateWnd% = 1
5450         INK# 0, Green%
5452         REMark ''LONGLINE
5454         PRINT# 0, "Copy process ended - press any key to close window"
5456         INK# 0, White%
5458         x% = KEYROW(0)
5460         a$ = INKEY$(-1)
5462         WINDOW# 0, 448, 12, 32, 231:
5464         CLOSE# ch1%
5466         OUTLN# ch%, 400, 156, 56, 50
5468         CLOSE# ch%
5470     END IF
5472 END DEFine
5474 :
5476 :
5478 REMark ''----------------------------------------------------------
5480 DEFine PROCedure CopyMultipleFiles(k%)
5482     LOCal ch%, ch1%, i%, x%, a$, Index%, panel%
5484     LOCal page%, id%, left%,windef$, hgt%, wid%
5486 :
5488     IF panelWinWid% * 2 > 602
5490         wid% = 600
5492     ELSE
5494         wid% = 400
5496     END IF
5498 :
5500     hgt% = panelWinHeight% * 8 DIV 10
5502     left% = (maxWinWid% - wid%) DIV 2
5504     windef$ = "scr_" & wid% & "x" & hgt% & "a" & left% & "x50"
5506     ch% = FOPEN(windef$)
5508     PAPER# ch%, 0
5510     INK# ch%, White%
5512     OUTLN# ch%, wid%, hgt%, left%, 50
5514     BORDER# ch%, 1, 2
5516     CLS# ch%
5518     left% = left% + 1
5520     windef$ = "scr_" & (wid% - 2) & "x12a" & left% & "x51"
5522     ch1% = FOPEN(windef$)
5524     BORDER# ch1%, 1, 2
5526     PAPER# ch1%, 0, 2, 1
5528     CLS# ch1%
5530     PAPER# ch1%, 0
5532     INK# ch1%, White%
5534     CURSOR# ch1%, (wid% - 90) DIV 2, 0
5536     PRINT# ch1%, " Copy Selected "
5538     WINDOW# 0, wid% - 4, hgt% - 16, left% + 1, 63
5540     PAPER# 0, 0
5542     INK# 0, White%
5544     CLS# 0
5546     REMark ''LONGLINE
5548     PRINT# 0, "Copy Selected list: " & k% & " files and/or directories"
5550 :
5552     IF crtPanel% = 7
5554         source$ = leftDir$
5556         dest$ = rightDir$
5558         Index% = LIndex%
5560         panel% = 8
5562         FOR i% = 1 TO LSizedir% + LSizeFile%
5564             LIndex% = i%
5566             IF GetFFlg%(LeftFiles$, i%) > 1
5568                 IF GetFFlg%(LeftFiles$, i%) = 2
5570                     REMark ''LONGLINE
5572                     PRINT# 0, "Copying file " & GetFNam$(LeftFiles$, i%) & " ..."
5574                     REMark ''LONGLINE
5576                     x% = CopyAListFile%(GetFNam$(LeftFiles$, i%), source$, dest$, GetFLen(LeftFiles$, i%), 8)
5578                 ELSE
5580                     REMark ''LONGLINE
5582                     PRINT# 0, "Copying directory " & GetFNam$(LeftFiles$, i%) & " ..."
5584                     REMark ''LONGLINE
5586                     x% = CopyFullDir%(GetFNam$(LeftFiles$, i%), source$, dest$, 8, 0, 1, 1)
5588                 END IF
5590                 IF x% = -1 THEN EXIT i%
5592                 REMark ''LONGLINE
5594                 PutFFlg LeftFiles$, i%, GetFFlg%(LeftFiles$, i%) ^^ 2
5596             END IF
5598             NEXT i%
5600         END FOR i%
5602         LIndex% = Index%
5604     ELSE
5606         source$ = rightDir$
5608         dest$ = leftDir$
5610         Index% = RIndex%
5612         FOR i% = 1 TO RSizedir% + RSizeFile%
5614             RIndex% = i%
5616             IF GetFFlg%(RightFiles$, i%) > 1
5618                 IF GetFFlg%(RightFiles$,i%) = 2
5620                     REMark ''LONGLINE
5622                     PRINT# 0, "Copying file " & GetFNam$(RightFiles$, i%) & " ..."
5624                     REMark ''LONGLINE
5626                     x% = CopyAListFile%(GetFNam$(RightFiles$, i%), source$, dest$, GetFLen(RightFiles$, i%), 7)
5628                 ELSE
5630                     REMark ''LONGLINE
5632                     PRINT# 0, "Copying directory " & GetFNam$(RightFiles$, i%) & " ..."
5634                     REMark ''LONGLINE
5636                     x% = CopyFullDir%(GetFNam$(RightFiles$, i%), source$, dest$, 7, 0, 1, 1)
5638                 END IF
5640                 IF x% = -1 THEN EXIT i%
5642                 REMark ''LONGLINE
5644                 PutFFlg RightFiles$, i%, GetFFlg%(RightFiles$, i%) ^^ 2
5646             END IF
5648             NEXT i%
5650         END FOR i%
5652         RIndex% = Index%
5654     END IF
5656 :
5658     INK# 0, Green%
5660     REMark ''LONGLINE
5662     PRINT# 0, "Copy process ended - press any key to close window"
5664     INK# 0, White%
5666     x% = KEYROW(0)
5668     a$ = INKEY$(-1)
5670     WINDOW# 0, 448, 12, 32, 231:
5672     CLOSE# ch1%
5674     OUTLN# ch%, wid%, hgt%, left% - 1, 50
5676     CLOSE# ch%
5678     id% = RIndex% + (RMinPos% = 0)
5680     page% = id% DIV rowno%
5682     IF id% MOD rowno% > 0 THEN page% = page% + 1
5684     RStartPos% = (page% - 1) * rowno% + RMinPos%
5686     ListFiles RightFiles$, RStartPos%, RIndex%, 8
5688     id% = LIndex% + (LMinPos% = 0)
5690     page% = id% DIV rowno%
5692     IF id% MOD rowno% > 0 THEN page% = page% + 1
5694     LStartPos% = (page% - 1) * rowno% + LMinPos%
5696     ListFiles LeftFiles$, LStartPos%, LIndex%, 7
5698 END DEFine
5700 :
5702 :
5704 REMark ''----------------------------------------------------------
5706 DEFine FuNction CopyAListFile%(name$, source$, dest$, filelen$, panel%)
5708     LOCal k%
5710 :
5712     IF LEN(dest$ & name$) > 41
5714         INK# 0, 2
5716         PRINT# 0, name$ & " not copied. Name too long"
5718         INK# 0, White%
5720         RETurn 0
5722     END IF
5724 :
5726     k% = FTEST(dest$ & name$)
5728 :
5730     IF k% = -7
5732         IF panel% = 8
5734             IF RSizedir% + RSizeFile% + 1 >= MaxFiles%
5736                 INK# 0, 2
5738                 REMark ''LONGLINE
5740                 PRINT# 0, "Maximum number reached on destination directory!"
5742                 INK# 0, White%
5744                 RETurn -1
5746             END IF
5748         ELSE
5750             IF LSizedir% + LSizeFile% + 1 >= MaxFiles%
5752                 INK# 0, 2
5754                 REMark ''LONGLINE
5756                 PRINT# 0, "Maximum number reached on destination directory!"
5758                 INK# 0, White%
5760                 RETurn -1
5762             END IF
5764         END IF
5766         Copy1File name$, source$, dest$, filelen$, 0
5768         RETurn 1
5770     ELSE
5772         IF k% = 0
5774             PRINT# 0, "File already exists Overwrite (Y/N) ?"
5776             REPeat loopa
5778                 a$ = INKEY$(-1)
5780                 IF a$ INSTR "yYnN" THEN EXIT loopa
5782             END REPeat loopa
5784             IF a$ = "y" OR a$ = "Y"
5786                 Copy1File name$, source$, dest$, filelen$, 0
5788                 RETurn 1
5790             ELSE
5792                 RETurn 0
5794             END IF
5796         ELSE
5798             SELect ON k%
5800               =  -9:
5802                 INK# 0, 2
5804                 REMark ''LONGLINE
5806                 PRINT# 0, name$ & "not copied. Destination is in use"
5808                 INK# 0, White%
5810                 RETurn 0
5812 :
5814               = -11:
5816                 INK# 0, 2
5818                 REMark ''LONGLINE
5820                 PRINT# 0, name$ & "not copied. Destination drive is full"
5822                 INK# 0, White%
5824                 RETurn -1
5826 :
5828               = -16:
5830                 INK# 0, 2
5832                 REMark ''LONGLINE
5834                 PRINT# 0, name$ & "not copied. Destination Bad or Changed Medium"
5836                 INK# 0, White%
5838                 RETurn -1
5840 :
5842               = -20:
5844                 INK# 0, 2
5846                 REMark ''LONGLINE
5848                 PRINT# 0, name$ & "not copied. Destination is Read Only! "
5850                 INK# 0, White%
5852                 RETurn 0
5854 :
5856               = REMAINDER :
5858                 INK# 0, 2
5860                 PRINT# 0, name$ & "not copied. Error " & k%
5862                 INK# 0, White%
5864                 RETurn 0
5866 :
5868             END SELect
5870         END IF
5872     END IF
5874 END DEFine
5876 :
5878 :
5880 REMark ''-----------------------------------------------------------
5882 DEFine PROCedure DeleteFiles
5884     LOCal source$, name$, panel%, x%, k%, a$, ch%, ch1%
5886     LOCal Index%, left%, windef$, hgt%, wid%
5888 :
5890     IF crtPanel% = 7
5892         source$ = leftDir$
5894         name$ = GetFNam$(LeftFiles$,LIndex%)
5896         panel% = 7
5898         Index% = LIndex%
5900     ELSE
5902         source$ = rightDir$
5904         name$ = GetFNam$(RightFiles$,RIndex%)
5906         panel% = 8
5908         Index% = RIndex%
5910     END IF
5912 :
5914     IF IsReadOnly%(source$)
5916         REMark ''LONGLINE
5918         MessageWnd 200, 60, 2, CHR$(10) & "       Drive is Read Only! "
5920         RETurn
5922     END IF
5924 :
5926     x% = CountSelected%
5928 :
5930     IF x% > 0
5932         REMark ''LONGLINE
5934         k% = DlgWnd%(240, 60, " Delete Files ", "   Are you sure you want to delete" & CHR$(10) & "     " & x% & " files and directories ?")
5936     ELSE
5938         IF IsDir% = 1
5940             a$ = "directory " & name$
5942         ELSE
5944             a$ = "file " & name$
5946         END IF
5948         k% = (39 - LEN(a$)) DIV 2
5950         IF k% < 0 THEN k% = 0
5952         REMark ''LONGLINE
5954         a$ = "   Are you sure you want to delete" & CHR$(10) & FILL$(" ", k%) & a$
5956         k% = DlgWnd%(240, 60, " Delete File ", a$)
5958     END IF
5960 :
5962     IF k% = 0 THEN RETurn
5964     IF panelWinWid% * 2 > 602
5966         wid% = 600
5968     ELSE
5970         wid% = 400
5972     END IF
5974     hgt% = panelWinHeight% * 8 DIV  10
5976     left% = (maxWinWid% - wid%) DIV 2
5978     windef$ = "scr_" & wid% & "x" & hgt% & "a" & left% & "x50"
5980     ch% = FOPEN(windef$)
5982     PAPER# ch%, 0
5984     INK# ch%, White%
5986     OUTLN# ch%, wid%, hgt%, left%, 50
5988     BORDER# ch%, 1, 2
5990     CLS# ch%
5992     left% = left% + 1
5994     windef$ = "scr_" & (wid% - 2) & "x12a" & left% & "x51"
5996     ch1% = FOPEN(windef$)
5998     BORDER# ch1%, 1, 2
6000     PAPER# ch1%, 0, 2, 1
6002     CLS# ch1%
6004     PAPER# ch1%, 0
6006     INK# ch1%, White%
6008     CURSOR# ch1%, (wid% - 84) DIV 2, 0
6010     PRINT# ch1%, " Delete Files "
6012     WINDOW# 0, wid% - 4, hgt% - 16, left% + 1, 63
6014     PAPER# 0, 0
6016     INK# 0, White%
6018     CLS# 0
6020 :
6022     IF x% = 0
6024         IF IsDir% = 0
6026             PRINT# 0, "Deleting file " & source$ & name$
6028             DELETE source$ & name$
6030         ELSE
6032             IF DeleteDirectory(source$, name$) = 0
6034                 INK# 0, 2
6036                 REMark ''LONGLINE
6038                 PRINT# 0, "Could not delete all of " & source$ & name$ & "_"
6040                 INK# 0, White%
6042             END IF
6044         END IF
6046     ELSE
6048         REMark ''LONGLINE
6050         PRINT# 0, "Delete Selected list: " & x% & " files and/or directories"
6052         IF crtPanel% = 7
6054             FOR k% = 1 TO LSizedir% + LSizeFile%
6056                 IF GetFFlg%(LeftFiles$,k%) > 1
6058                     IF GetFFlg%(LeftFiles$,k%) = 2
6060                         REMark ''LONGLINE
6062                         PRINT# 0, "Deleting file " & GetFNam$(LeftFiles$, k%) & " ..."
6064                         REMark ''LONGLINE
6066                         DELETE source$ & GetFNam$(LeftFiles$, k%)
6068                     ELSE
6070                         REMark ''LONGLINE
6072                         IF DeleteDirectory(source$, GetFNam$(LeftFiles$, k%)) = 0
6074                             INK# 0, 2
6076                             REMark ''LONGLINE
6078                             PRINT# 0, "Could not delete all of " & source$ & GetFNam$(LeftFiles$, k%) & "_"
6080                             INK# 0, White%
6082                         END IF
6084                     END IF
6086                 END IF
6088                 NEXT k%
6090             END FOR k%
6092         ELSE
6094             FOR k% = 1 TO RSizedir% + RSizeFile%
6096                 IF GetFFlg%(RightFiles$, k%) > 1
6098                     IF GetFFlg%(RightFiles$, k%) = 2
6100                         REMark ''LONGLINE
6102                         PRINT# 0, "Deleting file " & GetFNam$(RightFiles$, k%) & " ..."
6104                         REMark ''LONGLINE
6106                         DELETE source$ & GetFNam$(RightFiles$, k%)
6108                     ELSE
6110                         REMark ''LONGLINE
6112                         IF DeleteDirectory(source$, GetFNam$(RightFiles$, k%))
6114                             INK# 0, 2
6116                             REMark ''LONGLINE
6118                             PRINT# 0, "Could not delete all of " & source$ & GetFNam$(RightFiles$, k%) & "_"
6120                             INK# 0, White%
6122                         END IF
6124                     END IF
6126                 END IF
6128                 NEXT k%
6130             END FOR k%
6132         END IF
6134     END IF
6136 :
6138     INK# 0, Green%
6140     REMark ''LONGLINE
6142     PRINT# 0, "Delete process ended - press any key to close window"
6144     INK# 0, White%
6146 :
6148     x% = KEYROW(0)
6150     a$ = INKEY$(-1)
6152 :
6154     WINDOW# 0, 448, 12, 32, 231:
6156     CLOSE# ch1%
6158     OUTLN# ch%, wid%, hgt%, left% - 1, 50
6160     CLOSE# ch%
6162 :
6164     IF crtPanel% = 7
6166         ReloadPanel 7, Index%
6168     ELSE
6170         ReloadPanel 8, Index%
6172     END IF
6174 END DEFine
6176 :
6178 :
6180 REMark ''-----------------------------------------------------------
6182 DEFine PROCedure EXecFile
6184     LOCal filename$, path$, chf%, x%
6186 :
6188     IF crtPanel% = 7
6190         IF LIndex% > LSizeFile% + LSizedir% THEN RETurn
6192         filename$ = GetFNam$(LeftFiles$, LIndex%)
6194         path$ = leftDir$
6196     ELSE
6198         IF RIndex% > RSizeFile% + RSizedir% THEN RETurn
6200         filename$ = GetFNam$(RightFiles$, RIndex%)
6202         path$ = rightDir$
6204     END IF
6206     chf% = FOPEN(path$ & filename$)
6208     IF chf% < 0
6210         SELect ON chf%
6212           = -7:
6214             REMark ''LONGLINE
6216             MessageWnd 200, 60, 2, CHR$(10) & "         File Not Found !"
6218 :
6220           = -9:
6222             REMark ''LONGLINE
6224             MessageWnd 200, 60, 2, CHR$(10) & "           File in use"
6226 :
6228           = REMAINDER :
6230             REMark ''LONGLINE
6232             MessageWnd 200, 60, 2, CHR$(10) & "             Error " & chf%
6234         END SELect
6236      ELSE
6238         CLOSE# chf%
6240         x% = FTYP(\path$ & filename$)
6242         IF x% <> 1
6244             REMark ''LONGLINE
6246             MessageWnd 200, 60, 2, CHR$(10) & "   This is not a EXECable file"
6248         ELSE
6250             EX path$ & filename$
6252         END IF
6254     END IF
6256 END DEFine
6258 :
6260 :
6262 REMark ''----------------------------------------------------------
6264 DEFine FuNction getKey$(c%)
6266     LOCal k$(2)
6268 :
6270     CURSEN #c%
6272     k$ = INKEY$(c%, -1)
6274     CURDIS #c%
6276     RETurn k$
6278 END DEFine getKey$
6280 :
6282 :
6284 REMark ''----------------------------------------------------------
6286 DEFine PROCedure OnEnter
6288     LOCal ext$(10), path$, a$, x%, i%
6290 :
6292     IF crtPanel% = 7
6294         IF LIndex% > LSizedir% + LSizeFile% THEN RETurn
6296         a$ = GetFNam$(LeftFiles$, LIndex%)
6298         path$ = leftDir$
6300     ELSE
6302         IF RIndex% > RSizedir% + RSizeFile% THEN RETurn
6304         a$ = GetFNam$(RightFiles$, RIndex%)
6306         path$ = rightDir$
6308     END IF
6310     IF a$ == ".." OR IsDir% = 1
6312         IF crtPanel% = 7
6314             OpenSubDir LeftFiles$, LIndex%, 7
6316         ELSE
6318             OpenSubDir RightFiles$, RIndex%, 8
6320         END IF
6322         RETurn
6324     END IF
6326 :
6328     IF FTYP(\path$ & a$) = 1
6330         EXecFile
6332         RETurn
6334     END IF
6336 :
6338     REMark ''now get file extension
6340     x% = LEN(a$)
6342     FOR i% = 0 TO x% - 1
6344         IF a$(x% - i%) == "_" THEN EXIT i%
6346         NEXT i%
6348     END FOR i%
6350     IF i% > 0
6352         ext$ = a$(x% - i% TO x%)
6354     ELSE
6356         ext$ = ""
6358     END IF
6360     ext$ = LOWER$(ext$) : x% = 0
6362 :
6364     IF ext$ = "_bas" THEN x% = 1
6366     REMark ''LONGLINE
6368     IF ext$ = "_cde" OR ext$ = "_code" OR ext$ = "_rext" THEN x% = 2
6370     IF ext$ = "_zip" THEN x% = 3
6372     IF ext$ = "_doc" THEN x% = 4
6374     IF ext$ = "_aba" THEN x% = 5
6376     IF ext$ = "_grf" THEN x% = 6
6378     IF ext$ = "_dbf" THEN x% = 7
6380     IF ext$ = "_ssb" THEN x% = 9
6382     IF a$ = "boot" THEN x% = 1
6384 :
6386     SELect ON x%
6388       = 1:
6390         dbg(path$ & a$)
6392         LoadBasFile(path$ & a$)
6394 :
6396       = 2:
6398         DoLrespr path$ & a$
6400 :
6402       = 3:
6404         IF IsZipFile%(path$ & a$) = 1 THEN UnzipFile path$ & a$
6406 :
6408       = 4:
6410         IF IsQuillDoc%(path$ & a$) = 1
6412             IF Xchangeprog$ <> ""
6414                 ExecXchange path$, path$ & a$
6416             END IF
6418         END IF
6420 :
6422       = 5:
6424         IF IsAbacusDoc%(path$ & a$) = 1
6426             IF Xchangeprog$ <> ""
6428                 ExecXchange path$, path$ & a$
6430             END IF
6432         END IF
6434 :
6436       = 6:
6438         IF Xchangeprog$ <> ""
6440             ExecXchange path$, path$ & a$
6442         END IF
6444 :
6446       = 7:
6448         IF IsArchiveDoc%(path$ & a$) = 1
6450             IF Xchangeprog$ <> ""
6452                 ExecXchange path$, path$ & a$
6454             END IF
6456         END IF
6458 :
6460       = 8:
6462         REMark ''LONGLINE
6464         x% = DlgWnd%(240, 60, " Archive Prg ", "     " & a$ & CHR$(10) & "      Open with Xchange Archive ?")
6466         IF x% = 0 THEN RETurn
6468         ExecXchange path$, path$ & a$
6470 :
6472       = 9:
6474         dbg(path$ & a$)
6476         LoadSsbFile(path$ & a$)
6478 :
6480     END SELect
6482 END DEFine
6484 :
6486 :
6488 REMark ''----------------------------------------------------------
6490 DEFine PROCedure UnzipFile (filename$)
6492     LOCal path$, ch%, ch1%, ch2%
6494 :
6496     IF crtPanel% = 7
6498         IF LIndex% > LSizedir% + LSizeFile% THEN RETurn
6500         path$ = rightDir$
6502     ELSE
6504         IF RIndex% > RSizedir% + RSizeFile% THEN RETurn
6506         path$ = leftDir$
6508     END IF
6510 :
6512     REMark ''LONGLINE
6514     ch% = DlgWnd%(240, 60, " Unzip File ", "    Are you sure you want to unzip" & CHR$(10) & "     " & filename$ & " ?")
6516     IF ch% = 0 THEN RETurn
6518     ch% = FOPEN("scr_452x230a30x14")
6520     PAPER# ch%, 0
6522     INK# ch%, 7
6524     OUTLN# ch%, 452, 230, 30, 14
6526     BORDER# ch%, 1, 2
6528     CLS# ch%
6530     ch1% = FOPEN("scr_452x12a31x14")
6532     BORDER# ch1%, 1, 2
6534     PAPER# ch1%, 0, 2, 1
6536     CLS# ch1%
6538     PAPER# ch1%, 0
6540     INK# ch1%, 7
6542     AT# ch1%, 0, 37 - (LEN(a$) + 5) / 2
6544     PRINT# ch1%, "Unzip" & a$
6546     ch2% = FOPEN("scr_448x204a32x26")
6548     PAPER# ch2%, 0
6550     INK# ch2%, 4
6552     REMark ''LONGLINE
6554     EW ConfigDrv$ & "unzip", #ch2%; "-D" & path$ & " -o " & filename$
6556     PRINT# ch2%, "Press any key ..."
6558     path$ = INKEY$(-1)
6560     CLS# ch1%
6562     CLS# ch2%
6564     CLOSE# ch2%
6566     CLOSE# ch1%
6568     WINDOW# 0, 488, 23, 12, 233
6570     PAPER# 0, 0
6572     INK# 0, White%
6574     OUTLN# ch%, 452, 230, 30, 14
6576     CLOSE# ch%
6578 :
6580     IF crtPanel% = 7
6582         ReloadPanel 8, RIndex%
6584     ELSE
6586         ReloadPanel 7, LIndex%
6588     END IF
6590 END DEFine
6592 :
6594 :
6596 REMark ''----------------------------------------------------------
6598 DEFine PROCedure ExecXchange(path$, filename$)
6600     LOCal savedDATAD$(36), savedPROGD$(36)
6602 :
6604     savedDATAD$ = DATAD$
6606     savedPROGD$ = PROGD$
6608     DATA_USE path$
6610     PROG_USE Xchangepath$
6612     EX Xchangepath$ & Xchangeprog$; filename$
6614     DATA_USE savedDATAD$
6616     PROG_USE savedPROGD$
6618 END DEFine
6620 :
6622 :
6624 REMark ''-----------------------------------------------------------
6626 DEFine PROCedure EditFile(path$, filename$)
6628     LOCal savedDATAD$(36), savedPROGD$(36)
6630 :
6632     savedDATAD$ = DATAD$
6634     savedPROGD$ = PROGD$
6636     DATA_USE path$
6638     PROG_USE EditPath$
6640     EX EditPath$ & Editprog$; path$ & filename$
6642     DATA_USE savedDATAD$
6644     PROG_USE savedPROGD$
6646 END DEFine
6648 :
6650 :
6652 REMark ''-----------------------------------------------------------
6654 DEFine PROCedure AttachBasFileShell(filename$)
6656     TYPE_IN "merge " & "dos1_qlc_cmd_bas" & CHR$(10)
6658     REMark ''LONGLINE
6660     TYPE_IN "32604     QLC_GlobalFilename$ = '" & filename$ & "'" & CHR$(10) : REMark '' odd '
6662 END DEFine
6664 :
6666 :
6668 REMark ''-----------------------------------------------------------
6670 DEFine PROCedure LoadBasFile(filename$)
6672     LOCal x%
6674 :
6676     REMark ''QLC_GlobalFilename$ = filename$
6678     SBASIC
6680     COMMAND_LINE
6682     PAUSE 5
6684     TYPE_IN "load " & filename$ & CHR$(10)
6686     REMark ''type_in "dline 32600 to" & chr$(10)
6688 :
6690     AttachBasFileShell filename$
6692 :
6694     TYPE_IN "QLC_INIT" & CHR$(10)
6696     REMark ''type_in "SAVE_O " & filename$ & chr$(10)
6698     TYPE_IN "wtv" & CHR$(10)
6700     AT 2,0
6702     TYPE_IN "rem CMD: h/W/r/e/x/q/s/l/u" & CHR$(10)
6704     TYPE_IN "ED" & CHR$(10)
6706 END DEFine
6708 :
6710 :
6712 REMark ''-----------------------------------------------------------
6714 REMark ''QLXC IDE simplified SSB to BAS conversion
6716 REMark ''- missing support for @Lables and #include, now !!!
6718 DEFine PROCedure CompileSsb2Bas(ssb_filename$, bas_filename$)
6720   LOCal i, x$
6722 :
6724   ierr = FOP_IN(#10, ssb_filename$)
6726   oerr = FOP_OVER(#11, bas_filename$)
6728   PRINT #11, "1 rem &&SSBGEN"
6730   linenum = 10
6732   REPeat linenum
6734     INPUT #10, in$
6736     IF EOF(#10) THEN EXIT
6738     IF (CHR$(38) & CHR$(38) & "QLCGEN") INSTR in$ THEN EXIT
6740     out$ = in$
6742     IF in$ = "" THEN out$ = ":"
6744     pos = (CHR$(39) & CHR$(39) INSTR in$) : REMark ''or ("##" instr in$) or ("//" instr in$) + odd '
6746     IF pos > 0
6748       IF pos > 1
6750         FOR i = 1 TO pos : IF in$(i) <> " " THEN EXIT : NEXT i
6752         IF i < pos THEN comment$ = ": rem" : ELSE comment$ = "rem " : END IF
6754         out$ = in$(1 TO pos - 1) & comment$
6756       ELSE out$ = "rem "
6758       END IF
6760       out$ = out$ & in$(pos TO)
6762     END IF
6764     PRINT #11, linenum & " " & out$
6766     linenum = linenum + 2
6768   END REPeat
6770   CLOSE #10
6772   CLOSE #11
6774 END DEFine
6776 :
6778 :
6780 REMark ''-----------------------------------------------------------
6782 DEFine PROCedure LoadSsbFile(filename$)
6784     LOCal ssb_filename$, bas_filename$, i, x$
6786 :
6788     ssb_filename$ = filename$
6790     REMark ''LONGLINE
6792     bas_filename$ = ssb_filename$(1 TO LEN(ssb_filename$) - 4) & "_bas"
6794 :
6796     CompileSsb2Bas ssb_filename$, bas_filename$
6798     LoadBasFile bas_filename$
6800 END DEFine
6802 :
6804 :
6806 REMark ''----------------------------------------------------------
6808 DEFine PROCedure DoEdit
6810     LOCal path$, a$
6812 :
6814     IF crtPanel% = 7
6816         IF LIndex% > LSizedir% + LSizeFile% THEN RETurn
6818         a$ = GetFNam$(LeftFiles$, LIndex%)
6820         path$ = leftDir$
6822     ELSE
6824         IF RIndex% > RSizedir% + RSizeFile% THEN RETurn
6826         a$ = GetFNam$(RightFiles$, RIndex%)
6828         path$ = rightDir$
6830     END IF
6832 :
6834     IF IsDir%(path$ & a$) = 1 THEN RETurn
6836     IF IsQuillDoc%(path$ & a$) = 1
6838         IF Xchangeprog$ <> ""
6840             ExecXchange path$, path$ & a$
6842             RETurn
6844         END IF
6846     ELSE
6848         EditFile path$, a$
6850     END IF
6852 END DEFine
6854 :
6856 :
6858 REMark ''-----------------------------------------------------------
6860 DEFine PROCedure DoLrespr(filename$)
6862     LOCal x%
6864 :
6866     REMark ''LONGLINE
6868     x% = DlgWnd%(240, 60, " lrespr File ", "    Are you sure you want to lrespr" & CHR$(10) & "     " & filename$ & " ?")
6870     IF x% = 0 THEN RETurn
6872     COMMAND_LINE
6874     PAUSE 5
6876     TYPE_IN "lrespr " & filename$ & CHR$(10)
6878 END DEFine
6880 :
6882 :
6884 REMark ''----------------------------------------------------------
6886 DEFine FuNction IsAbacusDoc%(a$)
6888     LOCal ch%, q$, i%, k%
6890 :
6892     ch% = FOPEN(a$)
6894     IF ch% <= 0 THEN RETurn 0
6896     q$ = ""
6898     FOR i% = 1 TO 4
6900         BGET# ch%, k%
6902         q$ = q$ & CHR$(k%)
6904         NEXT i%
6906     END FOR i%
6908     CLOSE# ch%
6910     IF q$ = "ABM1" THEN RETurn 1 : ELSE RETurn 0
6912 END DEFine
6914 :
6916 :
6918 REMark ''-----------------------------------------------------------
6920 DEFine FuNction IsArchiveDoc%(a$)
6922     LOCal ch%, q$, i%, k%
6924 :
6926     ch% = FOPEN(a$)
6928     IF ch% <= 0 THEN RETurn 0
6930     q$ = ""
6932     BGET# ch%\1, k%
6934     FOR i% = 1 TO 8
6936         BGET# ch%, k%
6938         q$ = q$ & CHR$(k%)
6940         NEXT i%
6942     END FOR i%
6944     CLOSE# ch%
6946     IF q$ = "vrm1dbf0" THEN RETurn 1 : ELSE RETurn 0
6948 END DEFine
6950 :
6952 :
6954 REMark ''-----------------------------------------------------------
6956 DEFine PROCedure ReloadPanel(panel%, Index%)
6958     LOCal page%, x%
6960 :
6962     IF panel% = 7
6964         DIM LeftFiles$(MaxFiles%, _fMax%)
6966         LoadDir leftDir$, LeftFiles$, 7, LSizedir%, LSizeFile%
6968         IF LEN(leftDir$) = 5
6970             LMinPos% = 1
6972         ELSE
6974             LMinPos% = 0
6976         END IF
6978         IF Index% < LMinPos%
6980             Index% = LMinPos%
6982         END IF
6984         IF Index% > LSizedir% + LSizeFile%
6986             Index% = LMinPos%
6988         END IF
6990         LIndex% = Index%
6992         x% = Index% + (LMinPos% = 0)
6994         page% = x% DIV rowno%
6996         IF x% MOD rowno% > 0 THEN page% = page% + 1
6998         LStartPos% = (page% - 1) * rowno% + LMinPos%
7000         ListFiles LeftFiles$, LStartPos%, LIndex%, 7
7002     ELSE
7004         DIM RightFiles$(MaxFiles%, _fMax%)
7006         LoadDir rightDir$, RightFiles$, 8, RSizedir%, RSizeFile%
7008         IF LEN(rightDir$) = 5
7010             RMinPos% = 1
7012         ELSE
7014             RMinPos% = 0
7016         END IF
7018         IF Index% < RMinPos% THEN Index% = RMinPos%
7020         IF Index% > RSizedir% + RSizeFile%
7022             Index% = RMinPos%
7024         END IF
7026         RIndex% = Index%
7028         x% = Index% + (RMinPos% = 0)
7030         page% = x% DIV rowno%
7032         IF x% MOD rowno% > 0 THEN page% = page% + 1
7034         RStartPos% = (page% - 1) * rowno% + RMinPos%
7036         ListFiles RightFiles$, RStartPos%, RIndex%, 8
7038     END IF
7040 END DEFine
7042 :
7044 :
7046 REMark ''-----------------------------------------------------------
7048 DEFine PROCedure SelectAll
7050     LOCal i%
7052 :
7054     IF crtPanel% = 7
7056         FOR i% = 1 TO LSizedir% + LSizeFile%
7058             REMark ''LONGLINE
7060             IF GetFFlg%(LeftFiles$, i%) < 2 THEN PutFFlg LeftFiles$, i%, GetFFlg%(LeftFiles$, i%) ^^ 2
7062         END FOR i%
7064         ListFiles LeftFiles$, LStartPos%, LIndex%, 7
7066     ELSE
7068         FOR i% = 1 TO RSizedir% + RSizeFile%
7070             REMark ''LONGLINE
7072             IF GetFFlg%(RightFiles$, i%) < 2 THEN PutFFlg RightFiles$, i%, GetFFlg%(RightFiles$, i%) ^^ 2
7074         END FOR i%
7076         ListFiles RightFiles$, RStartPos%, RIndex%, 8
7078     END IF
7080 END DEFine
7082 :
7084 :
7086 REMark ''-----------------------------------------------------------
7088 DEFine PROCedure UnSelectAll
7090     LOCal i%
7092 :
7094     IF crtPanel% = 7
7096         FOR i% = 1 TO LSizedir% + LSizeFile%
7098             REMark ''LONGLINE
7100             IF GetFFlg%(LeftFiles$, i%) > 1 THEN PutFFlg LeftFiles$, i%, GetFFlg%(LeftFiles$, i%) ^^ 2
7102         END FOR i%
7104         ListFiles LeftFiles$, LStartPos%, LIndex%, 7
7106     ELSE
7108         FOR i% = 1 TO RSizedir% + RSizeFile%
7110             REMark ''LONGLINE
7112             IF GetFFlg%(RightFiles$, i%) > 1 THEN PutFFlg RightFiles$, i%, GetFFlg%(RightFiles$, i%) ^^ 2
7114         END FOR i%
7116         ListFiles RightFiles$, RStartPos%, RIndex%, 8
7118     END IF
7120 END DEFine
7122 :
7124 :
7126 REMark ''-----------------------------------------------------------
7128 REMark ''On QPC2 the char width gets reset so we have to set it again
7130 DEFine PROCedure Set78CharSet
7132 :
7134     IF mainFountBase > 0
7136         IF ClassicFont% = 0
7138             CHAR_USE# leftPanelWin%, mainFountBase, 0
7140             CHAR_INC# leftPanelWin%, 5, 10
7142             CHAR_USE# rightPanelWin%, mainFountBase, 0
7144             CHAR_INC# rightPanelWin%, 5, 10
7146         END IF
7148     END IF
7150 END DEFine
7152 :
7154 :
7156 REMark ''----------------------------------------------------------
7158 DEFine FuNction TestFount%(fountBase)
7160     LOCal fountMask%, fountMax%, char%, row%
7162 :
7164     fountMask% = 3 : REMark ''*** ------XX
7166     fountMax% = PEEK(fountBase + 1)
7168     FOR char% = 0 TO fountMax%
7170     FOR row% = 0 TO 8
7172         REMark ''*** appears to be a FAT fount
7174         REMark ''LONGLINE
7176         IF PEEK(fountBase + 2 + char% * 9 + row%) && fountMask% THEN RETurn 2
7178     END FOR row%
7180     END FOR char%
7182 :
7184     RETurn 1 : REMark ''*** Does not appear to be a FAT fount
7186 :
7188 END DEFine
7190 :
7192 :
7194 REMark ''----------------------------------------------------------
7196 REFERENCE fList$(0, 0)
7198 DEFine FuNction GetFNam$(fList$, fIndex%)
7200     REMark ''LONGLINE
7202     RETurn fList$(fIndex%, 3 TO 2 + STRING%(fList$(fIndex%, 1 TO 2)))
7204 END DEFine
7206 :
7208 :
7210 REMark ''----------------------------------------------------------
7212 REFERENCE fList$(0, 0)
7214 DEFine FuNction GetFLen(fList$, fIndex%)
7216     RETurn LONGINTEGER(fList$(fIndex%, _fLen% TO _fTyp% - 1))
7218 END DEFine
7220 :
7222 :
7224 REMark ''-----------------------------------------------------------
7226 REFERENCE fList$(0, 0)
7228 DEFine FuNction GetFTyp%(fList$)
7230     RETurn STRING%(fList$(fIndex%, _fTyp% TO _fDat% - 1))
7232 END DEFine
7234 :
7236 :
7238 REMark ''-----------------------------------------------------------
7240 REFERENCE fList$(0, 0)
7242 DEFine FuNction GetFDat(fList$, fIndex%)
7244     RETurn LONGINTEGER(fList$(fIndex%, _fDat% TO _fPar% - 1))
7246 END DEFine
7248 :
7250 :
7252 REMark ''-----------------------------------------------------------
7254 REFERENCE fList$(0, 0)
7256 DEFine FuNction GetFPar%(fList$, fIndex%)
7258     RETurn STRING%(fList$(fIndex%, _fPar% TO _fFlg% - 1))
7260 END DEFine
7262 :
7264 :
7266 REMark ''-----------------------------------------------------------
7268 REFERENCE fList$(0, 0)
7270 DEFine FuNction GetFFlg%(fList$, fIndex%)
7272     RETurn STRING%(fList$(fIndex%, _fFlg% TO _fMax%))
7274 END DEFine
7276 :
7278 :
7280 REMark ''-----------------------------------------------------------
7282 REFERENCE fList$(0, 0)
7284 DEFine PROCedure PutFNam(fList$, fIndex%, newVal$)
7286     LOCal nVLen%
7288 :
7290     nVLen% = LEN(newVal$)
7292     IF nVLen% > maxFNLen% THEN nVLen% = maxFNLen%
7294     REMark ''LONGLINE
7296     fList$(fIndex%, 1 TO 2 + nVLen%) = STRING$(newVal$(1 TO nVLen%))
7298 END DEFine
7300 :
7302 :
7304 REMark ''-----------------------------------------------------------
7306 REFERENCE fList$(0, 0)
7308 DEFine PROCedure PutFLen(fList$, fIndex%, newVal)
7310     fList$(fIndex%, _fLen% TO _fTyp% - 1) = LONGINTEGER$(newVal)
7312 END DEFine
7314 :
7316 :
7318 REMark ''-----------------------------------------------------------
7320 REFERENCE fList$(0, 0)
7322 DEFine PROCedure PutFTyp(fList$, fIndex%, newVal%)
7324     fList$(fIndex%, _fTyp% TO _fDat% - 1) = INTEGER$(newVal%)
7326 END DEFine
7328 :
7330 :
7332 REMark ''-----------------------------------------------------------
7334 REFERENCE fList$(0, 0)
7336 DEFine PROCedure PutFDat(fList$, fIndex%, newVal)
7338     fList$(fIndex%, _fDat% TO _fPar% - 1) = LONGINTEGER$(newVal)
7340 END DEFine
7342 :
7344 :
7346 REMark ''-----------------------------------------------------------
7348 REFERENCE fList$(0, 0)
7350 DEFine PROCedure PutFPar(fList$, fIndex%, newVal%)
7352     fList$(fIndex%, _fPar% TO _fFlg% - 1) = INTEGER$(newVal%)
7354 END DEFine
7356 :
7358 :
7360 REMark ''-----------------------------------------------------------
7362 REFERENCE fList$(0, 0)
7364 DEFine PROCedure PutFFlg(fList$, fIndex%, newVal%)
7366     fList$(fIndex%, _fFlg% TO _fMax%) = INTEGER$(newVal%)
7368 END DEFine
7370 :
7372 :
7374 REMark ''-----------------------------------------------------------
7376 REFERENCE fList$(0, 0), fListDest$(0, 0)
7378 DEFine PROCedure CopyRec(fList$, fIndex%, fListDest$, fDestIndex%)
7380     fListDest$(fDestIndex%, 1 TO _fMax%) = fList$(fIndex%, 1 TO _fMax%)
7382 END DEFine
7384 :
7386 :
7388 REMark ''-----------------------------------------------------------
7390 DEFine FuNction isBasicRunning
7392     IF BASIC_B%(111) <> 0
7394         RETurn 0
7396     ELSE
7398         REMark ''FIXME mixworx weird if sequences
7400         REMark ''break - Ctrl-Space pressed
7402         IF BASIC_B%(143) = 0 : RETurn 0
7404         REMark ''stop occurred
7406         IF BASIC_W%(104) = BASIC_W%(146) : RETurn 0
7408         REMark ''Program is running
7410         RETurn 1
7412     END IF
7414 END DEFine
7416 :
7418 :
7420 REMark ''-----------------------------------------------------------
7422 DEFine FuNction isBasicProgramLoaded
7424     RETurn BASIC_W%(BASIC_L(16))
7426 END DEFine
7428 :
7430 :
7432 REMark ''-----------------------------------------------------------
7434 REFERENCE fList$(0, 0), r_StartPos%, r_Index%
7436 DEFine PROCedure MoveTop(fList$, r_StartPos%, r_Index%, ch%)
7438     LOCal top%, x%, size%
7440 :
7442     IF ch% = 7
7444         r_StartPos% = LMinPos%
7446     ELSE
7448         r_StartPos% = RMinPos%
7450     END IF
7452     r_Index% = r_StartPos%
7454     ListFiles fList$, r_StartPos%, r_Index%, ch%
7456 END DEFine
7458 :
7460 :
7462 REMark ''----------------------------------------------------------
7464 REFERENCE fList$(0, 0), r_StartPos%, r_Index%
7466 DEFine PROCedure MoveLast(fList$, r_StartPos%, r_Index%, ch%)
7468     LOCal top%
7470 :
7472     IF ch% = 7
7474         top% = LMinPos%
7476         r_Index% = LSizeFile% + LSizedir%
7478     ELSE
7480         top% = RMinPos%
7482         r_Index% = RSizeFile% + RSizedir%
7484     END IF
7486     r_StartPos% = r_Index% - 19
7488     IF r_StartPos% < top% THEN r_StartPos% = top%
7490     ListFiles fList$, r_StartPos%, r_Index%, ch%
7492 END DEFine
7494 :
7496 :
7498 REMark ''-----------------------------------------------------------
7500 DEFine PROCedure LRUNBasic
7502     LOCal i%, a$, path$, ext$
7504 :
7506     IF crtPanel% = 7
7508         IF LIndex%>LSizedir% + LSizeFile% THEN RETurn
7510         a$ = GetFNam$(LeftFiles$, LIndex%)
7512         path$ = leftDir$
7514     ELSE
7516         IF RIndex% > RSizedir% + RSizeFile% THEN RETurn
7518         a$ = GetFNam$(RightFiles$, RIndex%)
7520         path$ = rightDir$
7522     END IF
7524     IF a$ == ".." OR IsDir% = 1 THEN RETurn
7526     REMark ''now get file extension
7528     x% = LEN(a$)
7530     FOR i% = 0 TO x% - 1
7532         IF a$(x% - i%) == "_" THEN EXIT i%
7534         NEXT i%
7536     END FOR i%
7538     IF i% > 0
7540         ext$ = a$(x% - i% TO x%)
7542     ELSE
7544         ext$ = ""
7546     END IF
7548     ext$ = LOWER$(ext$)
7550     IF ext$ <> "_bas" AND a$ <> "boot" THEN RETurn
7552     IF isBasicRunning = 1
7554         REMark ''LONGLINE
7556         MessageWnd 200, 60, 2, CHR$(10) & "        BASIC is running" & CHR$(10) & "       Cannot run _bas now!"
7558         RETurn
7560     END IF
7562     IF (isBasicProgramLoaded > 0) AND (isBasicProgramEdited = 1)
7564         REMark ''LONGLINE
7566         i% = DlgWnd%(240, 60, " Basic program loaded ", "       A Basic program is loaded" & CHR$(10) & "         Loose any changes made?")
7568         IF i% = 0 THEN RETurn
7570     END IF
7572     COMMAND_LINE
7574     PAUSE 5
7576     TYPE_IN CHR$(27) & CHR$(27) & CHR$(27)
7578     PAUSE 5
7580     TYPE_IN "LRUN " & path$ & a$ & CHR$(10)
7582 END DEFine
7584 :
7586 :
7588 REMark ''-----------------------------------------------------------
7590 DEFine PROCedure SetPalletteQL
7592     REMark ''LONGLINE
7594     PALETTE_QL 0, 0, 0, 255*256*256, 255*256*256, 255*256, 255*256, 255*256*256+255*256+255, 255*256*256+255*256+255
7596 END DEFine
7598 :
7600 :
7602 REMark ''-----------------------------------------------------------
7604 DEFine FuNction isBasicProgramEdited
7606     IF BASIC_B%(142) = 255
7608         RETurn 1
7610     ELSE
7612         RETurn 0
7614     END IF
7616 END DEFine
7618 :
7620 :
7622 REMark ''-----------------------------------------------------------
7624 DEFine FuNction CopyFullDir%(name$, source$, dest$, panel%, UpdateWnd%, CheckNoQ%, UpdateList%)
7626     LOCal x%, ch%, loop, d$, fp, newname$, newsource$
7628     LOCal newdest$, totrim
7630 :
7632     IF DirExists%(dest$ & name$) = 0
7634         REMark ''LONGLINE
7636         x% = Create1Dir%(name$, dest$ & name$, panel%, 0, CheckNoQ%, UpdateList%)
7638         IF x% = 0 THEN RETurn 0
7640     END IF
7642     PRINT# 0, "Copy " & source$ & name$ & " to " & dest$ & name$
7644     WCOPY source$ & name$ TO dest$ & name$
7646 :
7648     ch% = FOP_DIR(source$ & name$) : REMark ''open channel to directory
7650 :
7652     IF ch% < 0 THEN RETurn : REMark ''unable to open directory
7654 :
7656     fp = 14 : REMark ''file position in directory for filename
7658 :
7660     newsource$ = source$ & name$
7662     IF newsource$(LEN(newsource$)) <> "_"
7664         newsource$ = newsource$ & "_"
7666     END IF
7668     newdest$ = dest$ & name$
7670     IF newdest$(LEN(newdest$)) <> "_"
7672         newdest$ = newdest$ & "_"
7674     END IF
7676 :
7678     REPeat loop
7680         BGET# ch%\fp
7682         REMark ''FIXME mixworx weird if sequence
7684         IF EOF(#ch%) THEN CLOSE #ch% : EXIT loop
7686         GET# ch%, d$ : REMark ''get a directory entry name
7688         IF LEN(d$) > 0
7690             REMark ''a directory length of 0 may be a deleted file
7692             BGET# ch%\fp - 9 : REMark ''file type byte
7694             IF CODE(INKEY$(#ch%)) = 255
7696                 REMark ''this is a subdirectory
7698                 REMark ''so we need to copy this
7700 :
7702                 REMark ''Extract file name and check length
7704                 totrim = LEN(newsource$) - 4
7706                 newname$ = d$(totrim TO)
7708                 IF LEN(newdest$ & newname$) > 36
7710                     INK# 0, 2
7712                     REMark ''LONGLINE
7714                     PRINT# 0, "Directory " & newdest$ & newname$ & " not created  Name too long"
7716                     INK# 0, White%
7718                 ELSE
7720                     REMark ''LONGLINE
7722                     x% = CopyFullDir%(newname$, newsource$, newdest$, panel%, 0, 0, 0)
7724                 END IF
7726             END IF
7728         END IF
7730         fp = fp + 64
7732     END REPeat loop
7734     RETurn 1
7736 END DEFine
7738 :
7740 :
7742 REMark ''-----------------------------------------------------------
7744 DEFine PROCedure CopySingleDir(name$, source$, dest$, panel%)
7746     LOCal ch%, ch1%, i%, x%, a$, Index%,page%
7748     LOCal id%, left%,windef$, hgt%, wid%
7750 :
7752 :
7754     IF panelWinWid% * 2 > 602
7756         wid% = 600
7758     ELSE
7760         wid% = 400
7762     END IF
7764     hgt% = panelWinHeight% * 8 DIV 10
7766     left% = (maxWinWid% - wid%) DIV 2
7768     windef$ = "scr_" & wid% & "x" & hgt% & "a" & left% & "x50"
7770     ch% = FOPEN(windef$)
7772     PAPER# ch%, 0
7774     INK# ch%, White%
7776     OUTLN# ch%, wid%, hgt%, left%, 50
7778     BORDER# ch%, 1, 2
7780     CLS# ch%
7782     left% = left% + 1
7784     windef$ = "scr_" & (wid% - 2) & "x12a" & left% & "x51"
7786     ch1% = FOPEN(windef$)
7788     BORDER# ch1%, 1 , 2
7790     PAPER# ch1%, 0, 2, 1
7792     CLS# ch1%
7794     PAPER# ch1%, 0
7796     INK# ch1%, White%
7798     CURSOR# ch1%, (wid% - 90) DIV 2, 0
7800     PRINT# ch1%, " Copy Directory "
7802     WINDOW# 0, wid% - 4, hgt% - 16, left% + 1, 63
7804     PAPER# 0, 0
7806     INK# 0, White%
7808     CLS# 0
7810     REMark ''LONGLINE
7812     PRINT# 0, "Copy Directory " & source$ & name$ & " to " & dest$
7814     res% = CopyFullDir%(name$, source$, dest$, panel%, 0, 1, 0)
7816     INK# 0, Green%
7818     REMark ''LONGLINE
7820     PRINT# 0, "Copy process ended - press any key to close window"
7822     INK# 0, White%
7824     x% = KEYROW(0)
7826     a$ = INKEY$(-1)
7828     WINDOW# 0, 448, 12, 32, 231:
7830     CLOSE# ch1%
7832     OUTLN# ch%, wid%, hgt%, left% - 1, 50
7834     CLOSE# ch%
7836 :
7838     REMark ''if copy OK then Add the dir name to the list
7840     REMark ''in the destination panel and refresh screen
7842     IF res% = 1
7844         IF panel% = 8
7846             res% = Find%(name$, id%, RightFiles$, 1, RSizedir%)
7848             IF res% = 0
7850                 REMark ''LONGLINE
7852                 res% = Insert%(name$, id%, RightFiles$, 1, RSizedir%, RSizeFile%, "0")
7854                 RIndex% = id%
7856                 id% = id% + (RMinPos% = 0)
7858                 page% = id% DIV rowno%
7860                 IF id% MOD rowno% > 0
7862                     page% = page% + 1
7864                 END IF
7866                 RStartPos% = (page% - 1) * rowno% + RMinPos%
7868                 ListFiles RightFiles$, RStartPos%, RIndex%, 8
7870             END IF
7872         ELSE
7874             res% = Find%(name$, id%, LeftFiles$, 1, LSizedir%)
7876             IF res% = 0
7878                 REMark ''LONGLINE
7880                 res% = Insert%(name$, id%, LeftFiles$, 1, LSizedir%, LSizeFile%, "0")
7882                 LIndex% = id%
7884                 id% = id% + (LMinPos% = 0)
7886                 page% = id% DIV rowno%
7888                 IF id% MOD rowno% > 0
7890                     page% = page% + 1
7892                 END IF
7894                 LStartPos% = (page% - 1) * rowno% + LMinPos%
7896                 ListFiles LeftFiles$, LStartPos%, LIndex%, 7
7898             END IF
7900         END IF
7902     END IF
7904 END DEFine
7906 :
7908 :
7910 REMark ''----------------------------------------------------------
7912 DEFine FuNction DeleteDirectory(source$, name$)
7914     LOCal ch%, loop, d$, newsource$, newname$, fp, totrim, x%
7916 :
7918     IF name$(LEN(name$)) <> "_" THEN name$ = name$ & "_"
7920     PRINT# 0, "Deleting directory " & source$ & name$ & "..."
7922     WDEL source$ & name$
7924     ch% = FOP_DIR(source$ & name$) : REMark ''open channel to directory
7926     IF ch% < 0 THEN RETurn : REMark ''unable to open directory
7928     fp = 14 : REMark ''file position in directory for filename
7930     newsource$ = source$ & name$
7932     IF newsource$(LEN(newsource$)) <> "_"
7934         newsource$ = newsource$ & "_"
7936     END IF
7938     REPeat loop
7940         BGET# ch%\fp
7942         REMark ''FIXME mixworx weird if sequence
7944         IF EOF(#ch%) THEN CLOSE# ch% : EXIT loop
7946         GET# ch%, d$ : REMark ''get a directory entry name
7948         IF LEN(d$) > 0
7950             REMark ''a directory length of 0 may be a deleted file
7952             BGET# ch%\fp - 9 : REMark ''file type byte
7954             IF CODE(INKEY$(#ch%)) = 255
7956                 REMark ''this is a subdirectory
7958                 REMark ''so we need to delete this
7960 :
7962                 REMark ''Extract file name and check length
7964                 totrim = LEN(newsource$) - 4
7966                 newname$ = d$(totrimto)
7968                 x% = DeleteDirectory(newsource$, newname$)
7970             END IF
7972         END IF
7974         fp = fp + 64
7976     END REPeat loop
7978 :
7980     REMark ''Now check that directory is empty
7982     IF isDirEmpty(source$ & name$) = 1
7984         DELETE source$ & name$
7986         RETurn 1
7988     ELSE
7990         RETurn 0
7992     END IF
7994 END DEFine
7996 :
7998 :
8000 REMark ''----------------------------------------------------------
8002 DEFine FuNction isDirEmpty(DirName$)
8004     LOCal ch%, fp, d$, loop, res%
8006 :
8008     ch% = FOP_DIR(DirName$) : REMark ''open channel to directory
8010     IF ch% < 0 THEN RETurn 0: REMark ''unable to open directory
8012     res% = 1
8014     fp = 14 : REMark ''file position in directory for filename
8016     REPeat loop
8018         BGET# ch%\fp
8020         REMark ''FIXME mixworx weird if sequences
8022         IF EOF(#ch%) THEN : EXIT loop
8024         GET# ch%, d$ : REMark ''get a directory entry name
8026         IF LEN(d$) > 0 THEN res% = 0: EXIT loop
8028         REMark ''if file name >0 then we found a file
8030         REMark ''and we set result to 1
8032         fp = fp + 64
8034     END REPeat loop
8036     CLOSE# ch%
8038     RETurn res%
8040 END DEFine
8042 :
8044 :
8046 REMark ''----------------------------------------------------------
8048 DEFine PROCedure CompareDirs
8050     LOCal i%, res%
8052 :
8054     REMark ''Unselect all left files
8056     FOR i% = 1 TO LSizedir% + LSizeFile%
8058         IF GetFFlg%(LeftFiles$, i%) > 1
8060             REMark ''LONGLINE
8062             PutFFlg LeftFiles$, i%, GetFFlg%(LeftFiles$, i%) ^^ 2
8064         END IF
8066     END FOR i%
8068 :
8070     REMark ''Select all right files
8072     FOR i% = 1 TO RSizedir% + RSizeFile%
8074         IF GetFFlg%(RightFiles$, i%) < 2
8076             REMark ''LONGLINE
8078             PutFFlg RightFiles$, i%, GetFFlg%(RightFiles$, i%) ^^ 2
8080         END IF
8082     END FOR i%
8084 :
8086     REMark ''Parse left directory list and compare it to right
8088     FOR i% = 1 TO LSizedir%
8090         REMark ''LONGLINE
8092         res% = Find%(GetFNam$(LeftFiles$, i%), id%, RightFiles$, 1, RSizedir%)
8094         IF res% = 0
8096             REMark ''LONGLINE
8098             PutFFlg LeftFiles$, i%, GetFFlg%(LeftFiles$, i%) ^^ 2
8100         ELSE
8102             REMark ''LONGLINE
8104             PutFFlg RightFiles$, id%, GetFFlg%(RightFiles$, id%) ^^ 2
8106         END IF
8108         NEXT i%
8110     END FOR i%
8112 :
8114     REMark ''Parse left file list and compare it to right
8116     FOR i% = LSizedir% + 1 TO LSizedir% + LSizeFile%
8118         REMark ''LONGLINE
8120         res% = Find%(GetFNam$(LeftFiles$, i%), id%, RightFiles$, RSizedir% + 1, RSizedir% + RSizeFile%)
8122         IF res% = 0
8124             PutFFlg LeftFiles$,i%, GetFFlg%(LeftFiles$,i%) ^^2
8126         ELSE
8128             REMark ''LONGLINE
8130             IF GetFLen(LeftFiles$, i%) = GetFLen(RightFiles$, id%)
8132                 REMark ''LONGLINE
8134                 PutFFlg RightFiles$, id%, GetFFlg%(RightFiles$, id%) ^^ 2
8136             ELSE
8138                 REMark ''LONGLINE
8140                 PutFFlg LeftFiles$, i%, GetFFlg%(LeftFiles$, i%) ^^ 2
8142             END IF
8144         END IF
8146         NEXT i%
8148     END FOR i%
8150 :
8152     REMark ''refresh screen
8154     ListFiles LeftFiles$, LStartPos%, LIndex%, 7
8156     ListFiles RightFiles$, RStartPos%, RIndex%, 8
8158 END DEFine
8160 :
8162 :
8164 REMark ''----------------------------------------------------------
8166 DEFine PROCedure InvertSelection
8168     LOCal i%
8170 :
8172     IF crtPanel% = 7
8174         FOR i% = 1 TO LSizedir% + LSizeFile%
8176             REMark ''LONGLINE
8178             PutFFlg LeftFiles$, i%, GetFFlg%(LeftFiles$, i%) ^^ 2
8180         END FOR i%
8182         ListFiles LeftFiles$, LStartPos%, LIndex%, 7
8184     ELSE
8186         FOR i% = 1 TO RSizedir% + RSizeFile%
8188             REMark ''LONGLINE
8190             PutFFlg RightFiles$, i%, GetFFlg%(RightFiles$, i%) ^^ 2
8192         END FOR i%
8194         ListFiles RightFiles$, RStartPos%, RIndex%, 8
8196     END IF
8198 END DEFine
8200 :
8202 :
8204 :
8206 :
32600 REMark &&QLCGEN ShellCommands
32602 DEFine PROCedure QLC_INIT
32604   QLC_GlobalFilename$ = 'dos1_QLC_qlc20x_bas'
32616   XX=RESPR(1024) : LBYTES "dos1_tk_MORE_CODE", XX : CALL XX
32618   XX=RESPR(1538) : LBYTES "dos1_qlc_QLC_CODE", XX : CALL XX
32620   LRESPR "dos1_tk_TURBO_SMS_CODE"
32622 END DEFine
32624 :
32626 DEFine PROCedure r
32628   RUN
32630 END DEFine
32632 DEFine PROCedure e
32634   WTV
32636   PAPER #2,0 : INK #2,4
32638 END DEFine
32640 DEFine PROCedure x
32642   s : QUIT
32644 END DEFine
32646 DEFine PROCedure q
32648   s : QUIT
32650 END DEFine
32652 DEFine PROCedure s
32653   TYPE_IN "1 REMark &&SSBGEN &&SAVE" & CHR$(10)
32654   SAVE QLC_GlobalFilename$
32656   PRINT #2, QLC_GlobalFilename$ & " SAVED"
32658 END DEFine
32660 DEFine PROCedure l
32662   LOAD QLC_GlobalFilename$
32664   PRINT #2, QLC_GlobalFilename$ & " LOADED"
32666 END DEFine
32668 DEFine PROCedure w
32670   WMOV
32672 END DEFine
32674 DEFine PROCedure u
32676   REMark DLINE 32600 TO
32678   TYPE_IN "MERGE dos1_qlc_cmd_bas" & CHR$(10)
32680 END DEFine
32682 DEFine PROCedure h
32684   PRINT #0, "CMD: h/W/n/r/e/x/q/s/l/u"
32686 END DEFine
32688 DEFine PROCedure n(i)
32690   IF i = 0 THEN i = 1
32692   TYPE_IN "RENUM 10 TO 32599; 1000, " & i & CHR$(10)
32694 END DEFine
32696 DEFine PROCedure dbginit
32698   OPEN #99, "scr_"
32700   WINDOW #99, 120,16,0,0 : PAPER #99,0 : INK #99,7
32702 END DEFine
32704 DEFine PROCedure dbg(s$)
32706   PAPER #99,7 : INK #99,2 : PRINT #99, s$
32708 END DEFine
32710 DEFine PROCedure dbgstop
32712   STOP
32714 END DEFine
